/* sudoku-game.c generated by valac 0.56.17, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define SUDOKU_GAME_TYPE_STACK_ITEM (sudoku_game_stack_item_get_type ())
#define SUDOKU_GAME_STACK_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SUDOKU_GAME_TYPE_STACK_ITEM, SudokuGamestack_item))
#define SUDOKU_GAME_STACK_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SUDOKU_GAME_TYPE_STACK_ITEM, SudokuGamestack_itemClass))
#define SUDOKU_GAME_IS_STACK_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SUDOKU_GAME_TYPE_STACK_ITEM))
#define SUDOKU_GAME_IS_STACK_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SUDOKU_GAME_TYPE_STACK_ITEM))
#define SUDOKU_GAME_STACK_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SUDOKU_GAME_TYPE_STACK_ITEM, SudokuGamestack_itemClass))

typedef struct _SudokuGamestack_item SudokuGamestack_item;
typedef struct _SudokuGamestack_itemClass SudokuGamestack_itemClass;
enum  {
	SUDOKU_GAME_0_PROPERTY,
	SUDOKU_GAME_BOARD_PROPERTY,
	SUDOKU_GAME_MODE_PROPERTY,
	SUDOKU_GAME_PAUSED_PROPERTY,
	SUDOKU_GAME_NUM_PROPERTIES
};
static GParamSpec* sudoku_game_properties[SUDOKU_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
typedef struct _SudokuGamestack_itemPrivate SudokuGamestack_itemPrivate;

#define SUDOKU_GAME_TYPE_EARMARK_CHANGE (sudoku_game_earmark_change_get_type ())
typedef struct _SudokuGameearmark_change SudokuGameearmark_change;

#define SUDOKU_GAME_TYPE_VALUE_CHANGE (sudoku_game_value_change_get_type ())
typedef struct _SudokuGamevalue_change SudokuGamevalue_change;
#define _sudoku_game_stack_item_unref0(var) ((var == NULL) ? NULL : (var = (sudoku_game_stack_item_unref (var), NULL)))
#define _sudoku_game_value_change_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_value_change_free (var), NULL)))
#define _sudoku_game_earmark_change_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_earmark_change_free (var), NULL)))
typedef struct _SudokuGameParamSpecstack_item SudokuGameParamSpecstack_item;
enum  {
	SUDOKU_GAME_TICK_SIGNAL,
	SUDOKU_GAME_PAUSED_CHANGED_SIGNAL,
	SUDOKU_GAME_ACTION_COMPLETED_SIGNAL,
	SUDOKU_GAME_NUM_SIGNALS
};
static guint sudoku_game_signals[SUDOKU_GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuGamePrivate {
	SudokuBoard* _board;
	GameMode _mode;
	GTimer* timer;
	guint clock_timeout;
	gboolean _paused;
	GeeArrayList* stack;
	gint stack_head_index;
};

struct _SudokuGameearmark_change {
	gint row;
	gint col;
	gint number;
	gboolean enabled;
};

struct _SudokuGamevalue_change {
	gint row;
	gint col;
	gint old_val;
	gint new_val;
};

struct _SudokuGamestack_item {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SudokuGamestack_itemPrivate * priv;
	GeeArrayList* earmarks;
	GeeArrayList* values;
	StackAction action;
};

struct _SudokuGamestack_itemClass {
	GTypeClass parent_class;
	void (*finalize) (SudokuGamestack_item *self);
};

struct _SudokuGameParamSpecstack_item {
	GParamSpec parent_instance;
};

static gint SudokuGame_private_offset;
static gpointer sudoku_game_parent_class = NULL;
static gpointer sudoku_game_stack_item_parent_class = NULL;

static gpointer sudoku_game_stack_item_ref (gpointer instance);
static void sudoku_game_stack_item_unref (gpointer instance);
static GParamSpec* sudoku_game_param_spec_stack_item (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags) G_GNUC_UNUSED ;
static void sudoku_game_value_set_stack_item (GValue* value,
                                       gpointer v_object) G_GNUC_UNUSED ;
static void sudoku_game_value_take_stack_item (GValue* value,
                                        gpointer v_object) G_GNUC_UNUSED ;
static gpointer sudoku_game_value_get_stack_item (const GValue* value) G_GNUC_UNUSED ;
static GType sudoku_game_stack_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void sudoku_game_set_board (SudokuGame* self,
                            SudokuBoard* value);
static SudokuGamestack_item* sudoku_game_stack_item_new (StackAction _action);
static SudokuGamestack_item* sudoku_game_stack_item_construct (GType object_type,
                                                        StackAction _action);
static void sudoku_game_add_to_stack (SudokuGame* self,
                               SudokuGamestack_item* item);
static void sudoku_game_add_earmark_step (SudokuGame* self,
                                   SudokuGamestack_item* item,
                                   gint row,
                                   gint col,
                                   gint number,
                                   gboolean enabled);
static GType sudoku_game_earmark_change_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SudokuGameearmark_change* sudoku_game_earmark_change_dup (const SudokuGameearmark_change* self);
static void sudoku_game_earmark_change_free (SudokuGameearmark_change* self);
static GType sudoku_game_value_change_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SudokuGamevalue_change* sudoku_game_value_change_dup (const SudokuGamevalue_change* self);
static void sudoku_game_value_change_free (SudokuGamevalue_change* self);
static void sudoku_game_add_disable_earmarks_step (SudokuGame* self,
                                            SudokuGamestack_item* item,
                                            gint row,
                                            gint col);
static void sudoku_game_add_value_step (SudokuGame* self,
                                 SudokuGamestack_item* item,
                                 gint row,
                                 gint col,
                                 gint old_val,
                                 gint val);
static gboolean sudoku_game_timeout_cb (SudokuGame* self);
static gboolean _sudoku_game_timeout_cb_gsource_func (gpointer self);
static void sudoku_game_stack_item_finalize (SudokuGamestack_item * obj);
static GType sudoku_game_stack_item_get_type_once (void);
static void sudoku_game_finalize (GObject * obj);
static GType sudoku_game_get_type_once (void);
static void _vala_sudoku_game_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_game_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_game_get_instance_private (SudokuGame* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuGame_private_offset);
}

gboolean
sudoku_game_is_undostack_null (SudokuGame* self)
{
	gboolean result;
#line 78 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../lib/sudoku-game.vala"
	result = self->priv->stack_head_index == -1;
#line 80 "../lib/sudoku-game.vala"
	return result;
#line 207 "sudoku-game.c"
}

gboolean
sudoku_game_is_redostack_null (SudokuGame* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 83 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->stack;
#line 85 "../lib/sudoku-game.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 85 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 85 "../lib/sudoku-game.vala"
	result = self->priv->stack_head_index == (_tmp2_ - 1);
#line 85 "../lib/sudoku-game.vala"
	return result;
#line 229 "sudoku-game.c"
}

SudokuGame*
sudoku_game_construct (GType object_type,
                       SudokuBoard* board)
{
	SudokuGame * self = NULL;
	GTimer* _tmp0_;
	GeeArrayList* _tmp1_;
#line 88 "../lib/sudoku-game.vala"
	g_return_val_if_fail (board != NULL, NULL);
#line 88 "../lib/sudoku-game.vala"
	self = (SudokuGame*) g_object_new (object_type, NULL);
#line 90 "../lib/sudoku-game.vala"
	sudoku_game_set_board (self, board);
#line 91 "../lib/sudoku-game.vala"
	sudoku_game_set_mode (self, GAME_MODE_NONE);
#line 92 "../lib/sudoku-game.vala"
	_tmp0_ = g_timer_new ();
#line 92 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 92 "../lib/sudoku-game.vala"
	self->priv->timer = _tmp0_;
#line 93 "../lib/sudoku-game.vala"
	_tmp1_ = gee_array_list_new (SUDOKU_GAME_TYPE_STACK_ITEM, (GBoxedCopyFunc) sudoku_game_stack_item_ref, (GDestroyNotify) sudoku_game_stack_item_unref, NULL, NULL, NULL);
#line 93 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->stack);
#line 93 "../lib/sudoku-game.vala"
	self->priv->stack = _tmp1_;
#line 88 "../lib/sudoku-game.vala"
	return self;
#line 261 "sudoku-game.c"
}

SudokuGame*
sudoku_game_new (SudokuBoard* board)
{
#line 88 "../lib/sudoku-game.vala"
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
#line 269 "sudoku-game.c"
}

void
sudoku_game_enable_earmark (SudokuGame* self,
                            gint row,
                            gint col,
                            gint num)
{
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp0_;
	SudokuBoard* _tmp1_;
#line 96 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 98 "../lib/sudoku-game.vala"
	_tmp0_ = sudoku_game_stack_item_new (STACK_ACTION_ENABLE_EARMARK);
#line 98 "../lib/sudoku-game.vala"
	new_stack_item = _tmp0_;
#line 99 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, new_stack_item);
#line 101 "../lib/sudoku-game.vala"
	sudoku_game_add_earmark_step (self, new_stack_item, row, col, num, TRUE);
#line 102 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 102 "../lib/sudoku-game.vala"
	sudoku_board_enable_earmark (_tmp1_, row, col, num);
#line 104 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, new_stack_item->action);
#line 96 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 299 "sudoku-game.c"
}

void
sudoku_game_disable_earmark (SudokuGame* self,
                             gint row,
                             gint col,
                             gint num)
{
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp0_;
	SudokuBoard* _tmp1_;
#line 107 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 109 "../lib/sudoku-game.vala"
	_tmp0_ = sudoku_game_stack_item_new (STACK_ACTION_DISABLE_EARMARK);
#line 109 "../lib/sudoku-game.vala"
	new_stack_item = _tmp0_;
#line 110 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, new_stack_item);
#line 112 "../lib/sudoku-game.vala"
	sudoku_game_add_earmark_step (self, new_stack_item, row, col, num, FALSE);
#line 113 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 113 "../lib/sudoku-game.vala"
	sudoku_board_disable_earmark (_tmp1_, row, col, num);
#line 115 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, new_stack_item->action);
#line 107 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 329 "sudoku-game.c"
}

void
sudoku_game_disable_all_earmarks (SudokuGame* self,
                                  gint row,
                                  gint col)
{
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp0_;
	SudokuBoard* _tmp1_;
#line 118 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 120 "../lib/sudoku-game.vala"
	_tmp0_ = sudoku_game_stack_item_new (STACK_ACTION_DISABLE_ALL_EARMARKS);
#line 120 "../lib/sudoku-game.vala"
	new_stack_item = _tmp0_;
#line 121 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, new_stack_item);
#line 123 "../lib/sudoku-game.vala"
	sudoku_game_add_disable_earmarks_step (self, new_stack_item, row, col);
#line 124 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 124 "../lib/sudoku-game.vala"
	sudoku_board_disable_all_earmarks (_tmp1_, row, col);
#line 126 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, new_stack_item->action);
#line 118 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 358 "sudoku-game.c"
}

void
sudoku_game_insert (SudokuGame* self,
                    gint row,
                    gint col,
                    gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp1_;
	SudokuGamestack_item* _tmp2_;
	SudokuBoard* _tmp3_;
	SudokuGamestack_item* _tmp6_;
	SudokuBoard* _tmp7_;
	SudokuGamestack_item* _tmp8_;
#line 129 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 131 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 131 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 133 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_game_stack_item_new (STACK_ACTION_INSERT);
#line 133 "../lib/sudoku-game.vala"
	new_stack_item = _tmp1_;
#line 134 "../lib/sudoku-game.vala"
	_tmp2_ = new_stack_item;
#line 134 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp2_);
#line 136 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->_board;
#line 136 "../lib/sudoku-game.vala"
	if (sudoku_board_has_earmarks (_tmp3_, row, col)) {
#line 394 "sudoku-game.c"
		SudokuGamestack_item* _tmp4_;
		SudokuBoard* _tmp5_;
#line 138 "../lib/sudoku-game.vala"
		_tmp4_ = new_stack_item;
#line 138 "../lib/sudoku-game.vala"
		sudoku_game_add_disable_earmarks_step (self, _tmp4_, row, col);
#line 139 "../lib/sudoku-game.vala"
		_tmp5_ = self->priv->_board;
#line 139 "../lib/sudoku-game.vala"
		sudoku_board_disable_all_earmarks (_tmp5_, row, col);
#line 405 "sudoku-game.c"
	}
#line 142 "../lib/sudoku-game.vala"
	_tmp6_ = new_stack_item;
#line 142 "../lib/sudoku-game.vala"
	sudoku_game_add_value_step (self, _tmp6_, row, col, old_val, val);
#line 143 "../lib/sudoku-game.vala"
	_tmp7_ = self->priv->_board;
#line 143 "../lib/sudoku-game.vala"
	sudoku_board_insert (_tmp7_, row, col, val, FALSE);
#line 145 "../lib/sudoku-game.vala"
	_tmp8_ = new_stack_item;
#line 145 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp8_->action);
#line 129 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 421 "sudoku-game.c"
}

void
sudoku_game_remove (SudokuGame* self,
                    gint row,
                    gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp1_;
	SudokuBoard* _tmp2_;
#line 148 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 150 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 150 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 152 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_game_stack_item_new (STACK_ACTION_REMOVE);
#line 152 "../lib/sudoku-game.vala"
	new_stack_item = _tmp1_;
#line 153 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, new_stack_item);
#line 155 "../lib/sudoku-game.vala"
	sudoku_game_add_value_step (self, new_stack_item, row, col, old_val, 0);
#line 156 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->_board;
#line 156 "../lib/sudoku-game.vala"
	sudoku_board_remove (_tmp2_, row, col);
#line 158 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, new_stack_item->action);
#line 148 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 456 "sudoku-game.c"
}

void
sudoku_game_insert_and_disable_related_earmarks (SudokuGame* self,
                                                 gint row,
                                                 gint col,
                                                 gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp1_;
	SudokuGamestack_item* _tmp2_;
	SudokuGamestack_item* _tmp33_;
	GeeArrayList* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
	SudokuBoard* _tmp38_;
	SudokuGamestack_item* _tmp41_;
	SudokuBoard* _tmp42_;
	SudokuGamestack_item* _tmp43_;
#line 161 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 162 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 162 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 163 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_game_stack_item_new (STACK_ACTION_INSERT_AND_DISABLE_RELATED_EARMARKS);
#line 163 "../lib/sudoku-game.vala"
	new_stack_item = _tmp1_;
#line 164 "../lib/sudoku-game.vala"
	_tmp2_ = new_stack_item;
#line 164 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp2_);
#line 492 "sudoku-game.c"
	{
		gint col_tmp = 0;
#line 166 "../lib/sudoku-game.vala"
		col_tmp = 0;
#line 497 "sudoku-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 166 "../lib/sudoku-game.vala"
			_tmp3_ = TRUE;
#line 166 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 504 "sudoku-game.c"
				SudokuBoard* _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
#line 166 "../lib/sudoku-game.vala"
				if (!_tmp3_) {
#line 510 "sudoku-game.c"
					gint _tmp4_;
#line 166 "../lib/sudoku-game.vala"
					_tmp4_ = col_tmp;
#line 166 "../lib/sudoku-game.vala"
					col_tmp = _tmp4_ + 1;
#line 516 "sudoku-game.c"
				}
#line 166 "../lib/sudoku-game.vala"
				_tmp3_ = FALSE;
#line 166 "../lib/sudoku-game.vala"
				_tmp5_ = self->priv->_board;
#line 166 "../lib/sudoku-game.vala"
				_tmp6_ = sudoku_board_get_cols (_tmp5_);
#line 166 "../lib/sudoku-game.vala"
				_tmp7_ = _tmp6_;
#line 166 "../lib/sudoku-game.vala"
				if (!(col_tmp < _tmp7_)) {
#line 166 "../lib/sudoku-game.vala"
					break;
#line 530 "sudoku-game.c"
				}
				{
					gint row_tmp = 0;
#line 167 "../lib/sudoku-game.vala"
					row_tmp = 0;
#line 536 "sudoku-game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 167 "../lib/sudoku-game.vala"
						_tmp8_ = TRUE;
#line 167 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 543 "sudoku-game.c"
							SudokuBoard* _tmp10_;
							gint _tmp11_;
							gint _tmp12_;
							gboolean _tmp13_ = FALSE;
							gboolean _tmp14_ = FALSE;
							gboolean _tmp15_ = FALSE;
							gboolean _tmp16_ = FALSE;
#line 167 "../lib/sudoku-game.vala"
							if (!_tmp8_) {
#line 553 "sudoku-game.c"
								gint _tmp9_;
#line 167 "../lib/sudoku-game.vala"
								_tmp9_ = row_tmp;
#line 167 "../lib/sudoku-game.vala"
								row_tmp = _tmp9_ + 1;
#line 559 "sudoku-game.c"
							}
#line 167 "../lib/sudoku-game.vala"
							_tmp8_ = FALSE;
#line 167 "../lib/sudoku-game.vala"
							_tmp10_ = self->priv->_board;
#line 167 "../lib/sudoku-game.vala"
							_tmp11_ = sudoku_board_get_rows (_tmp10_);
#line 167 "../lib/sudoku-game.vala"
							_tmp12_ = _tmp11_;
#line 167 "../lib/sudoku-game.vala"
							if (!(row_tmp < _tmp12_)) {
#line 167 "../lib/sudoku-game.vala"
								break;
#line 573 "sudoku-game.c"
							}
#line 169 "../lib/sudoku-game.vala"
							if (row_tmp == row) {
#line 169 "../lib/sudoku-game.vala"
								_tmp13_ = col_tmp == col;
#line 579 "sudoku-game.c"
							} else {
#line 169 "../lib/sudoku-game.vala"
								_tmp13_ = FALSE;
#line 583 "sudoku-game.c"
							}
#line 169 "../lib/sudoku-game.vala"
							if (_tmp13_) {
#line 170 "../lib/sudoku-game.vala"
								continue;
#line 589 "sudoku-game.c"
							}
#line 172 "../lib/sudoku-game.vala"
							if (row_tmp == row) {
#line 172 "../lib/sudoku-game.vala"
								_tmp16_ = TRUE;
#line 595 "sudoku-game.c"
							} else {
#line 172 "../lib/sudoku-game.vala"
								_tmp16_ = col_tmp == col;
#line 599 "sudoku-game.c"
							}
#line 172 "../lib/sudoku-game.vala"
							if (_tmp16_) {
#line 172 "../lib/sudoku-game.vala"
								_tmp15_ = TRUE;
#line 605 "sudoku-game.c"
							} else {
								gboolean _tmp17_ = FALSE;
								SudokuBoard* _tmp18_;
								gint _tmp19_;
								gint _tmp20_;
								SudokuBoard* _tmp21_;
								gint _tmp22_;
								gint _tmp23_;
#line 173 "../lib/sudoku-game.vala"
								_tmp18_ = self->priv->_board;
#line 173 "../lib/sudoku-game.vala"
								_tmp19_ = sudoku_board_get_block_cols (_tmp18_);
#line 173 "../lib/sudoku-game.vala"
								_tmp20_ = _tmp19_;
#line 173 "../lib/sudoku-game.vala"
								_tmp21_ = self->priv->_board;
#line 173 "../lib/sudoku-game.vala"
								_tmp22_ = sudoku_board_get_block_cols (_tmp21_);
#line 173 "../lib/sudoku-game.vala"
								_tmp23_ = _tmp22_;
#line 173 "../lib/sudoku-game.vala"
								if ((row_tmp / _tmp20_) == (row / _tmp23_)) {
#line 628 "sudoku-game.c"
									SudokuBoard* _tmp24_;
									gint _tmp25_;
									gint _tmp26_;
									SudokuBoard* _tmp27_;
									gint _tmp28_;
									gint _tmp29_;
#line 174 "../lib/sudoku-game.vala"
									_tmp24_ = self->priv->_board;
#line 174 "../lib/sudoku-game.vala"
									_tmp25_ = sudoku_board_get_block_rows (_tmp24_);
#line 174 "../lib/sudoku-game.vala"
									_tmp26_ = _tmp25_;
#line 174 "../lib/sudoku-game.vala"
									_tmp27_ = self->priv->_board;
#line 174 "../lib/sudoku-game.vala"
									_tmp28_ = sudoku_board_get_block_rows (_tmp27_);
#line 174 "../lib/sudoku-game.vala"
									_tmp29_ = _tmp28_;
#line 174 "../lib/sudoku-game.vala"
									_tmp17_ = (col_tmp / _tmp26_) == (col / _tmp29_);
#line 649 "sudoku-game.c"
								} else {
#line 173 "../lib/sudoku-game.vala"
									_tmp17_ = FALSE;
#line 653 "sudoku-game.c"
								}
#line 173 "../lib/sudoku-game.vala"
								_tmp15_ = _tmp17_;
#line 657 "sudoku-game.c"
							}
#line 172 "../lib/sudoku-game.vala"
							if (_tmp15_) {
#line 661 "sudoku-game.c"
								SudokuBoard* _tmp30_;
#line 175 "../lib/sudoku-game.vala"
								_tmp30_ = self->priv->_board;
#line 175 "../lib/sudoku-game.vala"
								_tmp14_ = sudoku_board_is_earmark_enabled (_tmp30_, row_tmp, col_tmp, val);
#line 667 "sudoku-game.c"
							} else {
#line 172 "../lib/sudoku-game.vala"
								_tmp14_ = FALSE;
#line 671 "sudoku-game.c"
							}
#line 172 "../lib/sudoku-game.vala"
							if (_tmp14_) {
#line 675 "sudoku-game.c"
								SudokuGamestack_item* _tmp31_;
								SudokuBoard* _tmp32_;
#line 177 "../lib/sudoku-game.vala"
								_tmp31_ = new_stack_item;
#line 177 "../lib/sudoku-game.vala"
								sudoku_game_add_earmark_step (self, _tmp31_, row_tmp, col_tmp, val, FALSE);
#line 178 "../lib/sudoku-game.vala"
								_tmp32_ = self->priv->_board;
#line 178 "../lib/sudoku-game.vala"
								sudoku_board_disable_earmark (_tmp32_, row_tmp, col_tmp, val);
#line 686 "sudoku-game.c"
							}
						}
					}
				}
			}
		}
	}
#line 182 "../lib/sudoku-game.vala"
	_tmp33_ = new_stack_item;
#line 182 "../lib/sudoku-game.vala"
	_tmp34_ = _tmp33_->earmarks;
#line 182 "../lib/sudoku-game.vala"
	_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 182 "../lib/sudoku-game.vala"
	_tmp36_ = _tmp35_;
#line 182 "../lib/sudoku-game.vala"
	if (_tmp36_ == 0) {
#line 704 "sudoku-game.c"
		SudokuGamestack_item* _tmp37_;
#line 183 "../lib/sudoku-game.vala"
		_tmp37_ = new_stack_item;
#line 183 "../lib/sudoku-game.vala"
		_tmp37_->action = STACK_ACTION_INSERT;
#line 710 "sudoku-game.c"
	}
#line 185 "../lib/sudoku-game.vala"
	_tmp38_ = self->priv->_board;
#line 185 "../lib/sudoku-game.vala"
	if (sudoku_board_has_earmarks (_tmp38_, row, col)) {
#line 716 "sudoku-game.c"
		SudokuGamestack_item* _tmp39_;
		SudokuBoard* _tmp40_;
#line 187 "../lib/sudoku-game.vala"
		_tmp39_ = new_stack_item;
#line 187 "../lib/sudoku-game.vala"
		sudoku_game_add_disable_earmarks_step (self, _tmp39_, row, col);
#line 188 "../lib/sudoku-game.vala"
		_tmp40_ = self->priv->_board;
#line 188 "../lib/sudoku-game.vala"
		sudoku_board_disable_all_earmarks (_tmp40_, row, col);
#line 727 "sudoku-game.c"
	}
#line 191 "../lib/sudoku-game.vala"
	_tmp41_ = new_stack_item;
#line 191 "../lib/sudoku-game.vala"
	sudoku_game_add_value_step (self, _tmp41_, row, col, old_val, val);
#line 192 "../lib/sudoku-game.vala"
	_tmp42_ = self->priv->_board;
#line 192 "../lib/sudoku-game.vala"
	sudoku_board_insert (_tmp42_, row, col, val, FALSE);
#line 194 "../lib/sudoku-game.vala"
	_tmp43_ = new_stack_item;
#line 194 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp43_->action);
#line 161 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 743 "sudoku-game.c"
}

StackAction
sudoku_game_get_current_stack_action (SudokuGame* self)
{
	StackAction _tmp0_ = 0;
	StackAction result;
#line 197 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 199 "../lib/sudoku-game.vala"
	if (self->priv->stack_head_index == -1) {
#line 199 "../lib/sudoku-game.vala"
		_tmp0_ = STACK_ACTION_NONE;
#line 757 "sudoku-game.c"
	} else {
		GeeArrayList* _tmp1_;
		gpointer _tmp2_;
		SudokuGamestack_item* _tmp3_;
#line 199 "../lib/sudoku-game.vala"
		_tmp1_ = self->priv->stack;
#line 199 "../lib/sudoku-game.vala"
		_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, self->priv->stack_head_index);
#line 199 "../lib/sudoku-game.vala"
		_tmp3_ = (SudokuGamestack_item*) _tmp2_;
#line 199 "../lib/sudoku-game.vala"
		_tmp0_ = _tmp3_->action;
#line 199 "../lib/sudoku-game.vala"
		_sudoku_game_stack_item_unref0 (_tmp3_);
#line 772 "sudoku-game.c"
	}
#line 199 "../lib/sudoku-game.vala"
	result = _tmp0_;
#line 199 "../lib/sudoku-game.vala"
	return result;
#line 778 "sudoku-game.c"
}

static void
sudoku_game_add_to_stack (SudokuGame* self,
                          SudokuGamestack_item* item)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 202 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 202 "../lib/sudoku-game.vala"
	g_return_if_fail (item != NULL);
#line 204 "../lib/sudoku-game.vala"
	sudoku_game_stack_slice (self);
#line 205 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->stack;
#line 205 "../lib/sudoku-game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, item);
#line 206 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->stack;
#line 206 "../lib/sudoku-game.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 206 "../lib/sudoku-game.vala"
	_tmp3_ = _tmp2_;
#line 206 "../lib/sudoku-game.vala"
	self->priv->stack_head_index = _tmp3_ - 1;
#line 807 "sudoku-game.c"
}

gboolean
sudoku_game_is_empty (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gboolean result;
#line 209 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 211 "../lib/sudoku-game.vala"
	result = sudoku_board_is_empty (_tmp0_);
#line 211 "../lib/sudoku-game.vala"
	return result;
#line 823 "sudoku-game.c"
}

void
sudoku_game_reset (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gint* cells = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint* _tmp4_;
	gint cells_length1;
	gint cells_length2;
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp5_;
	SudokuGamestack_item* _tmp6_;
	SudokuGamestack_item* _tmp26_;
#line 214 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 216 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 216 "../lib/sudoku-game.vala"
	sudoku_board_set_previous_played_time (_tmp0_, (gdouble) 0);
#line 217 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->_board;
#line 217 "../lib/sudoku-game.vala"
	_tmp4_ = sudoku_board_get_cells (_tmp1_, &_tmp2_, &_tmp3_);
#line 217 "../lib/sudoku-game.vala"
	cells = _tmp4_;
#line 217 "../lib/sudoku-game.vala"
	cells_length1 = _tmp2_;
#line 217 "../lib/sudoku-game.vala"
	cells_length2 = _tmp3_;
#line 218 "../lib/sudoku-game.vala"
	_tmp5_ = sudoku_game_stack_item_new (STACK_ACTION_CLEAR_BOARD);
#line 218 "../lib/sudoku-game.vala"
	new_stack_item = _tmp5_;
#line 219 "../lib/sudoku-game.vala"
	_tmp6_ = new_stack_item;
#line 219 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp6_);
#line 865 "sudoku-game.c"
	{
		gint row = 0;
#line 220 "../lib/sudoku-game.vala"
		row = 0;
#line 870 "sudoku-game.c"
		{
			gboolean _tmp7_ = FALSE;
#line 220 "../lib/sudoku-game.vala"
			_tmp7_ = TRUE;
#line 220 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 877 "sudoku-game.c"
				SudokuBoard* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 220 "../lib/sudoku-game.vala"
				if (!_tmp7_) {
#line 883 "sudoku-game.c"
					gint _tmp8_;
#line 220 "../lib/sudoku-game.vala"
					_tmp8_ = row;
#line 220 "../lib/sudoku-game.vala"
					row = _tmp8_ + 1;
#line 889 "sudoku-game.c"
				}
#line 220 "../lib/sudoku-game.vala"
				_tmp7_ = FALSE;
#line 220 "../lib/sudoku-game.vala"
				_tmp9_ = self->priv->_board;
#line 220 "../lib/sudoku-game.vala"
				_tmp10_ = sudoku_board_get_rows (_tmp9_);
#line 220 "../lib/sudoku-game.vala"
				_tmp11_ = _tmp10_;
#line 220 "../lib/sudoku-game.vala"
				if (!(row < _tmp11_)) {
#line 220 "../lib/sudoku-game.vala"
					break;
#line 903 "sudoku-game.c"
				}
				{
					gint col = 0;
#line 221 "../lib/sudoku-game.vala"
					col = 0;
#line 909 "sudoku-game.c"
					{
						gboolean _tmp12_ = FALSE;
#line 221 "../lib/sudoku-game.vala"
						_tmp12_ = TRUE;
#line 221 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 916 "sudoku-game.c"
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							SudokuBoard* _tmp17_;
							gint* _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							gint _tmp19_;
							SudokuBoard* _tmp25_;
#line 221 "../lib/sudoku-game.vala"
							if (!_tmp12_) {
#line 928 "sudoku-game.c"
								gint _tmp13_;
#line 221 "../lib/sudoku-game.vala"
								_tmp13_ = col;
#line 221 "../lib/sudoku-game.vala"
								col = _tmp13_ + 1;
#line 934 "sudoku-game.c"
							}
#line 221 "../lib/sudoku-game.vala"
							_tmp12_ = FALSE;
#line 221 "../lib/sudoku-game.vala"
							_tmp14_ = self->priv->_board;
#line 221 "../lib/sudoku-game.vala"
							_tmp15_ = sudoku_board_get_cols (_tmp14_);
#line 221 "../lib/sudoku-game.vala"
							_tmp16_ = _tmp15_;
#line 221 "../lib/sudoku-game.vala"
							if (!(col < _tmp16_)) {
#line 221 "../lib/sudoku-game.vala"
								break;
#line 948 "sudoku-game.c"
							}
#line 223 "../lib/sudoku-game.vala"
							_tmp17_ = self->priv->_board;
#line 223 "../lib/sudoku-game.vala"
							if (sudoku_board_get_is_fixed (_tmp17_, row, col)) {
#line 224 "../lib/sudoku-game.vala"
								continue;
#line 956 "sudoku-game.c"
							}
#line 226 "../lib/sudoku-game.vala"
							_tmp18_ = cells;
#line 226 "../lib/sudoku-game.vala"
							_tmp18__length1 = cells_length1;
#line 226 "../lib/sudoku-game.vala"
							_tmp18__length2 = cells_length2;
#line 226 "../lib/sudoku-game.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 226 "../lib/sudoku-game.vala"
							if (_tmp19_ > 0) {
#line 968 "sudoku-game.c"
								SudokuGamestack_item* _tmp20_;
								gint* _tmp21_;
								gint _tmp21__length1;
								gint _tmp21__length2;
								gint _tmp22_;
#line 227 "../lib/sudoku-game.vala"
								_tmp20_ = new_stack_item;
#line 227 "../lib/sudoku-game.vala"
								_tmp21_ = cells;
#line 227 "../lib/sudoku-game.vala"
								_tmp21__length1 = cells_length1;
#line 227 "../lib/sudoku-game.vala"
								_tmp21__length2 = cells_length2;
#line 227 "../lib/sudoku-game.vala"
								_tmp22_ = _tmp21_[(row * _tmp21__length2) + col];
#line 227 "../lib/sudoku-game.vala"
								sudoku_game_add_value_step (self, _tmp20_, row, col, _tmp22_, 0);
#line 986 "sudoku-game.c"
							} else {
								SudokuBoard* _tmp23_;
#line 228 "../lib/sudoku-game.vala"
								_tmp23_ = self->priv->_board;
#line 228 "../lib/sudoku-game.vala"
								if (sudoku_board_has_earmarks (_tmp23_, row, col)) {
#line 993 "sudoku-game.c"
									SudokuGamestack_item* _tmp24_;
#line 229 "../lib/sudoku-game.vala"
									_tmp24_ = new_stack_item;
#line 229 "../lib/sudoku-game.vala"
									sudoku_game_add_disable_earmarks_step (self, _tmp24_, row, col);
#line 999 "sudoku-game.c"
								}
							}
#line 230 "../lib/sudoku-game.vala"
							_tmp25_ = self->priv->_board;
#line 230 "../lib/sudoku-game.vala"
							sudoku_board_set (_tmp25_, row, col, 0);
#line 1006 "sudoku-game.c"
						}
					}
				}
			}
		}
	}
#line 232 "../lib/sudoku-game.vala"
	_tmp26_ = new_stack_item;
#line 232 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp26_->action);
#line 214 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 214 "../lib/sudoku-game.vala"
	cells = (g_free (cells), NULL);
#line 1021 "sudoku-game.c"
}

static void
sudoku_game_add_earmark_step (SudokuGame* self,
                              SudokuGamestack_item* item,
                              gint row,
                              gint col,
                              gint number,
                              gboolean enabled)
{
	SudokuGameearmark_change step = {0};
	SudokuGameearmark_change _tmp0_ = {0};
	GeeArrayList* _tmp1_;
	SudokuGameearmark_change _tmp2_;
#line 235 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 235 "../lib/sudoku-game.vala"
	g_return_if_fail (item != NULL);
#line 237 "../lib/sudoku-game.vala"
	_tmp0_.row = row;
#line 237 "../lib/sudoku-game.vala"
	_tmp0_.col = col;
#line 237 "../lib/sudoku-game.vala"
	_tmp0_.number = number;
#line 237 "../lib/sudoku-game.vala"
	_tmp0_.enabled = enabled;
#line 237 "../lib/sudoku-game.vala"
	step = _tmp0_;
#line 238 "../lib/sudoku-game.vala"
	_tmp1_ = item->earmarks;
#line 238 "../lib/sudoku-game.vala"
	_tmp2_ = step;
#line 238 "../lib/sudoku-game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, &_tmp2_);
#line 1056 "sudoku-game.c"
}

static void
sudoku_game_add_disable_earmarks_step (SudokuGame* self,
                                       SudokuGamestack_item* item,
                                       gint row,
                                       gint col)
{
	gboolean* marks = NULL;
	SudokuBoard* _tmp0_;
	gint _tmp1_ = 0;
	gboolean* _tmp2_;
	gint marks_length1;
	gint _marks_size_;
#line 241 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 241 "../lib/sudoku-game.vala"
	g_return_if_fail (item != NULL);
#line 243 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 243 "../lib/sudoku-game.vala"
	_tmp2_ = sudoku_board_get_earmarks (_tmp0_, row, col, &_tmp1_);
#line 243 "../lib/sudoku-game.vala"
	marks = _tmp2_;
#line 243 "../lib/sudoku-game.vala"
	marks_length1 = _tmp1_;
#line 243 "../lib/sudoku-game.vala"
	_marks_size_ = marks_length1;
#line 1085 "sudoku-game.c"
	{
		gint num = 0;
#line 244 "../lib/sudoku-game.vala"
		num = 1;
#line 1090 "sudoku-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 244 "../lib/sudoku-game.vala"
			_tmp3_ = TRUE;
#line 244 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1097 "sudoku-game.c"
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gboolean _tmp6_;
#line 244 "../lib/sudoku-game.vala"
				if (!_tmp3_) {
#line 1103 "sudoku-game.c"
					gint _tmp4_;
#line 244 "../lib/sudoku-game.vala"
					_tmp4_ = num;
#line 244 "../lib/sudoku-game.vala"
					num = _tmp4_ + 1;
#line 1109 "sudoku-game.c"
				}
#line 244 "../lib/sudoku-game.vala"
				_tmp3_ = FALSE;
#line 244 "../lib/sudoku-game.vala"
				if (!(num <= 9)) {
#line 244 "../lib/sudoku-game.vala"
					break;
#line 1117 "sudoku-game.c"
				}
#line 245 "../lib/sudoku-game.vala"
				_tmp5_ = marks;
#line 245 "../lib/sudoku-game.vala"
				_tmp5__length1 = marks_length1;
#line 245 "../lib/sudoku-game.vala"
				_tmp6_ = _tmp5_[num - 1];
#line 245 "../lib/sudoku-game.vala"
				if (_tmp6_) {
#line 1127 "sudoku-game.c"
					SudokuGameearmark_change step = {0};
					SudokuGameearmark_change _tmp7_ = {0};
					GeeArrayList* _tmp8_;
					SudokuGameearmark_change _tmp9_;
#line 247 "../lib/sudoku-game.vala"
					_tmp7_.row = row;
#line 247 "../lib/sudoku-game.vala"
					_tmp7_.col = col;
#line 247 "../lib/sudoku-game.vala"
					_tmp7_.number = num;
#line 247 "../lib/sudoku-game.vala"
					_tmp7_.enabled = FALSE;
#line 247 "../lib/sudoku-game.vala"
					step = _tmp7_;
#line 248 "../lib/sudoku-game.vala"
					_tmp8_ = item->earmarks;
#line 248 "../lib/sudoku-game.vala"
					_tmp9_ = step;
#line 248 "../lib/sudoku-game.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, &_tmp9_);
#line 1148 "sudoku-game.c"
				}
			}
		}
	}
#line 241 "../lib/sudoku-game.vala"
	marks = (g_free (marks), NULL);
#line 1155 "sudoku-game.c"
}

static void
sudoku_game_add_value_step (SudokuGame* self,
                            SudokuGamestack_item* item,
                            gint row,
                            gint col,
                            gint old_val,
                            gint val)
{
	SudokuGamevalue_change step = {0};
	SudokuGamevalue_change _tmp0_ = {0};
	GeeArrayList* _tmp1_;
	SudokuGamevalue_change _tmp2_;
#line 252 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 252 "../lib/sudoku-game.vala"
	g_return_if_fail (item != NULL);
#line 254 "../lib/sudoku-game.vala"
	_tmp0_.row = row;
#line 254 "../lib/sudoku-game.vala"
	_tmp0_.col = col;
#line 254 "../lib/sudoku-game.vala"
	_tmp0_.old_val = old_val;
#line 254 "../lib/sudoku-game.vala"
	_tmp0_.new_val = val;
#line 254 "../lib/sudoku-game.vala"
	step = _tmp0_;
#line 255 "../lib/sudoku-game.vala"
	_tmp1_ = item->values;
#line 255 "../lib/sudoku-game.vala"
	_tmp2_ = step;
#line 255 "../lib/sudoku-game.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, &_tmp2_);
#line 1190 "sudoku-game.c"
}

void
sudoku_game_undo (SudokuGame* self)
{
	SudokuGamestack_item* changes = NULL;
	GeeArrayList* _tmp0_;
	gpointer _tmp1_;
	GeeListIterator* value_iterator = NULL;
	SudokuGamestack_item* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeListIterator* _tmp4_;
	GeeListIterator* earmark_iterator = NULL;
	SudokuGamestack_item* _tmp14_;
	GeeArrayList* _tmp15_;
	GeeListIterator* _tmp16_;
	gint _tmp31_;
	GeeArrayList* _tmp32_;
	gpointer _tmp33_;
	SudokuGamestack_item* _tmp34_;
#line 258 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 260 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->stack;
#line 260 "../lib/sudoku-game.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, self->priv->stack_head_index);
#line 260 "../lib/sudoku-game.vala"
	changes = (SudokuGamestack_item*) _tmp1_;
#line 262 "../lib/sudoku-game.vala"
	_tmp2_ = changes;
#line 262 "../lib/sudoku-game.vala"
	_tmp3_ = _tmp2_->values;
#line 262 "../lib/sudoku-game.vala"
	_tmp4_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp3_);
#line 262 "../lib/sudoku-game.vala"
	value_iterator = _tmp4_;
#line 1227 "sudoku-game.c"
	{
		gboolean has_next = FALSE;
		GeeListIterator* _tmp5_;
#line 263 "../lib/sudoku-game.vala"
		_tmp5_ = value_iterator;
#line 263 "../lib/sudoku-game.vala"
		has_next = gee_iterator_next ((GeeIterator*) _tmp5_);
#line 1235 "sudoku-game.c"
		{
			gboolean _tmp6_ = FALSE;
#line 263 "../lib/sudoku-game.vala"
			_tmp6_ = TRUE;
#line 263 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1242 "sudoku-game.c"
				SudokuGamevalue_change* val = NULL;
				GeeListIterator* _tmp8_;
				gpointer _tmp9_;
				SudokuBoard* _tmp10_;
				SudokuGamevalue_change* _tmp11_;
				SudokuGamevalue_change* _tmp12_;
				SudokuGamevalue_change* _tmp13_;
#line 263 "../lib/sudoku-game.vala"
				if (!_tmp6_) {
#line 1252 "sudoku-game.c"
					GeeListIterator* _tmp7_;
#line 263 "../lib/sudoku-game.vala"
					_tmp7_ = value_iterator;
#line 263 "../lib/sudoku-game.vala"
					has_next = gee_iterator_next ((GeeIterator*) _tmp7_);
#line 1258 "sudoku-game.c"
				}
#line 263 "../lib/sudoku-game.vala"
				_tmp6_ = FALSE;
#line 263 "../lib/sudoku-game.vala"
				if (!has_next) {
#line 263 "../lib/sudoku-game.vala"
					break;
#line 1266 "sudoku-game.c"
				}
#line 265 "../lib/sudoku-game.vala"
				_tmp8_ = value_iterator;
#line 265 "../lib/sudoku-game.vala"
				_tmp9_ = gee_iterator_get ((GeeIterator*) _tmp8_);
#line 265 "../lib/sudoku-game.vala"
				val = (SudokuGamevalue_change*) _tmp9_;
#line 266 "../lib/sudoku-game.vala"
				_tmp10_ = self->priv->_board;
#line 266 "../lib/sudoku-game.vala"
				_tmp11_ = val;
#line 266 "../lib/sudoku-game.vala"
				_tmp12_ = val;
#line 266 "../lib/sudoku-game.vala"
				_tmp13_ = val;
#line 266 "../lib/sudoku-game.vala"
				sudoku_board_set (_tmp10_, (*_tmp11_).row, (*_tmp12_).col, (*_tmp13_).old_val);
#line 263 "../lib/sudoku-game.vala"
				_sudoku_game_value_change_free0 (val);
#line 1286 "sudoku-game.c"
			}
		}
	}
#line 269 "../lib/sudoku-game.vala"
	_tmp14_ = changes;
#line 269 "../lib/sudoku-game.vala"
	_tmp15_ = _tmp14_->earmarks;
#line 269 "../lib/sudoku-game.vala"
	_tmp16_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp15_);
#line 269 "../lib/sudoku-game.vala"
	earmark_iterator = _tmp16_;
#line 1298 "sudoku-game.c"
	{
		gboolean has_next = FALSE;
		GeeListIterator* _tmp17_;
#line 270 "../lib/sudoku-game.vala"
		_tmp17_ = earmark_iterator;
#line 270 "../lib/sudoku-game.vala"
		has_next = gee_iterator_next ((GeeIterator*) _tmp17_);
#line 1306 "sudoku-game.c"
		{
			gboolean _tmp18_ = FALSE;
#line 270 "../lib/sudoku-game.vala"
			_tmp18_ = TRUE;
#line 270 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1313 "sudoku-game.c"
				SudokuGameearmark_change* earmark = NULL;
				GeeListIterator* _tmp20_;
				gpointer _tmp21_;
				SudokuGameearmark_change* _tmp22_;
#line 270 "../lib/sudoku-game.vala"
				if (!_tmp18_) {
#line 1320 "sudoku-game.c"
					GeeListIterator* _tmp19_;
#line 270 "../lib/sudoku-game.vala"
					_tmp19_ = earmark_iterator;
#line 270 "../lib/sudoku-game.vala"
					has_next = gee_iterator_next ((GeeIterator*) _tmp19_);
#line 1326 "sudoku-game.c"
				}
#line 270 "../lib/sudoku-game.vala"
				_tmp18_ = FALSE;
#line 270 "../lib/sudoku-game.vala"
				if (!has_next) {
#line 270 "../lib/sudoku-game.vala"
					break;
#line 1334 "sudoku-game.c"
				}
#line 272 "../lib/sudoku-game.vala"
				_tmp20_ = earmark_iterator;
#line 272 "../lib/sudoku-game.vala"
				_tmp21_ = gee_iterator_get ((GeeIterator*) _tmp20_);
#line 272 "../lib/sudoku-game.vala"
				earmark = (SudokuGameearmark_change*) _tmp21_;
#line 273 "../lib/sudoku-game.vala"
				_tmp22_ = earmark;
#line 273 "../lib/sudoku-game.vala"
				if ((*_tmp22_).enabled) {
#line 1346 "sudoku-game.c"
					SudokuBoard* _tmp23_;
					SudokuGameearmark_change* _tmp24_;
					SudokuGameearmark_change* _tmp25_;
					SudokuGameearmark_change* _tmp26_;
#line 274 "../lib/sudoku-game.vala"
					_tmp23_ = self->priv->_board;
#line 274 "../lib/sudoku-game.vala"
					_tmp24_ = earmark;
#line 274 "../lib/sudoku-game.vala"
					_tmp25_ = earmark;
#line 274 "../lib/sudoku-game.vala"
					_tmp26_ = earmark;
#line 274 "../lib/sudoku-game.vala"
					sudoku_board_disable_earmark (_tmp23_, (*_tmp24_).row, (*_tmp25_).col, (*_tmp26_).number);
#line 1361 "sudoku-game.c"
				} else {
					SudokuBoard* _tmp27_;
					SudokuGameearmark_change* _tmp28_;
					SudokuGameearmark_change* _tmp29_;
					SudokuGameearmark_change* _tmp30_;
#line 276 "../lib/sudoku-game.vala"
					_tmp27_ = self->priv->_board;
#line 276 "../lib/sudoku-game.vala"
					_tmp28_ = earmark;
#line 276 "../lib/sudoku-game.vala"
					_tmp29_ = earmark;
#line 276 "../lib/sudoku-game.vala"
					_tmp30_ = earmark;
#line 276 "../lib/sudoku-game.vala"
					sudoku_board_enable_earmark (_tmp27_, (*_tmp28_).row, (*_tmp29_).col, (*_tmp30_).number);
#line 1377 "sudoku-game.c"
				}
#line 270 "../lib/sudoku-game.vala"
				_sudoku_game_earmark_change_free0 (earmark);
#line 1381 "sudoku-game.c"
			}
		}
	}
#line 279 "../lib/sudoku-game.vala"
	_tmp31_ = self->priv->stack_head_index;
#line 279 "../lib/sudoku-game.vala"
	self->priv->stack_head_index = _tmp31_ - 1;
#line 280 "../lib/sudoku-game.vala"
	_tmp32_ = self->priv->stack;
#line 280 "../lib/sudoku-game.vala"
	_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, self->priv->stack_head_index + 1);
#line 280 "../lib/sudoku-game.vala"
	_tmp34_ = (SudokuGamestack_item*) _tmp33_;
#line 280 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp34_->action);
#line 280 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (_tmp34_);
#line 258 "../lib/sudoku-game.vala"
	_g_object_unref0 (earmark_iterator);
#line 258 "../lib/sudoku-game.vala"
	_g_object_unref0 (value_iterator);
#line 258 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (changes);
#line 1405 "sudoku-game.c"
}

void
sudoku_game_redo (SudokuGame* self)
{
	gint _tmp0_;
	SudokuGamestack_item* changes = NULL;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	GeeListIterator* earmark_iterator = NULL;
	SudokuGamestack_item* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeListIterator* _tmp5_;
	GeeListIterator* value_iterator = NULL;
	SudokuGamestack_item* _tmp20_;
	GeeArrayList* _tmp21_;
	GeeListIterator* _tmp22_;
	GeeArrayList* _tmp32_;
	gpointer _tmp33_;
	SudokuGamestack_item* _tmp34_;
#line 283 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 285 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->stack_head_index;
#line 285 "../lib/sudoku-game.vala"
	self->priv->stack_head_index = _tmp0_ + 1;
#line 287 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->stack;
#line 287 "../lib/sudoku-game.vala"
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, self->priv->stack_head_index);
#line 287 "../lib/sudoku-game.vala"
	changes = (SudokuGamestack_item*) _tmp2_;
#line 289 "../lib/sudoku-game.vala"
	_tmp3_ = changes;
#line 289 "../lib/sudoku-game.vala"
	_tmp4_ = _tmp3_->earmarks;
#line 289 "../lib/sudoku-game.vala"
	_tmp5_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp4_);
#line 289 "../lib/sudoku-game.vala"
	earmark_iterator = _tmp5_;
#line 1446 "sudoku-game.c"
	{
		gboolean has_next = FALSE;
		GeeListIterator* _tmp6_;
#line 290 "../lib/sudoku-game.vala"
		_tmp6_ = earmark_iterator;
#line 290 "../lib/sudoku-game.vala"
		has_next = gee_iterator_next ((GeeIterator*) _tmp6_);
#line 1454 "sudoku-game.c"
		{
			gboolean _tmp7_ = FALSE;
#line 290 "../lib/sudoku-game.vala"
			_tmp7_ = TRUE;
#line 290 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1461 "sudoku-game.c"
				SudokuGameearmark_change* earmark = NULL;
				GeeListIterator* _tmp9_;
				gpointer _tmp10_;
				SudokuGameearmark_change* _tmp11_;
#line 290 "../lib/sudoku-game.vala"
				if (!_tmp7_) {
#line 1468 "sudoku-game.c"
					GeeListIterator* _tmp8_;
#line 290 "../lib/sudoku-game.vala"
					_tmp8_ = earmark_iterator;
#line 290 "../lib/sudoku-game.vala"
					has_next = gee_iterator_next ((GeeIterator*) _tmp8_);
#line 1474 "sudoku-game.c"
				}
#line 290 "../lib/sudoku-game.vala"
				_tmp7_ = FALSE;
#line 290 "../lib/sudoku-game.vala"
				if (!has_next) {
#line 290 "../lib/sudoku-game.vala"
					break;
#line 1482 "sudoku-game.c"
				}
#line 292 "../lib/sudoku-game.vala"
				_tmp9_ = earmark_iterator;
#line 292 "../lib/sudoku-game.vala"
				_tmp10_ = gee_iterator_get ((GeeIterator*) _tmp9_);
#line 292 "../lib/sudoku-game.vala"
				earmark = (SudokuGameearmark_change*) _tmp10_;
#line 293 "../lib/sudoku-game.vala"
				_tmp11_ = earmark;
#line 293 "../lib/sudoku-game.vala"
				if ((*_tmp11_).enabled) {
#line 1494 "sudoku-game.c"
					SudokuBoard* _tmp12_;
					SudokuGameearmark_change* _tmp13_;
					SudokuGameearmark_change* _tmp14_;
					SudokuGameearmark_change* _tmp15_;
#line 294 "../lib/sudoku-game.vala"
					_tmp12_ = self->priv->_board;
#line 294 "../lib/sudoku-game.vala"
					_tmp13_ = earmark;
#line 294 "../lib/sudoku-game.vala"
					_tmp14_ = earmark;
#line 294 "../lib/sudoku-game.vala"
					_tmp15_ = earmark;
#line 294 "../lib/sudoku-game.vala"
					sudoku_board_enable_earmark (_tmp12_, (*_tmp13_).row, (*_tmp14_).col, (*_tmp15_).number);
#line 1509 "sudoku-game.c"
				} else {
					SudokuBoard* _tmp16_;
					SudokuGameearmark_change* _tmp17_;
					SudokuGameearmark_change* _tmp18_;
					SudokuGameearmark_change* _tmp19_;
#line 296 "../lib/sudoku-game.vala"
					_tmp16_ = self->priv->_board;
#line 296 "../lib/sudoku-game.vala"
					_tmp17_ = earmark;
#line 296 "../lib/sudoku-game.vala"
					_tmp18_ = earmark;
#line 296 "../lib/sudoku-game.vala"
					_tmp19_ = earmark;
#line 296 "../lib/sudoku-game.vala"
					sudoku_board_disable_earmark (_tmp16_, (*_tmp17_).row, (*_tmp18_).col, (*_tmp19_).number);
#line 1525 "sudoku-game.c"
				}
#line 290 "../lib/sudoku-game.vala"
				_sudoku_game_earmark_change_free0 (earmark);
#line 1529 "sudoku-game.c"
			}
		}
	}
#line 299 "../lib/sudoku-game.vala"
	_tmp20_ = changes;
#line 299 "../lib/sudoku-game.vala"
	_tmp21_ = _tmp20_->values;
#line 299 "../lib/sudoku-game.vala"
	_tmp22_ = gee_abstract_list_list_iterator ((GeeAbstractList*) _tmp21_);
#line 299 "../lib/sudoku-game.vala"
	value_iterator = _tmp22_;
#line 1541 "sudoku-game.c"
	{
		gboolean has_next = FALSE;
		GeeListIterator* _tmp23_;
#line 300 "../lib/sudoku-game.vala"
		_tmp23_ = value_iterator;
#line 300 "../lib/sudoku-game.vala"
		has_next = gee_iterator_next ((GeeIterator*) _tmp23_);
#line 1549 "sudoku-game.c"
		{
			gboolean _tmp24_ = FALSE;
#line 300 "../lib/sudoku-game.vala"
			_tmp24_ = TRUE;
#line 300 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1556 "sudoku-game.c"
				SudokuGamevalue_change* val = NULL;
				GeeListIterator* _tmp26_;
				gpointer _tmp27_;
				SudokuBoard* _tmp28_;
				SudokuGamevalue_change* _tmp29_;
				SudokuGamevalue_change* _tmp30_;
				SudokuGamevalue_change* _tmp31_;
#line 300 "../lib/sudoku-game.vala"
				if (!_tmp24_) {
#line 1566 "sudoku-game.c"
					GeeListIterator* _tmp25_;
#line 300 "../lib/sudoku-game.vala"
					_tmp25_ = value_iterator;
#line 300 "../lib/sudoku-game.vala"
					has_next = gee_iterator_next ((GeeIterator*) _tmp25_);
#line 1572 "sudoku-game.c"
				}
#line 300 "../lib/sudoku-game.vala"
				_tmp24_ = FALSE;
#line 300 "../lib/sudoku-game.vala"
				if (!has_next) {
#line 300 "../lib/sudoku-game.vala"
					break;
#line 1580 "sudoku-game.c"
				}
#line 302 "../lib/sudoku-game.vala"
				_tmp26_ = value_iterator;
#line 302 "../lib/sudoku-game.vala"
				_tmp27_ = gee_iterator_get ((GeeIterator*) _tmp26_);
#line 302 "../lib/sudoku-game.vala"
				val = (SudokuGamevalue_change*) _tmp27_;
#line 303 "../lib/sudoku-game.vala"
				_tmp28_ = self->priv->_board;
#line 303 "../lib/sudoku-game.vala"
				_tmp29_ = val;
#line 303 "../lib/sudoku-game.vala"
				_tmp30_ = val;
#line 303 "../lib/sudoku-game.vala"
				_tmp31_ = val;
#line 303 "../lib/sudoku-game.vala"
				sudoku_board_set (_tmp28_, (*_tmp29_).row, (*_tmp30_).col, (*_tmp31_).new_val);
#line 300 "../lib/sudoku-game.vala"
				_sudoku_game_value_change_free0 (val);
#line 1600 "sudoku-game.c"
			}
		}
	}
#line 306 "../lib/sudoku-game.vala"
	_tmp32_ = self->priv->stack;
#line 306 "../lib/sudoku-game.vala"
	_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, self->priv->stack_head_index);
#line 306 "../lib/sudoku-game.vala"
	_tmp34_ = (SudokuGamestack_item*) _tmp33_;
#line 306 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp34_->action);
#line 306 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (_tmp34_);
#line 283 "../lib/sudoku-game.vala"
	_g_object_unref0 (value_iterator);
#line 283 "../lib/sudoku-game.vala"
	_g_object_unref0 (earmark_iterator);
#line 283 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (changes);
#line 1620 "sudoku-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 314 "../lib/sudoku-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 1628 "sudoku-game.c"
}

void
sudoku_game_enable_all_earmark_possibilities (SudokuGame* self)
{
	gint* cells = NULL;
	SudokuBoard* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint* _tmp3_;
	gint cells_length1;
	gint cells_length2;
	SudokuGamestack_item* new_stack_item = NULL;
	SudokuGamestack_item* _tmp4_;
	gint head_backup = 0;
	GeeArrayList* stack_backup = NULL;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	SudokuGamestack_item* _tmp7_;
	SudokuGamestack_item* _tmp31_;
	GeeArrayList* _tmp32_;
	gint _tmp33_;
	gint _tmp34_;
#line 309 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 311 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 311 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_cells (_tmp0_, &_tmp1_, &_tmp2_);
#line 311 "../lib/sudoku-game.vala"
	cells = _tmp3_;
#line 311 "../lib/sudoku-game.vala"
	cells_length1 = _tmp1_;
#line 311 "../lib/sudoku-game.vala"
	cells_length2 = _tmp2_;
#line 312 "../lib/sudoku-game.vala"
	_tmp4_ = sudoku_game_stack_item_new (STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES);
#line 312 "../lib/sudoku-game.vala"
	new_stack_item = _tmp4_;
#line 313 "../lib/sudoku-game.vala"
	head_backup = self->priv->stack_head_index;
#line 314 "../lib/sudoku-game.vala"
	_tmp5_ = self->priv->stack;
#line 314 "../lib/sudoku-game.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 314 "../lib/sudoku-game.vala"
	stack_backup = _tmp6_;
#line 315 "../lib/sudoku-game.vala"
	_tmp7_ = new_stack_item;
#line 315 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp7_);
#line 1680 "sudoku-game.c"
	{
		gint row = 0;
#line 317 "../lib/sudoku-game.vala"
		row = 0;
#line 1685 "sudoku-game.c"
		{
			gboolean _tmp8_ = FALSE;
#line 317 "../lib/sudoku-game.vala"
			_tmp8_ = TRUE;
#line 317 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1692 "sudoku-game.c"
				SudokuBoard* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 317 "../lib/sudoku-game.vala"
				if (!_tmp8_) {
#line 1698 "sudoku-game.c"
					gint _tmp9_;
#line 317 "../lib/sudoku-game.vala"
					_tmp9_ = row;
#line 317 "../lib/sudoku-game.vala"
					row = _tmp9_ + 1;
#line 1704 "sudoku-game.c"
				}
#line 317 "../lib/sudoku-game.vala"
				_tmp8_ = FALSE;
#line 317 "../lib/sudoku-game.vala"
				_tmp10_ = self->priv->_board;
#line 317 "../lib/sudoku-game.vala"
				_tmp11_ = sudoku_board_get_rows (_tmp10_);
#line 317 "../lib/sudoku-game.vala"
				_tmp12_ = _tmp11_;
#line 317 "../lib/sudoku-game.vala"
				if (!(row < _tmp12_)) {
#line 317 "../lib/sudoku-game.vala"
					break;
#line 1718 "sudoku-game.c"
				}
				{
					gint col = 0;
#line 318 "../lib/sudoku-game.vala"
					col = 0;
#line 1724 "sudoku-game.c"
					{
						gboolean _tmp13_ = FALSE;
#line 318 "../lib/sudoku-game.vala"
						_tmp13_ = TRUE;
#line 318 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 1731 "sudoku-game.c"
							SudokuBoard* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							gint* _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							gint _tmp19_;
							gboolean* marks = NULL;
							SudokuBoard* _tmp20_;
							gint _tmp21_ = 0;
							gboolean* _tmp22_;
							gint marks_length1;
							gint _marks_size_;
#line 318 "../lib/sudoku-game.vala"
							if (!_tmp13_) {
#line 1747 "sudoku-game.c"
								gint _tmp14_;
#line 318 "../lib/sudoku-game.vala"
								_tmp14_ = col;
#line 318 "../lib/sudoku-game.vala"
								col = _tmp14_ + 1;
#line 1753 "sudoku-game.c"
							}
#line 318 "../lib/sudoku-game.vala"
							_tmp13_ = FALSE;
#line 318 "../lib/sudoku-game.vala"
							_tmp15_ = self->priv->_board;
#line 318 "../lib/sudoku-game.vala"
							_tmp16_ = sudoku_board_get_cols (_tmp15_);
#line 318 "../lib/sudoku-game.vala"
							_tmp17_ = _tmp16_;
#line 318 "../lib/sudoku-game.vala"
							if (!(col < _tmp17_)) {
#line 318 "../lib/sudoku-game.vala"
								break;
#line 1767 "sudoku-game.c"
							}
#line 320 "../lib/sudoku-game.vala"
							_tmp18_ = cells;
#line 320 "../lib/sudoku-game.vala"
							_tmp18__length1 = cells_length1;
#line 320 "../lib/sudoku-game.vala"
							_tmp18__length2 = cells_length2;
#line 320 "../lib/sudoku-game.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 320 "../lib/sudoku-game.vala"
							if (_tmp19_ != 0) {
#line 321 "../lib/sudoku-game.vala"
								continue;
#line 1781 "sudoku-game.c"
							}
#line 323 "../lib/sudoku-game.vala"
							_tmp20_ = self->priv->_board;
#line 323 "../lib/sudoku-game.vala"
							_tmp22_ = sudoku_board_get_possibilities_as_bool_array (_tmp20_, row, col, &_tmp21_);
#line 323 "../lib/sudoku-game.vala"
							marks = _tmp22_;
#line 323 "../lib/sudoku-game.vala"
							marks_length1 = _tmp21_;
#line 323 "../lib/sudoku-game.vala"
							_marks_size_ = marks_length1;
#line 1793 "sudoku-game.c"
							{
								gint num = 0;
#line 324 "../lib/sudoku-game.vala"
								num = 1;
#line 1798 "sudoku-game.c"
								{
									gboolean _tmp23_ = FALSE;
#line 324 "../lib/sudoku-game.vala"
									_tmp23_ = TRUE;
#line 324 "../lib/sudoku-game.vala"
									while (TRUE) {
#line 1805 "sudoku-game.c"
										gboolean _tmp25_ = FALSE;
										gboolean* _tmp26_;
										gint _tmp26__length1;
										gboolean _tmp27_;
#line 324 "../lib/sudoku-game.vala"
										if (!_tmp23_) {
#line 1812 "sudoku-game.c"
											gint _tmp24_;
#line 324 "../lib/sudoku-game.vala"
											_tmp24_ = num;
#line 324 "../lib/sudoku-game.vala"
											num = _tmp24_ + 1;
#line 1818 "sudoku-game.c"
										}
#line 324 "../lib/sudoku-game.vala"
										_tmp23_ = FALSE;
#line 324 "../lib/sudoku-game.vala"
										if (!(num <= 9)) {
#line 324 "../lib/sudoku-game.vala"
											break;
#line 1826 "sudoku-game.c"
										}
#line 326 "../lib/sudoku-game.vala"
										_tmp26_ = marks;
#line 326 "../lib/sudoku-game.vala"
										_tmp26__length1 = marks_length1;
#line 326 "../lib/sudoku-game.vala"
										_tmp27_ = _tmp26_[num - 1];
#line 326 "../lib/sudoku-game.vala"
										if (_tmp27_) {
#line 1836 "sudoku-game.c"
											SudokuBoard* _tmp28_;
#line 326 "../lib/sudoku-game.vala"
											_tmp28_ = self->priv->_board;
#line 326 "../lib/sudoku-game.vala"
											_tmp25_ = !sudoku_board_is_earmark_enabled (_tmp28_, row, col, num);
#line 1842 "sudoku-game.c"
										} else {
#line 326 "../lib/sudoku-game.vala"
											_tmp25_ = FALSE;
#line 1846 "sudoku-game.c"
										}
#line 326 "../lib/sudoku-game.vala"
										if (_tmp25_) {
#line 1850 "sudoku-game.c"
											SudokuGamestack_item* _tmp29_;
											SudokuBoard* _tmp30_;
#line 328 "../lib/sudoku-game.vala"
											_tmp29_ = new_stack_item;
#line 328 "../lib/sudoku-game.vala"
											sudoku_game_add_earmark_step (self, _tmp29_, row, col, num, TRUE);
#line 329 "../lib/sudoku-game.vala"
											_tmp30_ = self->priv->_board;
#line 329 "../lib/sudoku-game.vala"
											sudoku_board_enable_earmark (_tmp30_, row, col, num);
#line 1861 "sudoku-game.c"
										}
									}
								}
							}
#line 318 "../lib/sudoku-game.vala"
							marks = (g_free (marks), NULL);
#line 1868 "sudoku-game.c"
						}
					}
				}
			}
		}
	}
#line 334 "../lib/sudoku-game.vala"
	_tmp31_ = new_stack_item;
#line 334 "../lib/sudoku-game.vala"
	_tmp32_ = _tmp31_->earmarks;
#line 334 "../lib/sudoku-game.vala"
	_tmp33_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp32_);
#line 334 "../lib/sudoku-game.vala"
	_tmp34_ = _tmp33_;
#line 334 "../lib/sudoku-game.vala"
	if (_tmp34_ == 0) {
#line 1885 "sudoku-game.c"
		GeeArrayList* _tmp35_;
		GeeArrayList* _tmp36_;
#line 336 "../lib/sudoku-game.vala"
		_tmp35_ = stack_backup;
#line 336 "../lib/sudoku-game.vala"
		_tmp36_ = _g_object_ref0 (_tmp35_);
#line 336 "../lib/sudoku-game.vala"
		_g_object_unref0 (self->priv->stack);
#line 336 "../lib/sudoku-game.vala"
		self->priv->stack = _tmp36_;
#line 337 "../lib/sudoku-game.vala"
		self->priv->stack_head_index = head_backup;
#line 1898 "sudoku-game.c"
	} else {
		SudokuGamestack_item* _tmp37_;
#line 340 "../lib/sudoku-game.vala"
		_tmp37_ = new_stack_item;
#line 340 "../lib/sudoku-game.vala"
		g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL], 0, _tmp37_->action);
#line 1905 "sudoku-game.c"
	}
#line 309 "../lib/sudoku-game.vala"
	_g_object_unref0 (stack_backup);
#line 309 "../lib/sudoku-game.vala"
	_sudoku_game_stack_item_unref0 (new_stack_item);
#line 309 "../lib/sudoku-game.vala"
	cells = (g_free (cells), NULL);
#line 1913 "sudoku-game.c"
}

void
sudoku_game_stack_slice (SudokuGame* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 344 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 346 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->stack;
#line 346 "../lib/sudoku-game.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 346 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 346 "../lib/sudoku-game.vala"
	if (self->priv->stack_head_index == (_tmp2_ - 1)) {
#line 347 "../lib/sudoku-game.vala"
		return;
#line 1934 "sudoku-game.c"
	}
#line 349 "../lib/sudoku-game.vala"
	if (self->priv->stack_head_index == -1) {
#line 1938 "sudoku-game.c"
		GeeArrayList* _tmp3_;
#line 350 "../lib/sudoku-game.vala"
		_tmp3_ = self->priv->stack;
#line 350 "../lib/sudoku-game.vala"
		gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp3_);
#line 1944 "sudoku-game.c"
	} else {
		GeeArrayList* _tmp4_;
		GeeList* _tmp5_;
#line 352 "../lib/sudoku-game.vala"
		_tmp4_ = self->priv->stack;
#line 352 "../lib/sudoku-game.vala"
		_tmp5_ = gee_abstract_list_slice ((GeeAbstractList*) _tmp4_, 0, self->priv->stack_head_index + 1);
#line 352 "../lib/sudoku-game.vala"
		_g_object_unref0 (self->priv->stack);
#line 352 "../lib/sudoku-game.vala"
		self->priv->stack = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ARRAY_LIST, GeeArrayList);
#line 1956 "sudoku-game.c"
	}
}

gdouble
sudoku_game_get_total_time_played (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimer* _tmp3_;
	gdouble result;
#line 355 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 357 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 357 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
#line 357 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 357 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->timer;
#line 357 "../lib/sudoku-game.vala"
	result = _tmp2_ + g_timer_elapsed (_tmp3_, NULL);
#line 357 "../lib/sudoku-game.vala"
	return result;
#line 1982 "sudoku-game.c"
}

static gboolean
_sudoku_game_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = sudoku_game_timeout_cb ((SudokuGame*) self);
#line 362 "../lib/sudoku-game.vala"
	return result;
#line 1992 "sudoku-game.c"
}

static gboolean
sudoku_game_timeout_cb (SudokuGame* self)
{
	gboolean result;
#line 360 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 362 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sudoku_game_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 363 "../lib/sudoku-game.vala"
	g_source_set_name_by_id (self->priv->clock_timeout, "[gnome-sudoku] timeout_cb");
#line 364 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 365 "../lib/sudoku-game.vala"
	result = FALSE;
#line 365 "../lib/sudoku-game.vala"
	return result;
#line 2011 "sudoku-game.c"
}

void
sudoku_game_start_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp2_;
#line 368 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 370 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 370 "../lib/sudoku-game.vala"
	if (_tmp0_ == NULL) {
#line 2025 "sudoku-game.c"
		GTimer* _tmp1_;
#line 371 "../lib/sudoku-game.vala"
		_tmp1_ = g_timer_new ();
#line 371 "../lib/sudoku-game.vala"
		_g_timer_destroy0 (self->priv->timer);
#line 371 "../lib/sudoku-game.vala"
		self->priv->timer = _tmp1_;
#line 2033 "sudoku-game.c"
	}
#line 372 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->timer;
#line 372 "../lib/sudoku-game.vala"
	g_timer_start (_tmp2_);
#line 373 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 2041 "sudoku-game.c"
}

void
sudoku_game_stop_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 376 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 376 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 376 "../lib/sudoku-game.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "timer != null");
#line 379 "../lib/sudoku-game.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 380 "../lib/sudoku-game.vala"
		g_source_remove (self->priv->clock_timeout);
#line 2059 "sudoku-game.c"
	}
#line 381 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = (guint) 0;
#line 382 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->timer;
#line 382 "../lib/sudoku-game.vala"
	g_timer_stop (_tmp1_);
#line 383 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 2069 "sudoku-game.c"
}

void
sudoku_game_resume_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 386 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 386 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->timer;
#line 386 "../lib/sudoku-game.vala"
	_vala_return_if_fail ((_tmp0_ != NULL) && (self->priv->clock_timeout == ((guint) 0)), "timer != null && clock_timeout == 0");
#line 389 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->timer;
#line 389 "../lib/sudoku-game.vala"
	g_timer_continue (_tmp1_);
#line 390 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 2089 "sudoku-game.c"
}

SudokuBoard*
sudoku_game_get_board (SudokuGame* self)
{
	SudokuBoard* result;
	SudokuBoard* _tmp0_;
#line 26 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->_board;
#line 26 "../lib/sudoku-game.vala"
	result = _tmp0_;
#line 26 "../lib/sudoku-game.vala"
	return result;
#line 2105 "sudoku-game.c"
}

static void
sudoku_game_set_board (SudokuGame* self,
                       SudokuBoard* value)
{
	SudokuBoard* old_value;
#line 26 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 26 "../lib/sudoku-game.vala"
	old_value = sudoku_game_get_board (self);
#line 26 "../lib/sudoku-game.vala"
	if (old_value != value) {
#line 2119 "sudoku-game.c"
		SudokuBoard* _tmp0_;
#line 26 "../lib/sudoku-game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../lib/sudoku-game.vala"
		_g_object_unref0 (self->priv->_board);
#line 26 "../lib/sudoku-game.vala"
		self->priv->_board = _tmp0_;
#line 26 "../lib/sudoku-game.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_BOARD_PROPERTY]);
#line 2129 "sudoku-game.c"
	}
}

GameMode
sudoku_game_get_mode (SudokuGame* self)
{
	GameMode result;
#line 27 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../lib/sudoku-game.vala"
	result = self->priv->_mode;
#line 27 "../lib/sudoku-game.vala"
	return result;
#line 2143 "sudoku-game.c"
}

void
sudoku_game_set_mode (SudokuGame* self,
                      GameMode value)
{
	GameMode old_value;
#line 27 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/sudoku-game.vala"
	old_value = sudoku_game_get_mode (self);
#line 27 "../lib/sudoku-game.vala"
	if (old_value != value) {
#line 27 "../lib/sudoku-game.vala"
		self->priv->_mode = value;
#line 27 "../lib/sudoku-game.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_MODE_PROPERTY]);
#line 2161 "sudoku-game.c"
	}
}

gboolean
sudoku_game_get_paused (SudokuGame* self)
{
	gboolean result;
#line 43 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "../lib/sudoku-game.vala"
	result = self->priv->_paused;
#line 43 "../lib/sudoku-game.vala"
	return result;
#line 2175 "sudoku-game.c"
}

void
sudoku_game_set_paused (SudokuGame* self,
                        gboolean value)
{
#line 38 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/sudoku-game.vala"
	self->priv->_paused = value;
#line 41 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL], 0);
#line 38 "../lib/sudoku-game.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY]);
#line 2190 "sudoku-game.c"
}

static SudokuGamestack_item*
sudoku_game_stack_item_construct (GType object_type,
                                  StackAction _action)
{
	SudokuGamestack_item* self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 67 "../lib/sudoku-game.vala"
	self = (SudokuGamestack_item*) g_type_create_instance (object_type);
#line 69 "../lib/sudoku-game.vala"
	self->action = _action;
#line 70 "../lib/sudoku-game.vala"
	_tmp0_ = gee_array_list_new (SUDOKU_GAME_TYPE_EARMARK_CHANGE, (GBoxedCopyFunc) sudoku_game_earmark_change_dup, (GDestroyNotify) sudoku_game_earmark_change_free, NULL, NULL, NULL);
#line 70 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->earmarks);
#line 70 "../lib/sudoku-game.vala"
	self->earmarks = _tmp0_;
#line 71 "../lib/sudoku-game.vala"
	_tmp1_ = gee_array_list_new (SUDOKU_GAME_TYPE_VALUE_CHANGE, (GBoxedCopyFunc) sudoku_game_value_change_dup, (GDestroyNotify) sudoku_game_value_change_free, NULL, NULL, NULL);
#line 71 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->values);
#line 71 "../lib/sudoku-game.vala"
	self->values = _tmp1_;
#line 67 "../lib/sudoku-game.vala"
	return self;
#line 2218 "sudoku-game.c"
}

static SudokuGamestack_item*
sudoku_game_stack_item_new (StackAction _action)
{
#line 67 "../lib/sudoku-game.vala"
	return sudoku_game_stack_item_construct (SUDOKU_GAME_TYPE_STACK_ITEM, _action);
#line 2226 "sudoku-game.c"
}

static void
sudoku_game_value_stack_item_init (GValue* value)
{
#line 62 "../lib/sudoku-game.vala"
	value->data[0].v_pointer = NULL;
#line 2234 "sudoku-game.c"
}

static void
sudoku_game_value_stack_item_free_value (GValue* value)
{
#line 62 "../lib/sudoku-game.vala"
	if (value->data[0].v_pointer) {
#line 62 "../lib/sudoku-game.vala"
		sudoku_game_stack_item_unref (value->data[0].v_pointer);
#line 2244 "sudoku-game.c"
	}
}

static void
sudoku_game_value_stack_item_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 62 "../lib/sudoku-game.vala"
	if (src_value->data[0].v_pointer) {
#line 62 "../lib/sudoku-game.vala"
		dest_value->data[0].v_pointer = sudoku_game_stack_item_ref (src_value->data[0].v_pointer);
#line 2256 "sudoku-game.c"
	} else {
#line 62 "../lib/sudoku-game.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2260 "sudoku-game.c"
	}
}

static gpointer
sudoku_game_value_stack_item_peek_pointer (const GValue* value)
{
#line 62 "../lib/sudoku-game.vala"
	return value->data[0].v_pointer;
#line 2269 "sudoku-game.c"
}

static gchar*
sudoku_game_value_stack_item_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 62 "../lib/sudoku-game.vala"
	if (collect_values[0].v_pointer) {
#line 2280 "sudoku-game.c"
		SudokuGamestack_item * object;
		object = collect_values[0].v_pointer;
#line 62 "../lib/sudoku-game.vala"
		if (object->parent_instance.g_class == NULL) {
#line 62 "../lib/sudoku-game.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2287 "sudoku-game.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 62 "../lib/sudoku-game.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2291 "sudoku-game.c"
		}
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = sudoku_game_stack_item_ref (object);
#line 2295 "sudoku-game.c"
	} else {
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = NULL;
#line 2299 "sudoku-game.c"
	}
#line 62 "../lib/sudoku-game.vala"
	return NULL;
#line 2303 "sudoku-game.c"
}

static gchar*
sudoku_game_value_stack_item_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	SudokuGamestack_item ** object_p;
	object_p = collect_values[0].v_pointer;
#line 62 "../lib/sudoku-game.vala"
	if (!object_p) {
#line 62 "../lib/sudoku-game.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2318 "sudoku-game.c"
	}
#line 62 "../lib/sudoku-game.vala"
	if (!value->data[0].v_pointer) {
#line 62 "../lib/sudoku-game.vala"
		*object_p = NULL;
#line 2324 "sudoku-game.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 62 "../lib/sudoku-game.vala"
		*object_p = value->data[0].v_pointer;
#line 2328 "sudoku-game.c"
	} else {
#line 62 "../lib/sudoku-game.vala"
		*object_p = sudoku_game_stack_item_ref (value->data[0].v_pointer);
#line 2332 "sudoku-game.c"
	}
#line 62 "../lib/sudoku-game.vala"
	return NULL;
#line 2336 "sudoku-game.c"
}

static GParamSpec*
sudoku_game_param_spec_stack_item (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	SudokuGameParamSpecstack_item* spec;
#line 62 "../lib/sudoku-game.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SUDOKU_GAME_TYPE_STACK_ITEM), NULL);
#line 62 "../lib/sudoku-game.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 62 "../lib/sudoku-game.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 62 "../lib/sudoku-game.vala"
	return G_PARAM_SPEC (spec);
#line 2355 "sudoku-game.c"
}

static gpointer
sudoku_game_value_get_stack_item (const GValue* value)
{
#line 62 "../lib/sudoku-game.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUDOKU_GAME_TYPE_STACK_ITEM), NULL);
#line 62 "../lib/sudoku-game.vala"
	return value->data[0].v_pointer;
#line 2365 "sudoku-game.c"
}

static void
sudoku_game_value_set_stack_item (GValue* value,
                                  gpointer v_object)
{
	SudokuGamestack_item * old;
#line 62 "../lib/sudoku-game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUDOKU_GAME_TYPE_STACK_ITEM));
#line 62 "../lib/sudoku-game.vala"
	old = value->data[0].v_pointer;
#line 62 "../lib/sudoku-game.vala"
	if (v_object) {
#line 62 "../lib/sudoku-game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SUDOKU_GAME_TYPE_STACK_ITEM));
#line 62 "../lib/sudoku-game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = v_object;
#line 62 "../lib/sudoku-game.vala"
		sudoku_game_stack_item_ref (value->data[0].v_pointer);
#line 2387 "sudoku-game.c"
	} else {
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = NULL;
#line 2391 "sudoku-game.c"
	}
#line 62 "../lib/sudoku-game.vala"
	if (old) {
#line 62 "../lib/sudoku-game.vala"
		sudoku_game_stack_item_unref (old);
#line 2397 "sudoku-game.c"
	}
}

static void
sudoku_game_value_take_stack_item (GValue* value,
                                   gpointer v_object)
{
	SudokuGamestack_item * old;
#line 62 "../lib/sudoku-game.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SUDOKU_GAME_TYPE_STACK_ITEM));
#line 62 "../lib/sudoku-game.vala"
	old = value->data[0].v_pointer;
#line 62 "../lib/sudoku-game.vala"
	if (v_object) {
#line 62 "../lib/sudoku-game.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SUDOKU_GAME_TYPE_STACK_ITEM));
#line 62 "../lib/sudoku-game.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = v_object;
#line 2418 "sudoku-game.c"
	} else {
#line 62 "../lib/sudoku-game.vala"
		value->data[0].v_pointer = NULL;
#line 2422 "sudoku-game.c"
	}
#line 62 "../lib/sudoku-game.vala"
	if (old) {
#line 62 "../lib/sudoku-game.vala"
		sudoku_game_stack_item_unref (old);
#line 2428 "sudoku-game.c"
	}
}

static void
sudoku_game_stack_item_class_init (SudokuGamestack_itemClass * klass,
                                   gpointer klass_data)
{
#line 62 "../lib/sudoku-game.vala"
	sudoku_game_stack_item_parent_class = g_type_class_peek_parent (klass);
#line 62 "../lib/sudoku-game.vala"
	((SudokuGamestack_itemClass *) klass)->finalize = sudoku_game_stack_item_finalize;
#line 2440 "sudoku-game.c"
}

static void
sudoku_game_stack_item_instance_init (SudokuGamestack_item * self,
                                      gpointer klass)
{
#line 62 "../lib/sudoku-game.vala"
	self->ref_count = 1;
#line 2449 "sudoku-game.c"
}

static void
sudoku_game_stack_item_finalize (SudokuGamestack_item * obj)
{
	SudokuGamestack_item * self;
#line 62 "../lib/sudoku-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SUDOKU_GAME_TYPE_STACK_ITEM, SudokuGamestack_item);
#line 62 "../lib/sudoku-game.vala"
	g_signal_handlers_destroy (self);
#line 64 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->earmarks);
#line 65 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->values);
#line 2464 "sudoku-game.c"
}

static GType
sudoku_game_stack_item_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { sudoku_game_value_stack_item_init, sudoku_game_value_stack_item_free_value, sudoku_game_value_stack_item_copy_value, sudoku_game_value_stack_item_peek_pointer, "p", sudoku_game_value_stack_item_collect_value, "p", sudoku_game_value_stack_item_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (SudokuGamestack_itemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_stack_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGamestack_item), 0, (GInstanceInitFunc) sudoku_game_stack_item_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType sudoku_game_stack_item_type_id;
	sudoku_game_stack_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SudokuGamestack_item", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return sudoku_game_stack_item_type_id;
}

static GType
sudoku_game_stack_item_get_type (void)
{
	static volatile gsize sudoku_game_stack_item_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_stack_item_type_id__once)) {
		GType sudoku_game_stack_item_type_id;
		sudoku_game_stack_item_type_id = sudoku_game_stack_item_get_type_once ();
		g_once_init_leave (&sudoku_game_stack_item_type_id__once, sudoku_game_stack_item_type_id);
	}
	return sudoku_game_stack_item_type_id__once;
}

static gpointer
sudoku_game_stack_item_ref (gpointer instance)
{
	SudokuGamestack_item * self;
	self = instance;
#line 62 "../lib/sudoku-game.vala"
	g_atomic_int_inc (&self->ref_count);
#line 62 "../lib/sudoku-game.vala"
	return instance;
#line 2499 "sudoku-game.c"
}

static void
sudoku_game_stack_item_unref (gpointer instance)
{
	SudokuGamestack_item * self;
	self = instance;
#line 62 "../lib/sudoku-game.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 62 "../lib/sudoku-game.vala"
		SUDOKU_GAME_STACK_ITEM_GET_CLASS (self)->finalize (self);
#line 62 "../lib/sudoku-game.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2513 "sudoku-game.c"
	}
}

static SudokuGameearmark_change*
sudoku_game_earmark_change_dup (const SudokuGameearmark_change* self)
{
	SudokuGameearmark_change* dup;
#line 46 "../lib/sudoku-game.vala"
	dup = g_new0 (SudokuGameearmark_change, 1);
#line 46 "../lib/sudoku-game.vala"
	memcpy (dup, self, sizeof (SudokuGameearmark_change));
#line 46 "../lib/sudoku-game.vala"
	return dup;
#line 2527 "sudoku-game.c"
}

static void
sudoku_game_earmark_change_free (SudokuGameearmark_change* self)
{
#line 46 "../lib/sudoku-game.vala"
	g_free (self);
#line 2535 "sudoku-game.c"
}

static GType
sudoku_game_earmark_change_get_type_once (void)
{
	GType sudoku_game_earmark_change_type_id;
	sudoku_game_earmark_change_type_id = g_boxed_type_register_static ("SudokuGameearmark_change", (GBoxedCopyFunc) sudoku_game_earmark_change_dup, (GBoxedFreeFunc) sudoku_game_earmark_change_free);
	return sudoku_game_earmark_change_type_id;
}

static GType
sudoku_game_earmark_change_get_type (void)
{
	static volatile gsize sudoku_game_earmark_change_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_earmark_change_type_id__once)) {
		GType sudoku_game_earmark_change_type_id;
		sudoku_game_earmark_change_type_id = sudoku_game_earmark_change_get_type_once ();
		g_once_init_leave (&sudoku_game_earmark_change_type_id__once, sudoku_game_earmark_change_type_id);
	}
	return sudoku_game_earmark_change_type_id__once;
}

static SudokuGamevalue_change*
sudoku_game_value_change_dup (const SudokuGamevalue_change* self)
{
	SudokuGamevalue_change* dup;
#line 54 "../lib/sudoku-game.vala"
	dup = g_new0 (SudokuGamevalue_change, 1);
#line 54 "../lib/sudoku-game.vala"
	memcpy (dup, self, sizeof (SudokuGamevalue_change));
#line 54 "../lib/sudoku-game.vala"
	return dup;
#line 2568 "sudoku-game.c"
}

static void
sudoku_game_value_change_free (SudokuGamevalue_change* self)
{
#line 54 "../lib/sudoku-game.vala"
	g_free (self);
#line 2576 "sudoku-game.c"
}

static GType
sudoku_game_value_change_get_type_once (void)
{
	GType sudoku_game_value_change_type_id;
	sudoku_game_value_change_type_id = g_boxed_type_register_static ("SudokuGamevalue_change", (GBoxedCopyFunc) sudoku_game_value_change_dup, (GBoxedFreeFunc) sudoku_game_value_change_free);
	return sudoku_game_value_change_type_id;
}

static GType
sudoku_game_value_change_get_type (void)
{
	static volatile gsize sudoku_game_value_change_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_value_change_type_id__once)) {
		GType sudoku_game_value_change_type_id;
		sudoku_game_value_change_type_id = sudoku_game_value_change_get_type_once ();
		g_once_init_leave (&sudoku_game_value_change_type_id__once, sudoku_game_value_change_type_id);
	}
	return sudoku_game_value_change_type_id__once;
}

static void
sudoku_game_class_init (SudokuGameClass * klass,
                        gpointer klass_data)
{
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-game.vala"
	g_type_class_adjust_private_offset (klass, &SudokuGame_private_offset);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_game_get_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_game_set_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_BOARD_PROPERTY, sudoku_game_properties[SUDOKU_GAME_BOARD_PROPERTY] = g_param_spec_object ("board", "board", "board", TYPE_SUDOKU_BOARD, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_MODE_PROPERTY, sudoku_game_properties[SUDOKU_GAME_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", TYPE_GAME_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_PAUSED_PROPERTY, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL] = g_signal_new ("tick", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_ACTION_COMPLETED_SIGNAL] = g_signal_new ("action-completed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__ENUM, G_TYPE_NONE, 1, TYPE_STACK_ACTION);
#line 2625 "sudoku-game.c"
}

static void
sudoku_game_instance_init (SudokuGame * self,
                           gpointer klass)
{
#line 24 "../lib/sudoku-game.vala"
	self->priv = sudoku_game_get_instance_private (self);
#line 35 "../lib/sudoku-game.vala"
	self->priv->_paused = FALSE;
#line 76 "../lib/sudoku-game.vala"
	self->priv->stack_head_index = -1;
#line 2638 "sudoku-game.c"
}

static void
sudoku_game_finalize (GObject * obj)
{
	SudokuGame * self;
#line 24 "../lib/sudoku-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
#line 26 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->_board);
#line 28 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->priv->timer);
#line 75 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->stack);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
#line 2655 "sudoku-game.c"
}

static GType
sudoku_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
	GType sudoku_game_type_id;
	sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
	SudokuGame_private_offset = g_type_add_instance_private (sudoku_game_type_id, sizeof (SudokuGamePrivate));
	return sudoku_game_type_id;
}

GType
sudoku_game_get_type (void)
{
	static volatile gsize sudoku_game_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_type_id__once)) {
		GType sudoku_game_type_id;
		sudoku_game_type_id = sudoku_game_get_type_once ();
		g_once_init_leave (&sudoku_game_type_id__once, sudoku_game_type_id);
	}
	return sudoku_game_type_id__once;
}

static void
_vala_sudoku_game_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_BOARD_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_object (value, sudoku_game_get_board (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_MODE_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_enum (value, sudoku_game_get_mode (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_boolean (value, sudoku_game_get_paused (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 2708 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 2714 "sudoku-game.c"
	}
}

static void
_vala_sudoku_game_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_BOARD_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_board (self, g_value_get_object (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_MODE_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_mode (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_paused (self, g_value_get_boolean (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 2746 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 2752 "sudoku-game.c"
	}
}

static GType
game_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_MODE_NONE, "GAME_MODE_NONE", "none"}, {GAME_MODE_PLAY, "GAME_MODE_PLAY", "play"}, {GAME_MODE_CREATE, "GAME_MODE_CREATE", "create"}, {0, NULL, NULL}};
	GType game_mode_type_id;
	game_mode_type_id = g_enum_register_static ("GameMode", values);
	return game_mode_type_id;
}

GType
game_mode_get_type (void)
{
	static volatile gsize game_mode_type_id__once = 0;
	if (g_once_init_enter (&game_mode_type_id__once)) {
		GType game_mode_type_id;
		game_mode_type_id = game_mode_get_type_once ();
		g_once_init_leave (&game_mode_type_id__once, game_mode_type_id);
	}
	return game_mode_type_id__once;
}

gboolean
stack_action_is_single_value_change (StackAction self)
{
	gboolean result;
#line 415 "../lib/sudoku-game.vala"
	switch (self) {
#line 415 "../lib/sudoku-game.vala"
		case STACK_ACTION_INSERT:
#line 415 "../lib/sudoku-game.vala"
		case STACK_ACTION_REMOVE:
#line 415 "../lib/sudoku-game.vala"
		case STACK_ACTION_INSERT_AND_DISABLE_RELATED_EARMARKS:
#line 2789 "sudoku-game.c"
		{
#line 420 "../lib/sudoku-game.vala"
			result = TRUE;
#line 420 "../lib/sudoku-game.vala"
			return result;
#line 2795 "sudoku-game.c"
		}
		default:
		{
#line 422 "../lib/sudoku-game.vala"
			result = FALSE;
#line 422 "../lib/sudoku-game.vala"
			return result;
#line 2803 "sudoku-game.c"
		}
	}
}

gboolean
stack_action_is_single_earmarks_change (StackAction self)
{
	gboolean result;
#line 428 "../lib/sudoku-game.vala"
	switch (self) {
#line 428 "../lib/sudoku-game.vala"
		case STACK_ACTION_ENABLE_EARMARK:
#line 428 "../lib/sudoku-game.vala"
		case STACK_ACTION_DISABLE_EARMARK:
#line 428 "../lib/sudoku-game.vala"
		case STACK_ACTION_DISABLE_ALL_EARMARKS:
#line 2820 "sudoku-game.c"
		{
#line 433 "../lib/sudoku-game.vala"
			result = TRUE;
#line 433 "../lib/sudoku-game.vala"
			return result;
#line 2826 "sudoku-game.c"
		}
		default:
		{
#line 435 "../lib/sudoku-game.vala"
			result = FALSE;
#line 435 "../lib/sudoku-game.vala"
			return result;
#line 2834 "sudoku-game.c"
		}
	}
}

static GType
stack_action_get_type_once (void)
{
	static const GEnumValue values[] = {{STACK_ACTION_NONE, "STACK_ACTION_NONE", "none"}, {STACK_ACTION_INSERT, "STACK_ACTION_INSERT", "insert"}, {STACK_ACTION_REMOVE, "STACK_ACTION_REMOVE", "remove"}, {STACK_ACTION_ENABLE_EARMARK, "STACK_ACTION_ENABLE_EARMARK", "enable-earmark"}, {STACK_ACTION_DISABLE_EARMARK, "STACK_ACTION_DISABLE_EARMARK", "disable-earmark"}, {STACK_ACTION_DISABLE_ALL_EARMARKS, "STACK_ACTION_DISABLE_ALL_EARMARKS", "disable-all-earmarks"}, {STACK_ACTION_INSERT_AND_DISABLE_RELATED_EARMARKS, "STACK_ACTION_INSERT_AND_DISABLE_RELATED_EARMARKS", "insert-and-disable-related-earmarks"}, {STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES, "STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES", "enable-all-earmark-possibilities"}, {STACK_ACTION_CLEAR_BOARD, "STACK_ACTION_CLEAR_BOARD", "clear-board"}, {0, NULL, NULL}};
	GType stack_action_type_id;
	stack_action_type_id = g_enum_register_static ("StackAction", values);
	return stack_action_type_id;
}

GType
stack_action_get_type (void)
{
	static volatile gsize stack_action_type_id__once = 0;
	if (g_once_init_enter (&stack_action_type_id__once)) {
		GType stack_action_type_id;
		stack_action_type_id = stack_action_get_type_once ();
		g_once_init_leave (&stack_action_type_id__once, stack_action_type_id);
	}
	return stack_action_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

