/* view.c generated by valac 0.56.17, the Vala compiler
 * generated from view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include "libsudoku.h"
#include <glib/gi18n-lib.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;
typedef enum  {
	ZOOM_LEVEL_SMALL = 1,
	ZOOM_LEVEL_MEDIUM = 2,
	ZOOM_LEVEL_LARGE = 3
} ZoomLevel;

#define TYPE_ZOOM_LEVEL (zoom_level_get_type ())

#define TYPE_SUDOKU_NUMBER_PICKER (sudoku_number_picker_get_type ())
#define SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPicker))
#define SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))
#define IS_SUDOKU_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_NUMBER_PICKER))
#define IS_SUDOKU_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_NUMBER_PICKER))
#define SUDOKU_NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_NUMBER_PICKER, SudokuNumberPickerClass))

typedef struct _SudokuNumberPicker SudokuNumberPicker;
typedef struct _SudokuNumberPickerClass SudokuNumberPickerClass;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SELECTED_ROW_PROPERTY,
	SUDOKU_VIEW_SELECTED_COL_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_HAS_SELECTION_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL,
	SUDOKU_VIEW_NUM_SIGNALS
};
static guint sudoku_view_signals[SUDOKU_VIEW_NUM_SIGNALS] = {0};

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	gboolean earmark_mode;
	gboolean autoclean_earmarks;
	gboolean number_picker_second_click;
	gboolean highlight_row_column;
	gboolean highlight_block;
	gboolean highlight_numbers;
	gdouble value_zoom_multiplier;
	ZoomLevel zoom_level;
	SudokuNumberPicker* number_picker;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	GSettings* settings;
	GtkEventControllerKey* key_controller;
	SudokuGame* game;
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	SudokuFrame* frame;
	GtkLabel* paused_label;
	gint _selected_row;
	gint _selected_col;
	gboolean _show_warnings;
	gboolean _show_earmark_warnings;
	gboolean _solution_warnings;
	gboolean _show_possibilities;
	gboolean _highlighter;
	gboolean _has_selection;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType zoom_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType sudoku_number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuNumberPicker, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuView* sudoku_view_new (SudokuGame* game,
                             GSettings* settings);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   SudokuGame* game,
                                   GSettings* settings);
VALA_EXTERN void sudoku_view_update_zoom (SudokuView* self,
                              ZoomLevel level);
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_new (SudokuGame* game);
VALA_EXTERN SudokuNumberPicker* sudoku_number_picker_construct (GType object_type,
                                                    SudokuGame* game);
static void __lambda5_ (SudokuView* self);
static void sudoku_view_mask_view (SudokuView* self);
static void sudoku_view_clear_all_warnings (SudokuView* self);
static void sudoku_view_unmask_view (SudokuView* self);
static void sudoku_view_update_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_has_selection (SudokuView* self,
                                    gboolean value);
static void ___lambda5__sudoku_game_paused_changed (SudokuGame* _sender,
                                             gpointer self);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame* game,
                             SudokuView* view);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame* game,
                                   SudokuView* view);
VALA_EXTERN void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static void sudoku_view_value_changed_cb (SudokuView* self,
                                   gint row,
                                   gint col,
                                   gint old_val,
                                   gint new_val);
static void _sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                               gint row,
                                                               gint col,
                                                               gint old_val,
                                                               gint new_val,
                                                               gpointer self);
static void sudoku_view_earmark_changed_cb (SudokuView* self,
                                     gint row,
                                     gint col,
                                     gint num,
                                     gboolean enabled);
static void _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                                   gint row,
                                                                   gint col,
                                                                   gint num,
                                                                   gboolean enabled,
                                                                   gpointer self);
static void sudoku_view_selection_changed_cb (SudokuView* self,
                                       gint old_row,
                                       gint old_col,
                                       gint new_row,
                                       gint new_col);
static void _sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                      gint old_row,
                                                                      gint old_col,
                                                                      gint new_row,
                                                                      gint new_col,
                                                                      gpointer self);
static gboolean sudoku_view_key_pressed_cb (SudokuView* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_row (SudokuView* self);
VALA_EXTERN gint sudoku_view_get_selected_col (SudokuView* self);
static SudokuCell* sudoku_view_get_selected_cell (SudokuView* self);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
static void sudoku_view_insert_key (SudokuView* self,
                             gint key,
                             GdkModifierType state);
VALA_EXTERN void sudoku_number_picker_show_value_picker (SudokuNumberPicker* self,
                                             SudokuCell* cell);
VALA_EXTERN void sudoku_number_picker_show_earmark_picker (SudokuNumberPicker* self,
                                               SudokuCell* cell);
static void sudoku_view_set_cell_highlighter (SudokuView* self,
                                       gint row,
                                       gint col,
                                       gboolean enabled);
VALA_EXTERN void sudoku_cell_update_value (SudokuCell* self);
static void sudoku_view_set_selected_value_highlighter (SudokuView* self,
                                                 gint val,
                                                 gboolean enabled);
VALA_EXTERN void sudoku_cell_set_highlight_number (SudokuCell* self,
                                       gboolean value);
static void sudoku_view_set_unselected_value_highlighter (SudokuView* self,
                                                   gint row,
                                                   gint col,
                                                   gint val,
                                                   gboolean enabled);
VALA_EXTERN void sudoku_cell_get_visible_earmark (SudokuCell* self,
                                      gint num);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_earmark_warnings (SudokuCell* self,
                                         gint num);
VALA_EXTERN void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
static void sudoku_view_set_selected_row (SudokuView* self,
                                   gint value);
static void sudoku_view_set_selected_col (SudokuView* self,
                                   gint value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_earmark_highlight (SudokuCell* self,
                                        gint val,
                                        gboolean enabled);
VALA_EXTERN void sudoku_cell_set_highlight_coord (SudokuCell* self,
                                      gboolean value);
VALA_EXTERN void sudoku_cell_check_value_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_earmarks_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_clear_warnings (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_paused (SudokuCell* self,
                             gboolean value);
VALA_EXTERN void sudoku_view_dismiss_picker (SudokuView* self);
static void sudoku_view_real_dispose (GObject* base);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_earmark_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                            gboolean value);
VALA_EXTERN gboolean sudoku_view_get_solution_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_solution_warnings (SudokuView* self,
                                        gboolean value);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
VALA_EXTERN gboolean sudoku_view_get_has_selection (SudokuView* self);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_out (ZoomLevel self);
VALA_EXTERN gboolean zoom_level_is_fully_zoomed_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_in (ZoomLevel self);
VALA_EXTERN ZoomLevel zoom_level_zoom_out (ZoomLevel self);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 58 "../src/view.vala"
	return self ? g_object_ref (self) : NULL;
#line 357 "view.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 93 "../src/view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 365 "view.c"
}

static void
__lambda5_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	GtkLabel* _tmp9_;
	SudokuGame* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	SudokuGame* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	SudokuGame* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 93 "../src/view.vala"
	_tmp0_ = self->priv->paused_label;
#line 93 "../src/view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 93 "../src/view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 93 "../src/view.vala"
	attr_list = _tmp2_;
#line 94 "../src/view.vala"
	_tmp3_ = attr_list;
#line 94 "../src/view.vala"
	if (_tmp3_ == NULL) {
#line 402 "view.c"
		PangoAttrList* _tmp4_;
#line 95 "../src/view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 95 "../src/view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 95 "../src/view.vala"
		attr_list = _tmp4_;
#line 410 "view.c"
	}
#line 97 "../src/view.vala"
	_tmp5_ = attr_list;
#line 97 "../src/view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 97 "../src/view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 101 "../src/view.vala"
	_tmp7_ = self->priv->paused_label;
#line 101 "../src/view.vala"
	_tmp8_ = attr_list;
#line 101 "../src/view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 102 "../src/view.vala"
	_tmp9_ = self->priv->paused_label;
#line 102 "../src/view.vala"
	_tmp10_ = self->priv->game;
#line 102 "../src/view.vala"
	_tmp11_ = sudoku_game_get_paused (_tmp10_);
#line 102 "../src/view.vala"
	_tmp12_ = _tmp11_;
#line 102 "../src/view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, _tmp12_);
#line 104 "../src/view.vala"
	_tmp13_ = self->priv->game;
#line 104 "../src/view.vala"
	_tmp14_ = sudoku_game_get_paused (_tmp13_);
#line 104 "../src/view.vala"
	_tmp15_ = _tmp14_;
#line 104 "../src/view.vala"
	if (_tmp15_) {
#line 106 "../src/view.vala"
		sudoku_view_mask_view (self);
#line 107 "../src/view.vala"
		sudoku_view_clear_all_warnings (self);
#line 446 "view.c"
	} else {
#line 111 "../src/view.vala"
		sudoku_view_unmask_view (self);
#line 112 "../src/view.vala"
		sudoku_view_update_warnings (self);
#line 452 "view.c"
	}
#line 115 "../src/view.vala"
	_tmp16_ = self->priv->game;
#line 115 "../src/view.vala"
	_tmp17_ = sudoku_game_get_paused (_tmp16_);
#line 115 "../src/view.vala"
	_tmp18_ = _tmp17_;
#line 115 "../src/view.vala"
	sudoku_view_set_has_selection (self, !_tmp18_);
#line 91 "../src/view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 464 "view.c"
}

static void
___lambda5__sudoku_game_paused_changed (SudokuGame* _sender,
                                        gpointer self)
{
#line 91 "../src/view.vala"
	__lambda5_ ((SudokuView*) self);
#line 473 "view.c"
}

static void
_sudoku_view_value_changed_cb_sudoku_board_value_changed (SudokuBoard* _sender,
                                                          gint row,
                                                          gint col,
                                                          gint old_val,
                                                          gint new_val,
                                                          gpointer self)
{
#line 158 "../src/view.vala"
	sudoku_view_value_changed_cb ((SudokuView*) self, row, col, old_val, new_val);
#line 486 "view.c"
}

static void
_sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed (SudokuBoard* _sender,
                                                              gint row,
                                                              gint col,
                                                              gint num,
                                                              gboolean enabled,
                                                              gpointer self)
{
#line 159 "../src/view.vala"
	sudoku_view_earmark_changed_cb ((SudokuView*) self, row, col, num, enabled);
#line 499 "view.c"
}

static void
_sudoku_view_selection_changed_cb_sudoku_view_selection_changed (SudokuView* _sender,
                                                                 gint old_row,
                                                                 gint old_col,
                                                                 gint new_row,
                                                                 gint new_col,
                                                                 gpointer self)
{
#line 160 "../src/view.vala"
	sudoku_view_selection_changed_cb ((SudokuView*) self, old_row, old_col, new_row, new_col);
#line 512 "view.c"
}

static gboolean
_sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_view_key_pressed_cb ((SudokuView*) self, keyval, keycode, state);
#line 163 "../src/view.vala"
	return result;
#line 526 "view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       SudokuGame* game,
                       GSettings* settings)
{
	SudokuView * self = NULL;
	SudokuGame* _tmp0_;
	GSettings* _tmp1_;
	GameMode _tmp2_;
	GameMode _tmp3_;
	GtkOverlay* overlay = NULL;
	GtkOverlay* _tmp4_;
	GtkOverlay* _tmp5_;
	SudokuFrame* _tmp6_;
	SudokuFrame* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	GtkOverlay* _tmp10_;
	GtkLabel* _tmp11_;
	GtkOverlay* _tmp12_;
	SudokuNumberPicker* _tmp13_;
	SudokuGame* _tmp14_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp15_ = NULL;
	GtkGrid* _tmp16_;
	GtkOverlay* _tmp17_;
	GtkGrid* _tmp18_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp19_;
	SudokuBoard* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	SudokuBoard* _tmp23_;
	SudokuBoard* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GtkGrid** _tmp27_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp51_;
	SudokuBoard* _tmp52_;
	gint _tmp53_;
	gint _tmp54_;
	SudokuBoard* _tmp55_;
	SudokuBoard* _tmp56_;
	gint _tmp57_;
	gint _tmp58_;
	SudokuCell** _tmp59_;
	SudokuGame* _tmp96_;
	SudokuBoard* _tmp97_;
	SudokuBoard* _tmp98_;
	SudokuGame* _tmp99_;
	SudokuBoard* _tmp100_;
	SudokuBoard* _tmp101_;
	GtkEventControllerKey* _tmp102_;
	GtkEventControllerKey* _tmp103_;
	GtkEventControllerKey* _tmp104_;
	GtkEventController* _tmp105_;
	gboolean _tmp106_ = FALSE;
	gboolean _tmp107_ = FALSE;
	gboolean _tmp108_;
	gboolean _tmp109_;
#line 56 "../src/view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 56 "../src/view.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 56 "../src/view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 58 "../src/view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 58 "../src/view.vala"
	_g_object_unref0 (self->priv->game);
#line 58 "../src/view.vala"
	self->priv->game = _tmp0_;
#line 59 "../src/view.vala"
	_tmp1_ = _g_object_ref0 (settings);
#line 59 "../src/view.vala"
	_g_object_unref0 (self->priv->settings);
#line 59 "../src/view.vala"
	self->priv->settings = _tmp1_;
#line 61 "../src/view.vala"
	_tmp2_ = sudoku_game_get_mode (game);
#line 61 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 61 "../src/view.vala"
	if (_tmp3_ == GAME_MODE_CREATE) {
#line 62 "../src/view.vala"
		self->priv->_show_warnings = TRUE;
#line 617 "view.c"
	} else {
#line 64 "../src/view.vala"
		self->priv->_show_warnings = g_settings_get_boolean (settings, "show-warnings");
#line 621 "view.c"
	}
#line 65 "../src/view.vala"
	self->priv->_show_possibilities = g_settings_get_boolean (settings, "show-possibilities");
#line 66 "../src/view.vala"
	self->priv->_solution_warnings = g_settings_get_boolean (settings, "solution-warnings");
#line 67 "../src/view.vala"
	self->priv->_show_earmark_warnings = g_settings_get_boolean (settings, "show-earmark-warnings");
#line 68 "../src/view.vala"
	self->priv->_highlighter = g_settings_get_boolean (settings, "highlighter");
#line 69 "../src/view.vala"
	self->number_picker_second_click = g_settings_get_boolean (settings, "number-picker-second-click");
#line 70 "../src/view.vala"
	self->autoclean_earmarks = g_settings_get_boolean (settings, "autoclean-earmarks");
#line 71 "../src/view.vala"
	self->highlight_row_column = g_settings_get_boolean (settings, "highlight-row-column");
#line 72 "../src/view.vala"
	self->highlight_block = g_settings_get_boolean (settings, "highlight-block");
#line 73 "../src/view.vala"
	self->highlight_numbers = g_settings_get_boolean (settings, "highlight-numbers");
#line 74 "../src/view.vala"
	self->zoom_level = (ZoomLevel) g_settings_get_enum (settings, "zoom-level");
#line 75 "../src/view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 76 "../src/view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 78 "../src/view.vala"
	sudoku_view_update_zoom (self, self->zoom_level);
#line 80 "../src/view.vala"
	_tmp4_ = (GtkOverlay*) gtk_overlay_new ();
#line 80 "../src/view.vala"
	g_object_ref_sink (_tmp4_);
#line 80 "../src/view.vala"
	overlay = _tmp4_;
#line 81 "../src/view.vala"
	_tmp5_ = overlay;
#line 81 "../src/view.vala"
	_tmp6_ = sudoku_frame_new ((GtkWidget*) _tmp5_);
#line 81 "../src/view.vala"
	g_object_ref_sink (_tmp6_);
#line 81 "../src/view.vala"
	_g_object_unref0 (self->priv->frame);
#line 81 "../src/view.vala"
	self->priv->frame = _tmp6_;
#line 82 "../src/view.vala"
	_tmp7_ = self->priv->frame;
#line 82 "../src/view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp7_);
#line 84 "../src/view.vala"
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Paused"));
#line 84 "../src/view.vala"
	g_object_ref_sink (_tmp8_);
#line 84 "../src/view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 84 "../src/view.vala"
	self->priv->paused_label = _tmp8_;
#line 85 "../src/view.vala"
	_tmp9_ = self->priv->paused_label;
#line 85 "../src/view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
#line 86 "../src/view.vala"
	_tmp10_ = overlay;
#line 86 "../src/view.vala"
	_tmp11_ = self->priv->paused_label;
#line 86 "../src/view.vala"
	gtk_overlay_add_overlay (_tmp10_, (GtkWidget*) _tmp11_);
#line 87 "../src/view.vala"
	_tmp12_ = overlay;
#line 87 "../src/view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "paused");
#line 89 "../src/view.vala"
	_tmp13_ = sudoku_number_picker_new (game);
#line 89 "../src/view.vala"
	g_object_ref_sink (_tmp13_);
#line 89 "../src/view.vala"
	_g_object_unref0 (self->number_picker);
#line 89 "../src/view.vala"
	self->number_picker = _tmp13_;
#line 91 "../src/view.vala"
	_tmp14_ = self->priv->game;
#line 91 "../src/view.vala"
	g_signal_connect_object (_tmp14_, "paused-changed", (GCallback) ___lambda5__sudoku_game_paused_changed, self, 0);
#line 118 "../src/view.vala"
	_tmp15_ = (GtkGrid*) gtk_grid_new ();
#line 118 "../src/view.vala"
	gtk_grid_set_row_spacing (_tmp15_, 2);
#line 118 "../src/view.vala"
	gtk_grid_set_column_spacing (_tmp15_, 2);
#line 118 "../src/view.vala"
	gtk_grid_set_column_homogeneous (_tmp15_, TRUE);
#line 118 "../src/view.vala"
	gtk_grid_set_row_homogeneous (_tmp15_, TRUE);
#line 118 "../src/view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp15_, TRUE);
#line 118 "../src/view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
#line 118 "../src/view.vala"
	g_object_ref_sink (_tmp15_);
#line 118 "../src/view.vala"
	grid = _tmp15_;
#line 126 "../src/view.vala"
	_tmp16_ = grid;
#line 126 "../src/view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp16_, "board");
#line 127 "../src/view.vala"
	_tmp17_ = overlay;
#line 127 "../src/view.vala"
	_tmp18_ = grid;
#line 127 "../src/view.vala"
	gtk_overlay_set_child (_tmp17_, (GtkWidget*) _tmp18_);
#line 129 "../src/view.vala"
	_tmp19_ = sudoku_game_get_board (game);
#line 129 "../src/view.vala"
	_tmp20_ = _tmp19_;
#line 129 "../src/view.vala"
	_tmp21_ = sudoku_board_get_block_rows (_tmp20_);
#line 129 "../src/view.vala"
	_tmp22_ = _tmp21_;
#line 129 "../src/view.vala"
	_tmp23_ = sudoku_game_get_board (game);
#line 129 "../src/view.vala"
	_tmp24_ = _tmp23_;
#line 129 "../src/view.vala"
	_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
#line 129 "../src/view.vala"
	_tmp26_ = _tmp25_;
#line 129 "../src/view.vala"
	_tmp27_ = g_new0 (GtkGrid*, (_tmp22_ * _tmp26_) + 1);
#line 129 "../src/view.vala"
	blocks = _tmp27_;
#line 129 "../src/view.vala"
	blocks_length1 = _tmp22_;
#line 129 "../src/view.vala"
	blocks_length2 = _tmp26_;
#line 755 "view.c"
	{
		gint block_row = 0;
#line 130 "../src/view.vala"
		block_row = 0;
#line 760 "view.c"
		{
			gboolean _tmp28_ = FALSE;
#line 130 "../src/view.vala"
			_tmp28_ = TRUE;
#line 130 "../src/view.vala"
			while (TRUE) {
#line 767 "view.c"
				SudokuBoard* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 130 "../src/view.vala"
				if (!_tmp28_) {
#line 774 "view.c"
					gint _tmp29_;
#line 130 "../src/view.vala"
					_tmp29_ = block_row;
#line 130 "../src/view.vala"
					block_row = _tmp29_ + 1;
#line 780 "view.c"
				}
#line 130 "../src/view.vala"
				_tmp28_ = FALSE;
#line 130 "../src/view.vala"
				_tmp30_ = sudoku_game_get_board (game);
#line 130 "../src/view.vala"
				_tmp31_ = _tmp30_;
#line 130 "../src/view.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 130 "../src/view.vala"
				_tmp33_ = _tmp32_;
#line 130 "../src/view.vala"
				if (!(block_row < _tmp33_)) {
#line 130 "../src/view.vala"
					break;
#line 796 "view.c"
				}
				{
					gint block_col = 0;
#line 132 "../src/view.vala"
					block_col = 0;
#line 802 "view.c"
					{
						gboolean _tmp34_ = FALSE;
#line 132 "../src/view.vala"
						_tmp34_ = TRUE;
#line 132 "../src/view.vala"
						while (TRUE) {
#line 809 "view.c"
							SudokuBoard* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp40_;
							GtkGrid* _tmp41_;
							GtkGrid* _tmp42_;
							GtkGrid* _tmp43_;
							GtkGrid* _tmp44_;
							GtkGrid* _tmp45_;
							GtkGrid* _tmp46_;
							GtkGrid* _tmp47_;
							GtkGrid** _tmp48_;
							gint _tmp48__length1;
							gint _tmp48__length2;
							GtkGrid* _tmp49_;
							GtkGrid* _tmp50_;
#line 132 "../src/view.vala"
							if (!_tmp34_) {
#line 830 "view.c"
								gint _tmp35_;
#line 132 "../src/view.vala"
								_tmp35_ = block_col;
#line 132 "../src/view.vala"
								block_col = _tmp35_ + 1;
#line 836 "view.c"
							}
#line 132 "../src/view.vala"
							_tmp34_ = FALSE;
#line 132 "../src/view.vala"
							_tmp36_ = sudoku_game_get_board (game);
#line 132 "../src/view.vala"
							_tmp37_ = _tmp36_;
#line 132 "../src/view.vala"
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
#line 132 "../src/view.vala"
							_tmp39_ = _tmp38_;
#line 132 "../src/view.vala"
							if (!(block_col < _tmp39_)) {
#line 132 "../src/view.vala"
								break;
#line 852 "view.c"
							}
#line 134 "../src/view.vala"
							_tmp40_ = (GtkGrid*) gtk_grid_new ();
#line 134 "../src/view.vala"
							g_object_ref_sink (_tmp40_);
#line 134 "../src/view.vala"
							block_grid = _tmp40_;
#line 135 "../src/view.vala"
							_tmp41_ = block_grid;
#line 135 "../src/view.vala"
							gtk_grid_set_row_spacing (_tmp41_, 1);
#line 136 "../src/view.vala"
							_tmp42_ = block_grid;
#line 136 "../src/view.vala"
							gtk_grid_set_column_spacing (_tmp42_, 1);
#line 137 "../src/view.vala"
							_tmp43_ = block_grid;
#line 137 "../src/view.vala"
							gtk_grid_set_column_homogeneous (_tmp43_, TRUE);
#line 138 "../src/view.vala"
							_tmp44_ = block_grid;
#line 138 "../src/view.vala"
							gtk_grid_set_row_homogeneous (_tmp44_, TRUE);
#line 139 "../src/view.vala"
							_tmp45_ = block_grid;
#line 139 "../src/view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "block");
#line 140 "../src/view.vala"
							_tmp46_ = grid;
#line 140 "../src/view.vala"
							_tmp47_ = block_grid;
#line 140 "../src/view.vala"
							gtk_grid_attach (_tmp46_, (GtkWidget*) _tmp47_, block_col, block_row, 1, 1);
#line 142 "../src/view.vala"
							_tmp48_ = blocks;
#line 142 "../src/view.vala"
							_tmp48__length1 = blocks_length1;
#line 142 "../src/view.vala"
							_tmp48__length2 = blocks_length2;
#line 142 "../src/view.vala"
							_tmp49_ = block_grid;
#line 142 "../src/view.vala"
							_tmp50_ = _g_object_ref0 (_tmp49_);
#line 142 "../src/view.vala"
							_g_object_unref0 (_tmp48_[(block_row * _tmp48__length2) + block_col]);
#line 142 "../src/view.vala"
							_tmp48_[(block_row * _tmp48__length2) + block_col] = _tmp50_;
#line 132 "../src/view.vala"
							_g_object_unref0 (block_grid);
#line 902 "view.c"
						}
					}
				}
			}
		}
	}
#line 146 "../src/view.vala"
	_tmp51_ = sudoku_game_get_board (game);
#line 146 "../src/view.vala"
	_tmp52_ = _tmp51_;
#line 146 "../src/view.vala"
	_tmp53_ = sudoku_board_get_rows (_tmp52_);
#line 146 "../src/view.vala"
	_tmp54_ = _tmp53_;
#line 146 "../src/view.vala"
	_tmp55_ = sudoku_game_get_board (game);
#line 146 "../src/view.vala"
	_tmp56_ = _tmp55_;
#line 146 "../src/view.vala"
	_tmp57_ = sudoku_board_get_cols (_tmp56_);
#line 146 "../src/view.vala"
	_tmp58_ = _tmp57_;
#line 146 "../src/view.vala"
	_tmp59_ = g_new0 (SudokuCell*, (_tmp54_ * _tmp58_) + 1);
#line 146 "../src/view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 146 "../src/view.vala"
	self->priv->cells = _tmp59_;
#line 146 "../src/view.vala"
	self->priv->cells_length1 = _tmp54_;
#line 146 "../src/view.vala"
	self->priv->cells_length2 = _tmp58_;
#line 935 "view.c"
	{
		gint row = 0;
#line 147 "../src/view.vala"
		row = 0;
#line 940 "view.c"
		{
			gboolean _tmp60_ = FALSE;
#line 147 "../src/view.vala"
			_tmp60_ = TRUE;
#line 147 "../src/view.vala"
			while (TRUE) {
#line 947 "view.c"
				SudokuBoard* _tmp62_;
				SudokuBoard* _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
#line 147 "../src/view.vala"
				if (!_tmp60_) {
#line 954 "view.c"
					gint _tmp61_;
#line 147 "../src/view.vala"
					_tmp61_ = row;
#line 147 "../src/view.vala"
					row = _tmp61_ + 1;
#line 960 "view.c"
				}
#line 147 "../src/view.vala"
				_tmp60_ = FALSE;
#line 147 "../src/view.vala"
				_tmp62_ = sudoku_game_get_board (game);
#line 147 "../src/view.vala"
				_tmp63_ = _tmp62_;
#line 147 "../src/view.vala"
				_tmp64_ = sudoku_board_get_rows (_tmp63_);
#line 147 "../src/view.vala"
				_tmp65_ = _tmp64_;
#line 147 "../src/view.vala"
				if (!(row < _tmp65_)) {
#line 147 "../src/view.vala"
					break;
#line 976 "view.c"
				}
				{
					gint col = 0;
#line 149 "../src/view.vala"
					col = 0;
#line 982 "view.c"
					{
						gboolean _tmp66_ = FALSE;
#line 149 "../src/view.vala"
						_tmp66_ = TRUE;
#line 149 "../src/view.vala"
						while (TRUE) {
#line 989 "view.c"
							SudokuBoard* _tmp68_;
							SudokuBoard* _tmp69_;
							gint _tmp70_;
							gint _tmp71_;
							SudokuCell* cell = NULL;
							SudokuCell* _tmp72_;
							SudokuCell* _tmp73_;
							GtkGrid** _tmp74_;
							gint _tmp74__length1;
							gint _tmp74__length2;
							SudokuBoard* _tmp75_;
							SudokuBoard* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
							SudokuBoard* _tmp79_;
							SudokuBoard* _tmp80_;
							gint _tmp81_;
							gint _tmp82_;
							GtkGrid* _tmp83_;
							SudokuCell* _tmp84_;
							SudokuBoard* _tmp85_;
							SudokuBoard* _tmp86_;
							gint _tmp87_;
							gint _tmp88_;
							SudokuBoard* _tmp89_;
							SudokuBoard* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							SudokuCell** _tmp93_;
							gint _tmp93__length1;
							gint _tmp93__length2;
							SudokuCell* _tmp94_;
							SudokuCell* _tmp95_;
#line 149 "../src/view.vala"
							if (!_tmp66_) {
#line 1025 "view.c"
								gint _tmp67_;
#line 149 "../src/view.vala"
								_tmp67_ = col;
#line 149 "../src/view.vala"
								col = _tmp67_ + 1;
#line 1031 "view.c"
							}
#line 149 "../src/view.vala"
							_tmp66_ = FALSE;
#line 149 "../src/view.vala"
							_tmp68_ = sudoku_game_get_board (game);
#line 149 "../src/view.vala"
							_tmp69_ = _tmp68_;
#line 149 "../src/view.vala"
							_tmp70_ = sudoku_board_get_cols (_tmp69_);
#line 149 "../src/view.vala"
							_tmp71_ = _tmp70_;
#line 149 "../src/view.vala"
							if (!(col < _tmp71_)) {
#line 149 "../src/view.vala"
								break;
#line 1047 "view.c"
							}
#line 151 "../src/view.vala"
							_tmp72_ = sudoku_cell_new (row, col, game, self);
#line 151 "../src/view.vala"
							g_object_ref_sink (_tmp72_);
#line 151 "../src/view.vala"
							cell = _tmp72_;
#line 152 "../src/view.vala"
							_tmp73_ = cell;
#line 152 "../src/view.vala"
							sudoku_cell_get_visible_earmarks (_tmp73_);
#line 153 "../src/view.vala"
							_tmp74_ = blocks;
#line 153 "../src/view.vala"
							_tmp74__length1 = blocks_length1;
#line 153 "../src/view.vala"
							_tmp74__length2 = blocks_length2;
#line 153 "../src/view.vala"
							_tmp75_ = sudoku_game_get_board (game);
#line 153 "../src/view.vala"
							_tmp76_ = _tmp75_;
#line 153 "../src/view.vala"
							_tmp77_ = sudoku_board_get_block_rows (_tmp76_);
#line 153 "../src/view.vala"
							_tmp78_ = _tmp77_;
#line 153 "../src/view.vala"
							_tmp79_ = sudoku_game_get_board (game);
#line 153 "../src/view.vala"
							_tmp80_ = _tmp79_;
#line 153 "../src/view.vala"
							_tmp81_ = sudoku_board_get_block_cols (_tmp80_);
#line 153 "../src/view.vala"
							_tmp82_ = _tmp81_;
#line 153 "../src/view.vala"
							_tmp83_ = _tmp74_[((row / _tmp78_) * _tmp74__length2) + (col / _tmp82_)];
#line 153 "../src/view.vala"
							_tmp84_ = cell;
#line 153 "../src/view.vala"
							_tmp85_ = sudoku_game_get_board (game);
#line 153 "../src/view.vala"
							_tmp86_ = _tmp85_;
#line 153 "../src/view.vala"
							_tmp87_ = sudoku_board_get_block_cols (_tmp86_);
#line 153 "../src/view.vala"
							_tmp88_ = _tmp87_;
#line 153 "../src/view.vala"
							_tmp89_ = sudoku_game_get_board (game);
#line 153 "../src/view.vala"
							_tmp90_ = _tmp89_;
#line 153 "../src/view.vala"
							_tmp91_ = sudoku_board_get_block_rows (_tmp90_);
#line 153 "../src/view.vala"
							_tmp92_ = _tmp91_;
#line 153 "../src/view.vala"
							gtk_grid_attach (_tmp83_, (GtkWidget*) _tmp84_, col % _tmp88_, row % _tmp92_, 1, 1);
#line 154 "../src/view.vala"
							_tmp93_ = self->priv->cells;
#line 154 "../src/view.vala"
							_tmp93__length1 = self->priv->cells_length1;
#line 154 "../src/view.vala"
							_tmp93__length2 = self->priv->cells_length2;
#line 154 "../src/view.vala"
							_tmp94_ = cell;
#line 154 "../src/view.vala"
							_tmp95_ = _g_object_ref0 (_tmp94_);
#line 154 "../src/view.vala"
							_g_object_unref0 (_tmp93_[(row * _tmp93__length2) + col]);
#line 154 "../src/view.vala"
							_tmp93_[(row * _tmp93__length2) + col] = _tmp95_;
#line 149 "../src/view.vala"
							_g_object_unref0 (cell);
#line 1119 "view.c"
						}
					}
				}
			}
		}
	}
#line 158 "../src/view.vala"
	_tmp96_ = self->priv->game;
#line 158 "../src/view.vala"
	_tmp97_ = sudoku_game_get_board (_tmp96_);
#line 158 "../src/view.vala"
	_tmp98_ = _tmp97_;
#line 158 "../src/view.vala"
	g_signal_connect_object (_tmp98_, "value-changed", (GCallback) _sudoku_view_value_changed_cb_sudoku_board_value_changed, self, 0);
#line 159 "../src/view.vala"
	_tmp99_ = self->priv->game;
#line 159 "../src/view.vala"
	_tmp100_ = sudoku_game_get_board (_tmp99_);
#line 159 "../src/view.vala"
	_tmp101_ = _tmp100_;
#line 159 "../src/view.vala"
	g_signal_connect_object (_tmp101_, "earmark-changed", (GCallback) _sudoku_view_earmark_changed_cb_sudoku_board_earmark_changed, self, 0);
#line 160 "../src/view.vala"
	g_signal_connect_object (self, "selection-changed", (GCallback) _sudoku_view_selection_changed_cb_sudoku_view_selection_changed, self, 0);
#line 162 "../src/view.vala"
	_tmp102_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 162 "../src/view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 162 "../src/view.vala"
	self->priv->key_controller = _tmp102_;
#line 163 "../src/view.vala"
	_tmp103_ = self->priv->key_controller;
#line 163 "../src/view.vala"
	g_signal_connect_object (_tmp103_, "key-pressed", (GCallback) _sudoku_view_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 164 "../src/view.vala"
	_tmp104_ = self->priv->key_controller;
#line 164 "../src/view.vala"
	_tmp105_ = _g_object_ref0 ((GtkEventController*) _tmp104_);
#line 164 "../src/view.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp105_);
#line 166 "../src/view.vala"
	_tmp108_ = sudoku_view_get_show_possibilities (self);
#line 166 "../src/view.vala"
	_tmp109_ = _tmp108_;
#line 166 "../src/view.vala"
	if (_tmp109_) {
#line 1166 "view.c"
		GameMode _tmp110_;
		GameMode _tmp111_;
#line 166 "../src/view.vala"
		_tmp110_ = sudoku_game_get_mode (game);
#line 166 "../src/view.vala"
		_tmp111_ = _tmp110_;
#line 166 "../src/view.vala"
		_tmp107_ = _tmp111_ != GAME_MODE_CREATE;
#line 1175 "view.c"
	} else {
#line 166 "../src/view.vala"
		_tmp107_ = FALSE;
#line 1179 "view.c"
	}
#line 166 "../src/view.vala"
	if (_tmp107_) {
#line 1183 "view.c"
		SudokuBoard* _tmp112_;
		SudokuBoard* _tmp113_;
		gdouble _tmp114_;
		gdouble _tmp115_;
#line 166 "../src/view.vala"
		_tmp112_ = sudoku_game_get_board (game);
#line 166 "../src/view.vala"
		_tmp113_ = _tmp112_;
#line 166 "../src/view.vala"
		_tmp114_ = sudoku_board_get_previous_played_time (_tmp113_);
#line 166 "../src/view.vala"
		_tmp115_ = _tmp114_;
#line 166 "../src/view.vala"
		_tmp106_ = _tmp115_ == 0.0;
#line 1198 "view.c"
	} else {
#line 166 "../src/view.vala"
		_tmp106_ = FALSE;
#line 1202 "view.c"
	}
#line 166 "../src/view.vala"
	if (_tmp106_) {
#line 167 "../src/view.vala"
		sudoku_game_enable_all_earmark_possibilities (game);
#line 1208 "view.c"
	}
#line 169 "../src/view.vala"
	sudoku_view_update_warnings (self);
#line 56 "../src/view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 56 "../src/view.vala"
	_g_object_unref0 (grid);
#line 56 "../src/view.vala"
	_g_object_unref0 (overlay);
#line 56 "../src/view.vala"
	return self;
#line 1220 "view.c"
}

SudokuView*
sudoku_view_new (SudokuGame* game,
                 GSettings* settings)
{
#line 56 "../src/view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, game, settings);
#line 1229 "view.c"
}

static gboolean
sudoku_view_key_pressed_cb (SudokuView* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	SudokuGame* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	SudokuCell* _tmp35_;
	SudokuCell* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean result;
#line 172 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 176 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 176 "../src/view.vala"
	_tmp1_ = sudoku_game_get_paused (_tmp0_);
#line 176 "../src/view.vala"
	_tmp2_ = _tmp1_;
#line 176 "../src/view.vala"
	if (_tmp2_) {
#line 177 "../src/view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 177 "../src/view.vala"
		return result;
#line 1260 "view.c"
	}
#line 179 "../src/view.vala"
	switch (keyval) {
#line 179 "../src/view.vala"
		case GDK_KEY_Up:
#line 179 "../src/view.vala"
		case GDK_KEY_w:
#line 179 "../src/view.vala"
		case GDK_KEY_KP_Up:
#line 1270 "view.c"
		{
			gint _tmp3_;
#line 182 "../src/view.vala"
			_tmp3_ = self->priv->_selected_row;
#line 182 "../src/view.vala"
			if (_tmp3_ == 0) {
#line 1277 "view.c"
				SudokuCell** _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp5_;
				SudokuCell* _tmp6_;
#line 183 "../src/view.vala"
				_tmp4_ = self->priv->cells;
#line 183 "../src/view.vala"
				_tmp4__length1 = self->priv->cells_length1;
#line 183 "../src/view.vala"
				_tmp4__length2 = self->priv->cells_length2;
#line 183 "../src/view.vala"
				_tmp5_ = self->priv->_selected_col;
#line 183 "../src/view.vala"
				_tmp6_ = _tmp4_[(8 * _tmp4__length2) + _tmp5_];
#line 183 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp6_);
#line 1295 "view.c"
			} else {
				SudokuCell** _tmp7_;
				gint _tmp7__length1;
				gint _tmp7__length2;
				gint _tmp8_;
				gint _tmp9_;
				SudokuCell* _tmp10_;
#line 185 "../src/view.vala"
				_tmp7_ = self->priv->cells;
#line 185 "../src/view.vala"
				_tmp7__length1 = self->priv->cells_length1;
#line 185 "../src/view.vala"
				_tmp7__length2 = self->priv->cells_length2;
#line 185 "../src/view.vala"
				_tmp8_ = self->priv->_selected_row;
#line 185 "../src/view.vala"
				_tmp9_ = self->priv->_selected_col;
#line 185 "../src/view.vala"
				_tmp10_ = _tmp7_[((_tmp8_ - 1) * _tmp7__length2) + _tmp9_];
#line 185 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 1317 "view.c"
			}
#line 186 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 186 "../src/view.vala"
			return result;
#line 1323 "view.c"
		}
#line 179 "../src/view.vala"
		case GDK_KEY_Down:
#line 179 "../src/view.vala"
		case GDK_KEY_s:
#line 179 "../src/view.vala"
		case GDK_KEY_KP_Down:
#line 1331 "view.c"
		{
			gint _tmp11_;
#line 189 "../src/view.vala"
			_tmp11_ = self->priv->_selected_row;
#line 189 "../src/view.vala"
			if (_tmp11_ == 8) {
#line 1338 "view.c"
				SudokuCell** _tmp12_;
				gint _tmp12__length1;
				gint _tmp12__length2;
				gint _tmp13_;
				SudokuCell* _tmp14_;
#line 190 "../src/view.vala"
				_tmp12_ = self->priv->cells;
#line 190 "../src/view.vala"
				_tmp12__length1 = self->priv->cells_length1;
#line 190 "../src/view.vala"
				_tmp12__length2 = self->priv->cells_length2;
#line 190 "../src/view.vala"
				_tmp13_ = self->priv->_selected_col;
#line 190 "../src/view.vala"
				_tmp14_ = _tmp12_[(0 * _tmp12__length2) + _tmp13_];
#line 190 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp14_);
#line 1356 "view.c"
			} else {
				SudokuCell** _tmp15_;
				gint _tmp15__length1;
				gint _tmp15__length2;
				gint _tmp16_;
				gint _tmp17_;
				SudokuCell* _tmp18_;
#line 192 "../src/view.vala"
				_tmp15_ = self->priv->cells;
#line 192 "../src/view.vala"
				_tmp15__length1 = self->priv->cells_length1;
#line 192 "../src/view.vala"
				_tmp15__length2 = self->priv->cells_length2;
#line 192 "../src/view.vala"
				_tmp16_ = self->priv->_selected_row;
#line 192 "../src/view.vala"
				_tmp17_ = self->priv->_selected_col;
#line 192 "../src/view.vala"
				_tmp18_ = _tmp15_[((_tmp16_ + 1) * _tmp15__length2) + _tmp17_];
#line 192 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp18_);
#line 1378 "view.c"
			}
#line 193 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 193 "../src/view.vala"
			return result;
#line 1384 "view.c"
		}
#line 179 "../src/view.vala"
		case GDK_KEY_Left:
#line 179 "../src/view.vala"
		case GDK_KEY_a:
#line 179 "../src/view.vala"
		case GDK_KEY_KP_Left:
#line 1392 "view.c"
		{
			gint _tmp19_;
#line 196 "../src/view.vala"
			_tmp19_ = self->priv->_selected_col;
#line 196 "../src/view.vala"
			if (_tmp19_ == 0) {
#line 1399 "view.c"
				SudokuCell** _tmp20_;
				gint _tmp20__length1;
				gint _tmp20__length2;
				gint _tmp21_;
				SudokuCell* _tmp22_;
#line 197 "../src/view.vala"
				_tmp20_ = self->priv->cells;
#line 197 "../src/view.vala"
				_tmp20__length1 = self->priv->cells_length1;
#line 197 "../src/view.vala"
				_tmp20__length2 = self->priv->cells_length2;
#line 197 "../src/view.vala"
				_tmp21_ = self->priv->_selected_row;
#line 197 "../src/view.vala"
				_tmp22_ = _tmp20_[(_tmp21_ * _tmp20__length2) + 8];
#line 197 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp22_);
#line 1417 "view.c"
			} else {
				SudokuCell** _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
				gint _tmp24_;
				gint _tmp25_;
				SudokuCell* _tmp26_;
#line 199 "../src/view.vala"
				_tmp23_ = self->priv->cells;
#line 199 "../src/view.vala"
				_tmp23__length1 = self->priv->cells_length1;
#line 199 "../src/view.vala"
				_tmp23__length2 = self->priv->cells_length2;
#line 199 "../src/view.vala"
				_tmp24_ = self->priv->_selected_row;
#line 199 "../src/view.vala"
				_tmp25_ = self->priv->_selected_col;
#line 199 "../src/view.vala"
				_tmp26_ = _tmp23_[(_tmp24_ * _tmp23__length2) + (_tmp25_ - 1)];
#line 199 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp26_);
#line 1439 "view.c"
			}
#line 200 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 200 "../src/view.vala"
			return result;
#line 1445 "view.c"
		}
#line 179 "../src/view.vala"
		case GDK_KEY_Right:
#line 179 "../src/view.vala"
		case GDK_KEY_d:
#line 179 "../src/view.vala"
		case GDK_KEY_KP_Right:
#line 1453 "view.c"
		{
			gint _tmp27_;
#line 203 "../src/view.vala"
			_tmp27_ = self->priv->_selected_col;
#line 203 "../src/view.vala"
			if (_tmp27_ == 8) {
#line 1460 "view.c"
				SudokuCell** _tmp28_;
				gint _tmp28__length1;
				gint _tmp28__length2;
				gint _tmp29_;
				SudokuCell* _tmp30_;
#line 204 "../src/view.vala"
				_tmp28_ = self->priv->cells;
#line 204 "../src/view.vala"
				_tmp28__length1 = self->priv->cells_length1;
#line 204 "../src/view.vala"
				_tmp28__length2 = self->priv->cells_length2;
#line 204 "../src/view.vala"
				_tmp29_ = self->priv->_selected_row;
#line 204 "../src/view.vala"
				_tmp30_ = _tmp28_[(_tmp29_ * _tmp28__length2) + 0];
#line 204 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp30_);
#line 1478 "view.c"
			} else {
				SudokuCell** _tmp31_;
				gint _tmp31__length1;
				gint _tmp31__length2;
				gint _tmp32_;
				gint _tmp33_;
				SudokuCell* _tmp34_;
#line 206 "../src/view.vala"
				_tmp31_ = self->priv->cells;
#line 206 "../src/view.vala"
				_tmp31__length1 = self->priv->cells_length1;
#line 206 "../src/view.vala"
				_tmp31__length2 = self->priv->cells_length2;
#line 206 "../src/view.vala"
				_tmp32_ = self->priv->_selected_row;
#line 206 "../src/view.vala"
				_tmp33_ = self->priv->_selected_col;
#line 206 "../src/view.vala"
				_tmp34_ = _tmp31_[(_tmp32_ * _tmp31__length2) + (_tmp33_ + 1)];
#line 206 "../src/view.vala"
				gtk_widget_grab_focus ((GtkWidget*) _tmp34_);
#line 1500 "view.c"
			}
#line 207 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 207 "../src/view.vala"
			return result;
#line 1506 "view.c"
		}
		default:
		{
#line 210 "../src/view.vala"
			break;
#line 1512 "view.c"
		}
	}
#line 213 "../src/view.vala"
	_tmp35_ = sudoku_view_get_selected_cell (self);
#line 213 "../src/view.vala"
	_tmp36_ = _tmp35_;
#line 213 "../src/view.vala"
	_tmp37_ = sudoku_cell_get_is_fixed (_tmp36_);
#line 213 "../src/view.vala"
	_tmp38_ = _tmp37_;
#line 213 "../src/view.vala"
	if (_tmp38_) {
#line 214 "../src/view.vala"
		result = GDK_EVENT_PROPAGATE;
#line 214 "../src/view.vala"
		return result;
#line 1529 "view.c"
	}
#line 216 "../src/view.vala"
	switch (keyval) {
#line 216 "../src/view.vala"
		case GDK_KEY_0:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_0:
#line 216 "../src/view.vala"
		case GDK_KEY_BackSpace:
#line 216 "../src/view.vala"
		case GDK_KEY_Delete:
#line 1541 "view.c"
		{
#line 219 "../src/view.vala"
			if (state == GDK_CONTROL_MASK) {
#line 220 "../src/view.vala"
				result = GDK_EVENT_PROPAGATE;
#line 220 "../src/view.vala"
				return result;
#line 1549 "view.c"
			} else {
				SudokuCell* _tmp39_;
				SudokuCell* _tmp40_;
#line 223 "../src/view.vala"
				_tmp39_ = sudoku_view_get_selected_cell (self);
#line 223 "../src/view.vala"
				_tmp40_ = _tmp39_;
#line 223 "../src/view.vala"
				sudoku_cell_set_value (_tmp40_, 0);
#line 224 "../src/view.vala"
				result = GDK_EVENT_STOP;
#line 224 "../src/view.vala"
				return result;
#line 1563 "view.c"
			}
		}
#line 216 "../src/view.vala"
		case GDK_KEY_1:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_1:
#line 1570 "view.c"
		{
#line 227 "../src/view.vala"
			sudoku_view_insert_key (self, 1, state);
#line 228 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 228 "../src/view.vala"
			return result;
#line 1578 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_2:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_2:
#line 1584 "view.c"
		{
#line 230 "../src/view.vala"
			sudoku_view_insert_key (self, 2, state);
#line 231 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 231 "../src/view.vala"
			return result;
#line 1592 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_3:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_3:
#line 1598 "view.c"
		{
#line 233 "../src/view.vala"
			sudoku_view_insert_key (self, 3, state);
#line 234 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 234 "../src/view.vala"
			return result;
#line 1606 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_4:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_4:
#line 1612 "view.c"
		{
#line 236 "../src/view.vala"
			sudoku_view_insert_key (self, 4, state);
#line 237 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 237 "../src/view.vala"
			return result;
#line 1620 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_5:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_5:
#line 1626 "view.c"
		{
#line 239 "../src/view.vala"
			sudoku_view_insert_key (self, 5, state);
#line 240 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 240 "../src/view.vala"
			return result;
#line 1634 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_6:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_6:
#line 1640 "view.c"
		{
#line 242 "../src/view.vala"
			sudoku_view_insert_key (self, 6, state);
#line 243 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 243 "../src/view.vala"
			return result;
#line 1648 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_7:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_7:
#line 1654 "view.c"
		{
#line 245 "../src/view.vala"
			sudoku_view_insert_key (self, 7, state);
#line 246 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 246 "../src/view.vala"
			return result;
#line 1662 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_8:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_8:
#line 1668 "view.c"
		{
#line 248 "../src/view.vala"
			sudoku_view_insert_key (self, 8, state);
#line 249 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 249 "../src/view.vala"
			return result;
#line 1676 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_9:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_9:
#line 1682 "view.c"
		{
#line 251 "../src/view.vala"
			sudoku_view_insert_key (self, 9, state);
#line 252 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 252 "../src/view.vala"
			return result;
#line 1690 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_Escape:
#line 1694 "view.c"
		{
			SudokuNumberPicker* _tmp41_;
#line 255 "../src/view.vala"
			_tmp41_ = self->number_picker;
#line 255 "../src/view.vala"
			gtk_popover_popdown ((GtkPopover*) _tmp41_);
#line 256 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 256 "../src/view.vala"
			return result;
#line 1705 "view.c"
		}
#line 216 "../src/view.vala"
		case GDK_KEY_space:
#line 216 "../src/view.vala"
		case GDK_KEY_Return:
#line 216 "../src/view.vala"
		case GDK_KEY_KP_Enter:
#line 1713 "view.c"
		{
			gboolean wants_value = FALSE;
#line 259 "../src/view.vala"
			wants_value = state != GDK_CONTROL_MASK;
#line 260 "../src/view.vala"
			wants_value = wants_value ^ self->earmark_mode;
#line 262 "../src/view.vala"
			if (wants_value) {
#line 1722 "view.c"
				SudokuNumberPicker* _tmp42_;
				SudokuCell* _tmp43_;
				SudokuCell* _tmp44_;
#line 263 "../src/view.vala"
				_tmp42_ = self->number_picker;
#line 263 "../src/view.vala"
				_tmp43_ = sudoku_view_get_selected_cell (self);
#line 263 "../src/view.vala"
				_tmp44_ = _tmp43_;
#line 263 "../src/view.vala"
				sudoku_number_picker_show_value_picker (_tmp42_, _tmp44_);
#line 1734 "view.c"
			} else {
				SudokuNumberPicker* _tmp45_;
				SudokuCell* _tmp46_;
				SudokuCell* _tmp47_;
#line 265 "../src/view.vala"
				_tmp45_ = self->number_picker;
#line 265 "../src/view.vala"
				_tmp46_ = sudoku_view_get_selected_cell (self);
#line 265 "../src/view.vala"
				_tmp47_ = _tmp46_;
#line 265 "../src/view.vala"
				sudoku_number_picker_show_earmark_picker (_tmp45_, _tmp47_);
#line 1747 "view.c"
			}
#line 267 "../src/view.vala"
			result = GDK_EVENT_STOP;
#line 267 "../src/view.vala"
			return result;
#line 1753 "view.c"
		}
		default:
		{
#line 270 "../src/view.vala"
			result = GDK_EVENT_PROPAGATE;
#line 270 "../src/view.vala"
			return result;
#line 1761 "view.c"
		}
	}
}

static void
sudoku_view_selection_changed_cb (SudokuView* self,
                                  gint old_row,
                                  gint old_col,
                                  gint new_row,
                                  gint new_col)
{
	SudokuNumberPicker* _tmp0_;
#line 274 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 276 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, old_row, old_col, FALSE);
#line 277 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, new_row, new_col, TRUE);
#line 278 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 278 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 1784 "view.c"
}

static void
sudoku_view_value_changed_cb (SudokuView* self,
                              gint row,
                              gint col,
                              gint old_val,
                              gint new_val)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	SudokuCell* _tmp2_;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
#line 281 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 283 "../src/view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 285 "../src/view.vala"
	_tmp1_ = self->priv->cells;
#line 285 "../src/view.vala"
	_tmp1__length1 = self->priv->cells_length1;
#line 285 "../src/view.vala"
	_tmp1__length2 = self->priv->cells_length2;
#line 285 "../src/view.vala"
	_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 285 "../src/view.vala"
	sudoku_cell_update_value (_tmp2_);
#line 286 "../src/view.vala"
	sudoku_view_update_warnings (self);
#line 288 "../src/view.vala"
	if (stack_action_is_single_value_change (action)) {
#line 1822 "view.c"
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuCell* _tmp4_;
#line 289 "../src/view.vala"
		_tmp3_ = self->priv->cells;
#line 289 "../src/view.vala"
		_tmp3__length1 = self->priv->cells_length1;
#line 289 "../src/view.vala"
		_tmp3__length2 = self->priv->cells_length2;
#line 289 "../src/view.vala"
		_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 289 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp4_);
#line 1837 "view.c"
	}
#line 292 "../src/view.vala"
	_tmp6_ = self->priv->_selected_row;
#line 292 "../src/view.vala"
	if (row == _tmp6_) {
#line 1843 "view.c"
		gint _tmp7_;
#line 292 "../src/view.vala"
		_tmp7_ = self->priv->_selected_col;
#line 292 "../src/view.vala"
		_tmp5_ = col == _tmp7_;
#line 1849 "view.c"
	} else {
#line 292 "../src/view.vala"
		_tmp5_ = FALSE;
#line 1853 "view.c"
	}
#line 292 "../src/view.vala"
	if (_tmp5_) {
#line 1857 "view.c"
		SudokuCell* _tmp8_;
		SudokuCell* _tmp9_;
#line 294 "../src/view.vala"
		sudoku_view_set_selected_value_highlighter (self, old_val, FALSE);
#line 295 "../src/view.vala"
		sudoku_view_set_selected_value_highlighter (self, new_val, TRUE);
#line 296 "../src/view.vala"
		_tmp8_ = sudoku_view_get_selected_cell (self);
#line 296 "../src/view.vala"
		_tmp9_ = _tmp8_;
#line 296 "../src/view.vala"
		sudoku_cell_set_highlight_number (_tmp9_, FALSE);
#line 1870 "view.c"
	} else {
#line 300 "../src/view.vala"
		sudoku_view_set_unselected_value_highlighter (self, row, col, old_val, FALSE);
#line 301 "../src/view.vala"
		sudoku_view_set_unselected_value_highlighter (self, row, col, new_val, TRUE);
#line 1876 "view.c"
	}
}

static void
sudoku_view_earmark_changed_cb (SudokuView* self,
                                gint row,
                                gint col,
                                gint num,
                                gboolean enabled)
{
	StackAction action = 0;
	SudokuGame* _tmp0_;
	SudokuCell** _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	SudokuCell* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 305 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 307 "../src/view.vala"
	_tmp0_ = self->priv->game;
#line 307 "../src/view.vala"
	action = sudoku_game_get_current_stack_action (_tmp0_);
#line 308 "../src/view.vala"
	if (stack_action_is_single_earmarks_change (action)) {
#line 1904 "view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 309 "../src/view.vala"
		_tmp1_ = self->priv->cells;
#line 309 "../src/view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 309 "../src/view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 309 "../src/view.vala"
		_tmp2_ = _tmp1_[(row * _tmp1__length2) + col];
#line 309 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp2_);
#line 1919 "view.c"
	}
#line 311 "../src/view.vala"
	_tmp3_ = self->priv->cells;
#line 311 "../src/view.vala"
	_tmp3__length1 = self->priv->cells_length1;
#line 311 "../src/view.vala"
	_tmp3__length2 = self->priv->cells_length2;
#line 311 "../src/view.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + col];
#line 311 "../src/view.vala"
	sudoku_cell_get_visible_earmark (_tmp4_, num);
#line 312 "../src/view.vala"
	_tmp6_ = sudoku_view_get_show_warnings (self);
#line 312 "../src/view.vala"
	_tmp7_ = _tmp6_;
#line 312 "../src/view.vala"
	if (_tmp7_) {
#line 312 "../src/view.vala"
		_tmp5_ = enabled;
#line 1939 "view.c"
	} else {
#line 312 "../src/view.vala"
		_tmp5_ = FALSE;
#line 1943 "view.c"
	}
#line 312 "../src/view.vala"
	if (_tmp5_) {
#line 1947 "view.c"
		SudokuCell** _tmp8_;
		gint _tmp8__length1;
		gint _tmp8__length2;
		SudokuCell* _tmp9_;
#line 313 "../src/view.vala"
		_tmp8_ = self->priv->cells;
#line 313 "../src/view.vala"
		_tmp8__length1 = self->priv->cells_length1;
#line 313 "../src/view.vala"
		_tmp8__length2 = self->priv->cells_length2;
#line 313 "../src/view.vala"
		_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 313 "../src/view.vala"
		sudoku_cell_check_earmark_warnings (_tmp9_, num);
#line 1962 "view.c"
	}
}

void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gint old_row = 0;
	gint _tmp6_;
	gint old_col = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	SudokuCell* _tmp10_;
	SudokuCell* _tmp11_;
#line 316 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 318 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 318 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 318 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 318 "../src/view.vala"
	_tmp1_ = _tmp0_[(cell_row * _tmp0__length2) + cell_col];
#line 318 "../src/view.vala"
	_tmp2_ = sudoku_cell_get_selected (_tmp1_);
#line 318 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 318 "../src/view.vala"
	if (_tmp3_ == TRUE) {
#line 319 "../src/view.vala"
		return;
#line 2005 "view.c"
	}
#line 321 "../src/view.vala"
	_tmp4_ = sudoku_view_get_selected_cell (self);
#line 321 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 321 "../src/view.vala"
	sudoku_cell_set_selected (_tmp5_, FALSE);
#line 323 "../src/view.vala"
	_tmp6_ = self->priv->_selected_row;
#line 323 "../src/view.vala"
	old_row = _tmp6_;
#line 324 "../src/view.vala"
	_tmp7_ = self->priv->_selected_col;
#line 324 "../src/view.vala"
	old_col = _tmp7_;
#line 326 "../src/view.vala"
	sudoku_view_set_selected_row (self, cell_row);
#line 327 "../src/view.vala"
	sudoku_view_set_selected_col (self, cell_col);
#line 329 "../src/view.vala"
	_tmp8_ = self->priv->_selected_row;
#line 329 "../src/view.vala"
	_tmp9_ = self->priv->_selected_col;
#line 329 "../src/view.vala"
	g_signal_emit (self, sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL], 0, old_row, old_col, _tmp8_, _tmp9_);
#line 331 "../src/view.vala"
	_tmp10_ = sudoku_view_get_selected_cell (self);
#line 331 "../src/view.vala"
	_tmp11_ = _tmp10_;
#line 331 "../src/view.vala"
	sudoku_cell_set_selected (_tmp11_, TRUE);
#line 2037 "view.c"
}

static void
sudoku_view_set_cell_highlighter (SudokuView* self,
                                  gint row,
                                  gint col,
                                  gboolean enabled)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	SudokuCell* cell = NULL;
	SudokuCell** _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	SudokuCell* _tmp3_;
	SudokuCell* _tmp4_;
#line 334 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 336 "../src/view.vala"
	_tmp0_ = sudoku_view_get_highlighter (self);
#line 336 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 336 "../src/view.vala"
	if (!_tmp1_) {
#line 337 "../src/view.vala"
		return;
#line 2064 "view.c"
	}
#line 339 "../src/view.vala"
	_tmp2_ = self->priv->cells;
#line 339 "../src/view.vala"
	_tmp2__length1 = self->priv->cells_length1;
#line 339 "../src/view.vala"
	_tmp2__length2 = self->priv->cells_length2;
#line 339 "../src/view.vala"
	_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 339 "../src/view.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 339 "../src/view.vala"
	cell = _tmp4_;
#line 2078 "view.c"
	{
		gint col_tmp = 0;
#line 341 "../src/view.vala"
		col_tmp = 0;
#line 2083 "view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 341 "../src/view.vala"
			_tmp5_ = TRUE;
#line 341 "../src/view.vala"
			while (TRUE) {
#line 2090 "view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				SudokuBoard* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
#line 341 "../src/view.vala"
				if (!_tmp5_) {
#line 2098 "view.c"
					gint _tmp6_;
#line 341 "../src/view.vala"
					_tmp6_ = col_tmp;
#line 341 "../src/view.vala"
					col_tmp = _tmp6_ + 1;
#line 2104 "view.c"
				}
#line 341 "../src/view.vala"
				_tmp5_ = FALSE;
#line 341 "../src/view.vala"
				_tmp7_ = self->priv->game;
#line 341 "../src/view.vala"
				_tmp8_ = sudoku_game_get_board (_tmp7_);
#line 341 "../src/view.vala"
				_tmp9_ = _tmp8_;
#line 341 "../src/view.vala"
				_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 341 "../src/view.vala"
				_tmp11_ = _tmp10_;
#line 341 "../src/view.vala"
				if (!(col_tmp < _tmp11_)) {
#line 341 "../src/view.vala"
					break;
#line 2122 "view.c"
				}
				{
					gint row_tmp = 0;
#line 343 "../src/view.vala"
					row_tmp = 0;
#line 2128 "view.c"
					{
						gboolean _tmp12_ = FALSE;
#line 343 "../src/view.vala"
						_tmp12_ = TRUE;
#line 343 "../src/view.vala"
						while (TRUE) {
#line 2135 "view.c"
							SudokuGame* _tmp14_;
							SudokuBoard* _tmp15_;
							SudokuBoard* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp19_;
							gint _tmp19__length1;
							gint _tmp19__length2;
							SudokuCell* _tmp20_;
							SudokuCell* _tmp21_;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							gboolean _tmp24_ = FALSE;
							SudokuCell* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gboolean _tmp42_ = FALSE;
							SudokuCell* _tmp43_;
							gboolean _tmp44_;
							gboolean _tmp45_;
#line 343 "../src/view.vala"
							if (!_tmp12_) {
#line 2159 "view.c"
								gint _tmp13_;
#line 343 "../src/view.vala"
								_tmp13_ = row_tmp;
#line 343 "../src/view.vala"
								row_tmp = _tmp13_ + 1;
#line 2165 "view.c"
							}
#line 343 "../src/view.vala"
							_tmp12_ = FALSE;
#line 343 "../src/view.vala"
							_tmp14_ = self->priv->game;
#line 343 "../src/view.vala"
							_tmp15_ = sudoku_game_get_board (_tmp14_);
#line 343 "../src/view.vala"
							_tmp16_ = _tmp15_;
#line 343 "../src/view.vala"
							_tmp17_ = sudoku_board_get_rows (_tmp16_);
#line 343 "../src/view.vala"
							_tmp18_ = _tmp17_;
#line 343 "../src/view.vala"
							if (!(row_tmp < _tmp18_)) {
#line 343 "../src/view.vala"
								break;
#line 2183 "view.c"
							}
#line 345 "../src/view.vala"
							_tmp19_ = self->priv->cells;
#line 345 "../src/view.vala"
							_tmp19__length1 = self->priv->cells_length1;
#line 345 "../src/view.vala"
							_tmp19__length2 = self->priv->cells_length2;
#line 345 "../src/view.vala"
							_tmp20_ = _tmp19_[(row_tmp * _tmp19__length2) + col_tmp];
#line 345 "../src/view.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 345 "../src/view.vala"
							cell_tmp = _tmp21_;
#line 347 "../src/view.vala"
							_tmp22_ = cell;
#line 347 "../src/view.vala"
							_tmp23_ = cell_tmp;
#line 347 "../src/view.vala"
							if (_tmp22_ == _tmp23_) {
#line 348 "../src/view.vala"
								_g_object_unref0 (cell_tmp);
#line 348 "../src/view.vala"
								continue;
#line 2207 "view.c"
							}
#line 350 "../src/view.vala"
							_tmp25_ = cell;
#line 350 "../src/view.vala"
							_tmp26_ = sudoku_cell_get_value (_tmp25_);
#line 350 "../src/view.vala"
							_tmp27_ = _tmp26_;
#line 350 "../src/view.vala"
							if (_tmp27_ > 0) {
#line 350 "../src/view.vala"
								_tmp24_ = self->highlight_numbers;
#line 2219 "view.c"
							} else {
#line 350 "../src/view.vala"
								_tmp24_ = FALSE;
#line 2223 "view.c"
							}
#line 350 "../src/view.vala"
							if (_tmp24_) {
#line 2227 "view.c"
								SudokuCell* _tmp28_;
								gint _tmp29_;
								gint _tmp30_;
								SudokuCell* _tmp31_;
								gint _tmp32_;
								gint _tmp33_;
#line 352 "../src/view.vala"
								_tmp28_ = cell;
#line 352 "../src/view.vala"
								_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 352 "../src/view.vala"
								_tmp30_ = _tmp29_;
#line 352 "../src/view.vala"
								_tmp31_ = cell_tmp;
#line 352 "../src/view.vala"
								_tmp32_ = sudoku_cell_get_value (_tmp31_);
#line 352 "../src/view.vala"
								_tmp33_ = _tmp32_;
#line 352 "../src/view.vala"
								if (_tmp30_ == _tmp33_) {
#line 2248 "view.c"
									SudokuCell* _tmp34_;
#line 353 "../src/view.vala"
									_tmp34_ = cell_tmp;
#line 353 "../src/view.vala"
									sudoku_cell_set_highlight_number (_tmp34_, enabled);
#line 2254 "view.c"
								} else {
									SudokuCell* _tmp35_;
									gint _tmp36_;
									gint _tmp37_;
#line 354 "../src/view.vala"
									_tmp35_ = cell_tmp;
#line 354 "../src/view.vala"
									_tmp36_ = sudoku_cell_get_value (_tmp35_);
#line 354 "../src/view.vala"
									_tmp37_ = _tmp36_;
#line 354 "../src/view.vala"
									if (_tmp37_ == 0) {
#line 2267 "view.c"
										SudokuCell* _tmp38_;
										SudokuCell* _tmp39_;
										gint _tmp40_;
										gint _tmp41_;
#line 355 "../src/view.vala"
										_tmp38_ = cell_tmp;
#line 355 "../src/view.vala"
										_tmp39_ = cell;
#line 355 "../src/view.vala"
										_tmp40_ = sudoku_cell_get_value (_tmp39_);
#line 355 "../src/view.vala"
										_tmp41_ = _tmp40_;
#line 355 "../src/view.vala"
										sudoku_cell_set_earmark_highlight (_tmp38_, _tmp41_, enabled);
#line 2282 "view.c"
									}
								}
							}
#line 358 "../src/view.vala"
							_tmp43_ = cell_tmp;
#line 358 "../src/view.vala"
							_tmp44_ = sudoku_cell_get_is_fixed (_tmp43_);
#line 358 "../src/view.vala"
							_tmp45_ = _tmp44_;
#line 358 "../src/view.vala"
							if (!_tmp45_) {
#line 2294 "view.c"
								gboolean _tmp46_ = FALSE;
								gboolean _tmp47_ = FALSE;
#line 359 "../src/view.vala"
								if (self->highlight_row_column) {
#line 2299 "view.c"
									gboolean _tmp48_ = FALSE;
#line 359 "../src/view.vala"
									if (row_tmp == row) {
#line 359 "../src/view.vala"
										_tmp48_ = TRUE;
#line 2305 "view.c"
									} else {
#line 359 "../src/view.vala"
										_tmp48_ = col_tmp == col;
#line 2309 "view.c"
									}
#line 359 "../src/view.vala"
									_tmp47_ = _tmp48_;
#line 2313 "view.c"
								} else {
#line 359 "../src/view.vala"
									_tmp47_ = FALSE;
#line 2317 "view.c"
								}
#line 359 "../src/view.vala"
								if (_tmp47_) {
#line 359 "../src/view.vala"
									_tmp46_ = TRUE;
#line 2323 "view.c"
								} else {
									gboolean _tmp49_ = FALSE;
									gboolean _tmp50_ = FALSE;
#line 360 "../src/view.vala"
									if (self->highlight_block) {
#line 2329 "view.c"
										SudokuGame* _tmp51_;
										SudokuBoard* _tmp52_;
										SudokuBoard* _tmp53_;
										gint _tmp54_;
										gint _tmp55_;
										SudokuGame* _tmp56_;
										SudokuBoard* _tmp57_;
										SudokuBoard* _tmp58_;
										gint _tmp59_;
										gint _tmp60_;
#line 361 "../src/view.vala"
										_tmp51_ = self->priv->game;
#line 361 "../src/view.vala"
										_tmp52_ = sudoku_game_get_board (_tmp51_);
#line 361 "../src/view.vala"
										_tmp53_ = _tmp52_;
#line 361 "../src/view.vala"
										_tmp54_ = sudoku_board_get_block_cols (_tmp53_);
#line 361 "../src/view.vala"
										_tmp55_ = _tmp54_;
#line 361 "../src/view.vala"
										_tmp56_ = self->priv->game;
#line 361 "../src/view.vala"
										_tmp57_ = sudoku_game_get_board (_tmp56_);
#line 361 "../src/view.vala"
										_tmp58_ = _tmp57_;
#line 361 "../src/view.vala"
										_tmp59_ = sudoku_board_get_block_cols (_tmp58_);
#line 361 "../src/view.vala"
										_tmp60_ = _tmp59_;
#line 361 "../src/view.vala"
										_tmp50_ = (row_tmp / _tmp55_) == (row / _tmp60_);
#line 2362 "view.c"
									} else {
#line 360 "../src/view.vala"
										_tmp50_ = FALSE;
#line 2366 "view.c"
									}
#line 360 "../src/view.vala"
									if (_tmp50_) {
#line 2370 "view.c"
										SudokuGame* _tmp61_;
										SudokuBoard* _tmp62_;
										SudokuBoard* _tmp63_;
										gint _tmp64_;
										gint _tmp65_;
										SudokuGame* _tmp66_;
										SudokuBoard* _tmp67_;
										SudokuBoard* _tmp68_;
										gint _tmp69_;
										gint _tmp70_;
#line 362 "../src/view.vala"
										_tmp61_ = self->priv->game;
#line 362 "../src/view.vala"
										_tmp62_ = sudoku_game_get_board (_tmp61_);
#line 362 "../src/view.vala"
										_tmp63_ = _tmp62_;
#line 362 "../src/view.vala"
										_tmp64_ = sudoku_board_get_block_rows (_tmp63_);
#line 362 "../src/view.vala"
										_tmp65_ = _tmp64_;
#line 362 "../src/view.vala"
										_tmp66_ = self->priv->game;
#line 362 "../src/view.vala"
										_tmp67_ = sudoku_game_get_board (_tmp66_);
#line 362 "../src/view.vala"
										_tmp68_ = _tmp67_;
#line 362 "../src/view.vala"
										_tmp69_ = sudoku_board_get_block_rows (_tmp68_);
#line 362 "../src/view.vala"
										_tmp70_ = _tmp69_;
#line 362 "../src/view.vala"
										_tmp49_ = (col_tmp / _tmp65_) == (col / _tmp70_);
#line 2403 "view.c"
									} else {
#line 360 "../src/view.vala"
										_tmp49_ = FALSE;
#line 2407 "view.c"
									}
#line 360 "../src/view.vala"
									_tmp46_ = _tmp49_;
#line 2411 "view.c"
								}
#line 359 "../src/view.vala"
								_tmp42_ = _tmp46_;
#line 2415 "view.c"
							} else {
#line 358 "../src/view.vala"
								_tmp42_ = FALSE;
#line 2419 "view.c"
							}
#line 358 "../src/view.vala"
							if (_tmp42_) {
#line 2423 "view.c"
								SudokuCell* _tmp71_;
#line 364 "../src/view.vala"
								_tmp71_ = cell_tmp;
#line 364 "../src/view.vala"
								sudoku_cell_set_highlight_coord (_tmp71_, enabled);
#line 2429 "view.c"
							}
#line 343 "../src/view.vala"
							_g_object_unref0 (cell_tmp);
#line 2433 "view.c"
						}
					}
				}
			}
		}
	}
#line 334 "../src/view.vala"
	_g_object_unref0 (cell);
#line 2442 "view.c"
}

static void
sudoku_view_set_selected_value_highlighter (SudokuView* self,
                                            gint val,
                                            gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 370 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 372 "../src/view.vala"
	_tmp2_ = sudoku_view_get_highlighter (self);
#line 372 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 372 "../src/view.vala"
	if (!_tmp3_) {
#line 372 "../src/view.vala"
		_tmp1_ = TRUE;
#line 2464 "view.c"
	} else {
#line 372 "../src/view.vala"
		_tmp1_ = val == 0;
#line 2468 "view.c"
	}
#line 372 "../src/view.vala"
	if (_tmp1_) {
#line 372 "../src/view.vala"
		_tmp0_ = TRUE;
#line 2474 "view.c"
	} else {
#line 372 "../src/view.vala"
		_tmp0_ = !self->highlight_numbers;
#line 2478 "view.c"
	}
#line 372 "../src/view.vala"
	if (_tmp0_) {
#line 373 "../src/view.vala"
		return;
#line 2484 "view.c"
	}
	{
		gint col_tmp = 0;
#line 375 "../src/view.vala"
		col_tmp = 0;
#line 2490 "view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 375 "../src/view.vala"
			_tmp4_ = TRUE;
#line 375 "../src/view.vala"
			while (TRUE) {
#line 2497 "view.c"
				SudokuGame* _tmp6_;
				SudokuBoard* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 375 "../src/view.vala"
				if (!_tmp4_) {
#line 2505 "view.c"
					gint _tmp5_;
#line 375 "../src/view.vala"
					_tmp5_ = col_tmp;
#line 375 "../src/view.vala"
					col_tmp = _tmp5_ + 1;
#line 2511 "view.c"
				}
#line 375 "../src/view.vala"
				_tmp4_ = FALSE;
#line 375 "../src/view.vala"
				_tmp6_ = self->priv->game;
#line 375 "../src/view.vala"
				_tmp7_ = sudoku_game_get_board (_tmp6_);
#line 375 "../src/view.vala"
				_tmp8_ = _tmp7_;
#line 375 "../src/view.vala"
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
#line 375 "../src/view.vala"
				_tmp10_ = _tmp9_;
#line 375 "../src/view.vala"
				if (!(col_tmp < _tmp10_)) {
#line 375 "../src/view.vala"
					break;
#line 2529 "view.c"
				}
				{
					gint row_tmp = 0;
#line 377 "../src/view.vala"
					row_tmp = 0;
#line 2535 "view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 377 "../src/view.vala"
						_tmp11_ = TRUE;
#line 377 "../src/view.vala"
						while (TRUE) {
#line 2542 "view.c"
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							SudokuBoard* _tmp15_;
							gint _tmp16_;
							gint _tmp17_;
							SudokuCell* cell_tmp = NULL;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
							SudokuCell* _tmp20_;
							SudokuCell* _tmp21_;
							SudokuCell* _tmp22_;
							SudokuCell* _tmp23_;
							SudokuCell* _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
#line 377 "../src/view.vala"
							if (!_tmp11_) {
#line 2562 "view.c"
								gint _tmp12_;
#line 377 "../src/view.vala"
								_tmp12_ = row_tmp;
#line 377 "../src/view.vala"
								row_tmp = _tmp12_ + 1;
#line 2568 "view.c"
							}
#line 377 "../src/view.vala"
							_tmp11_ = FALSE;
#line 377 "../src/view.vala"
							_tmp13_ = self->priv->game;
#line 377 "../src/view.vala"
							_tmp14_ = sudoku_game_get_board (_tmp13_);
#line 377 "../src/view.vala"
							_tmp15_ = _tmp14_;
#line 377 "../src/view.vala"
							_tmp16_ = sudoku_board_get_rows (_tmp15_);
#line 377 "../src/view.vala"
							_tmp17_ = _tmp16_;
#line 377 "../src/view.vala"
							if (!(row_tmp < _tmp17_)) {
#line 377 "../src/view.vala"
								break;
#line 2586 "view.c"
							}
#line 379 "../src/view.vala"
							_tmp18_ = self->priv->cells;
#line 379 "../src/view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 379 "../src/view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 379 "../src/view.vala"
							_tmp19_ = _tmp18_[(row_tmp * _tmp18__length2) + col_tmp];
#line 379 "../src/view.vala"
							_tmp20_ = _g_object_ref0 (_tmp19_);
#line 379 "../src/view.vala"
							cell_tmp = _tmp20_;
#line 381 "../src/view.vala"
							_tmp21_ = sudoku_view_get_selected_cell (self);
#line 381 "../src/view.vala"
							_tmp22_ = _tmp21_;
#line 381 "../src/view.vala"
							_tmp23_ = cell_tmp;
#line 381 "../src/view.vala"
							if (_tmp22_ == _tmp23_) {
#line 382 "../src/view.vala"
								_g_object_unref0 (cell_tmp);
#line 382 "../src/view.vala"
								continue;
#line 2612 "view.c"
							}
#line 384 "../src/view.vala"
							_tmp24_ = cell_tmp;
#line 384 "../src/view.vala"
							_tmp25_ = sudoku_cell_get_value (_tmp24_);
#line 384 "../src/view.vala"
							_tmp26_ = _tmp25_;
#line 384 "../src/view.vala"
							if (val == _tmp26_) {
#line 2622 "view.c"
								SudokuCell* _tmp27_;
#line 385 "../src/view.vala"
								_tmp27_ = cell_tmp;
#line 385 "../src/view.vala"
								sudoku_cell_set_highlight_number (_tmp27_, enabled);
#line 2628 "view.c"
							} else {
								SudokuCell* _tmp28_;
								gint _tmp29_;
								gint _tmp30_;
#line 386 "../src/view.vala"
								_tmp28_ = cell_tmp;
#line 386 "../src/view.vala"
								_tmp29_ = sudoku_cell_get_value (_tmp28_);
#line 386 "../src/view.vala"
								_tmp30_ = _tmp29_;
#line 386 "../src/view.vala"
								if (_tmp30_ == 0) {
#line 2641 "view.c"
									SudokuCell* _tmp31_;
#line 387 "../src/view.vala"
									_tmp31_ = cell_tmp;
#line 387 "../src/view.vala"
									sudoku_cell_set_earmark_highlight (_tmp31_, val, enabled);
#line 2647 "view.c"
								}
							}
#line 377 "../src/view.vala"
							_g_object_unref0 (cell_tmp);
#line 2652 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_set_unselected_value_highlighter (SudokuView* self,
                                              gint row,
                                              gint col,
                                              gint val,
                                              gboolean enabled)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuCell* _tmp4_;
	SudokuCell* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	SudokuCell* changed_cell = NULL;
	SudokuCell** _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	SudokuCell* _tmp9_;
	SudokuCell* _tmp10_;
	SudokuCell* _tmp11_;
#line 392 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 394 "../src/view.vala"
	_tmp2_ = sudoku_view_get_highlighter (self);
#line 394 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 394 "../src/view.vala"
	if (!_tmp3_) {
#line 394 "../src/view.vala"
		_tmp1_ = TRUE;
#line 2693 "view.c"
	} else {
#line 394 "../src/view.vala"
		_tmp1_ = val == 0;
#line 2697 "view.c"
	}
#line 394 "../src/view.vala"
	if (_tmp1_) {
#line 394 "../src/view.vala"
		_tmp0_ = TRUE;
#line 2703 "view.c"
	} else {
#line 394 "../src/view.vala"
		_tmp0_ = !self->highlight_numbers;
#line 2707 "view.c"
	}
#line 394 "../src/view.vala"
	if (_tmp0_) {
#line 395 "../src/view.vala"
		return;
#line 2713 "view.c"
	}
#line 397 "../src/view.vala"
	_tmp4_ = sudoku_view_get_selected_cell (self);
#line 397 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 397 "../src/view.vala"
	_tmp6_ = sudoku_cell_get_value (_tmp5_);
#line 397 "../src/view.vala"
	_tmp7_ = _tmp6_;
#line 397 "../src/view.vala"
	if (val != _tmp7_) {
#line 398 "../src/view.vala"
		return;
#line 2727 "view.c"
	}
#line 400 "../src/view.vala"
	_tmp8_ = self->priv->cells;
#line 400 "../src/view.vala"
	_tmp8__length1 = self->priv->cells_length1;
#line 400 "../src/view.vala"
	_tmp8__length2 = self->priv->cells_length2;
#line 400 "../src/view.vala"
	_tmp9_ = _tmp8_[(row * _tmp8__length2) + col];
#line 400 "../src/view.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 400 "../src/view.vala"
	changed_cell = _tmp10_;
#line 401 "../src/view.vala"
	_tmp11_ = changed_cell;
#line 401 "../src/view.vala"
	sudoku_cell_set_highlight_number (_tmp11_, enabled);
#line 392 "../src/view.vala"
	_g_object_unref0 (changed_cell);
#line 2747 "view.c"
}

void
sudoku_view_update_zoom (SudokuView* self,
                         ZoomLevel level)
{
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 404 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 406 "../src/view.vala"
	self->zoom_level = level;
#line 407 "../src/view.vala"
	switch (level) {
#line 407 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 2765 "view.c"
		{
#line 410 "../src/view.vala"
			self->value_zoom_multiplier = 0.4;
#line 411 "../src/view.vala"
			break;
#line 2771 "view.c"
		}
#line 407 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 2775 "view.c"
		{
#line 413 "../src/view.vala"
			self->value_zoom_multiplier = 0.5;
#line 414 "../src/view.vala"
			break;
#line 2781 "view.c"
		}
#line 407 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 2785 "view.c"
		{
#line 416 "../src/view.vala"
			self->value_zoom_multiplier = 0.6;
#line 417 "../src/view.vala"
			break;
#line 2791 "view.c"
		}
		default:
#line 407 "../src/view.vala"
		break;
#line 2796 "view.c"
	}
#line 419 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 419 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 419 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 2804 "view.c"
	{
		SudokuCell** cell_collection = NULL;
		gint cell_collection_length1 = 0;
		gint cell_collection_length2 = 0;
		gint cell_it = 0;
#line 419 "../src/view.vala"
		cell_collection = _tmp0_;
#line 419 "../src/view.vala"
		cell_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 419 "../src/view.vala"
		for (cell_it = 0; cell_it < cell_collection_length1; cell_it = cell_it + 1) {
#line 2816 "view.c"
			SudokuCell* _tmp1_;
			SudokuCell* cell = NULL;
#line 419 "../src/view.vala"
			_tmp1_ = _g_object_ref0 (cell_collection[cell_it]);
#line 419 "../src/view.vala"
			cell = _tmp1_;
#line 2823 "view.c"
			{
				SudokuCell* _tmp2_;
#line 420 "../src/view.vala"
				_tmp2_ = cell;
#line 420 "../src/view.vala"
				gtk_widget_queue_allocate ((GtkWidget*) _tmp2_);
#line 419 "../src/view.vala"
				_g_object_unref0 (cell);
#line 2832 "view.c"
			}
		}
	}
}

static void
sudoku_view_update_warnings (SudokuView* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 423 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 425 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 425 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 425 "../src/view.vala"
	if (!_tmp1_) {
#line 426 "../src/view.vala"
		return;
#line 2853 "view.c"
	}
	{
		gint col = 0;
#line 428 "../src/view.vala"
		col = 0;
#line 2859 "view.c"
		{
			gboolean _tmp2_ = FALSE;
#line 428 "../src/view.vala"
			_tmp2_ = TRUE;
#line 428 "../src/view.vala"
			while (TRUE) {
#line 2866 "view.c"
				SudokuGame* _tmp4_;
				SudokuBoard* _tmp5_;
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 428 "../src/view.vala"
				if (!_tmp2_) {
#line 2874 "view.c"
					gint _tmp3_;
#line 428 "../src/view.vala"
					_tmp3_ = col;
#line 428 "../src/view.vala"
					col = _tmp3_ + 1;
#line 2880 "view.c"
				}
#line 428 "../src/view.vala"
				_tmp2_ = FALSE;
#line 428 "../src/view.vala"
				_tmp4_ = self->priv->game;
#line 428 "../src/view.vala"
				_tmp5_ = sudoku_game_get_board (_tmp4_);
#line 428 "../src/view.vala"
				_tmp6_ = _tmp5_;
#line 428 "../src/view.vala"
				_tmp7_ = sudoku_board_get_cols (_tmp6_);
#line 428 "../src/view.vala"
				_tmp8_ = _tmp7_;
#line 428 "../src/view.vala"
				if (!(col < _tmp8_)) {
#line 428 "../src/view.vala"
					break;
#line 2898 "view.c"
				}
				{
					gint row = 0;
#line 429 "../src/view.vala"
					row = 0;
#line 2904 "view.c"
					{
						gboolean _tmp9_ = FALSE;
#line 429 "../src/view.vala"
						_tmp9_ = TRUE;
#line 429 "../src/view.vala"
						while (TRUE) {
#line 2911 "view.c"
							SudokuGame* _tmp11_;
							SudokuBoard* _tmp12_;
							SudokuBoard* _tmp13_;
							gint _tmp14_;
							gint _tmp15_;
							SudokuCell** _tmp16_;
							gint _tmp16__length1;
							gint _tmp16__length2;
							SudokuCell* _tmp17_;
							SudokuCell** _tmp18_;
							gint _tmp18__length1;
							gint _tmp18__length2;
							SudokuCell* _tmp19_;
#line 429 "../src/view.vala"
							if (!_tmp9_) {
#line 2927 "view.c"
								gint _tmp10_;
#line 429 "../src/view.vala"
								_tmp10_ = row;
#line 429 "../src/view.vala"
								row = _tmp10_ + 1;
#line 2933 "view.c"
							}
#line 429 "../src/view.vala"
							_tmp9_ = FALSE;
#line 429 "../src/view.vala"
							_tmp11_ = self->priv->game;
#line 429 "../src/view.vala"
							_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 429 "../src/view.vala"
							_tmp13_ = _tmp12_;
#line 429 "../src/view.vala"
							_tmp14_ = sudoku_board_get_rows (_tmp13_);
#line 429 "../src/view.vala"
							_tmp15_ = _tmp14_;
#line 429 "../src/view.vala"
							if (!(row < _tmp15_)) {
#line 429 "../src/view.vala"
								break;
#line 2951 "view.c"
							}
#line 431 "../src/view.vala"
							_tmp16_ = self->priv->cells;
#line 431 "../src/view.vala"
							_tmp16__length1 = self->priv->cells_length1;
#line 431 "../src/view.vala"
							_tmp16__length2 = self->priv->cells_length2;
#line 431 "../src/view.vala"
							_tmp17_ = _tmp16_[(row * _tmp16__length2) + col];
#line 431 "../src/view.vala"
							sudoku_cell_check_value_warnings (_tmp17_);
#line 432 "../src/view.vala"
							_tmp18_ = self->priv->cells;
#line 432 "../src/view.vala"
							_tmp18__length1 = self->priv->cells_length1;
#line 432 "../src/view.vala"
							_tmp18__length2 = self->priv->cells_length2;
#line 432 "../src/view.vala"
							_tmp19_ = _tmp18_[(row * _tmp18__length2) + col];
#line 432 "../src/view.vala"
							sudoku_cell_check_earmarks_warnings (_tmp19_);
#line 2973 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_clear_all_warnings (SudokuView* self)
{
#line 436 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 2987 "view.c"
	{
		gint col_tmp = 0;
#line 438 "../src/view.vala"
		col_tmp = 0;
#line 2992 "view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 438 "../src/view.vala"
			_tmp0_ = TRUE;
#line 438 "../src/view.vala"
			while (TRUE) {
#line 2999 "view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 438 "../src/view.vala"
				if (!_tmp0_) {
#line 3007 "view.c"
					gint _tmp1_;
#line 438 "../src/view.vala"
					_tmp1_ = col_tmp;
#line 438 "../src/view.vala"
					col_tmp = _tmp1_ + 1;
#line 3013 "view.c"
				}
#line 438 "../src/view.vala"
				_tmp0_ = FALSE;
#line 438 "../src/view.vala"
				_tmp2_ = self->priv->game;
#line 438 "../src/view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 438 "../src/view.vala"
				_tmp4_ = _tmp3_;
#line 438 "../src/view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 438 "../src/view.vala"
				_tmp6_ = _tmp5_;
#line 438 "../src/view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 438 "../src/view.vala"
					break;
#line 3031 "view.c"
				}
				{
					gint row_tmp = 0;
#line 439 "../src/view.vala"
					row_tmp = 0;
#line 3037 "view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 439 "../src/view.vala"
						_tmp7_ = TRUE;
#line 439 "../src/view.vala"
						while (TRUE) {
#line 3044 "view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 439 "../src/view.vala"
							if (!_tmp7_) {
#line 3056 "view.c"
								gint _tmp8_;
#line 439 "../src/view.vala"
								_tmp8_ = row_tmp;
#line 439 "../src/view.vala"
								row_tmp = _tmp8_ + 1;
#line 3062 "view.c"
							}
#line 439 "../src/view.vala"
							_tmp7_ = FALSE;
#line 439 "../src/view.vala"
							_tmp9_ = self->priv->game;
#line 439 "../src/view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 439 "../src/view.vala"
							_tmp11_ = _tmp10_;
#line 439 "../src/view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 439 "../src/view.vala"
							_tmp13_ = _tmp12_;
#line 439 "../src/view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 439 "../src/view.vala"
								break;
#line 3080 "view.c"
							}
#line 440 "../src/view.vala"
							_tmp14_ = self->priv->cells;
#line 440 "../src/view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 440 "../src/view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 440 "../src/view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 440 "../src/view.vala"
							sudoku_cell_clear_warnings (_tmp15_);
#line 3092 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_mask_view (SudokuView* self)
{
#line 443 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 3106 "view.c"
	{
		gint col_tmp = 0;
#line 445 "../src/view.vala"
		col_tmp = 0;
#line 3111 "view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 445 "../src/view.vala"
			_tmp0_ = TRUE;
#line 445 "../src/view.vala"
			while (TRUE) {
#line 3118 "view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 445 "../src/view.vala"
				if (!_tmp0_) {
#line 3126 "view.c"
					gint _tmp1_;
#line 445 "../src/view.vala"
					_tmp1_ = col_tmp;
#line 445 "../src/view.vala"
					col_tmp = _tmp1_ + 1;
#line 3132 "view.c"
				}
#line 445 "../src/view.vala"
				_tmp0_ = FALSE;
#line 445 "../src/view.vala"
				_tmp2_ = self->priv->game;
#line 445 "../src/view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 445 "../src/view.vala"
				_tmp4_ = _tmp3_;
#line 445 "../src/view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 445 "../src/view.vala"
				_tmp6_ = _tmp5_;
#line 445 "../src/view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 445 "../src/view.vala"
					break;
#line 3150 "view.c"
				}
				{
					gint row_tmp = 0;
#line 446 "../src/view.vala"
					row_tmp = 0;
#line 3156 "view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 446 "../src/view.vala"
						_tmp7_ = TRUE;
#line 446 "../src/view.vala"
						while (TRUE) {
#line 3163 "view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 446 "../src/view.vala"
							if (!_tmp7_) {
#line 3175 "view.c"
								gint _tmp8_;
#line 446 "../src/view.vala"
								_tmp8_ = row_tmp;
#line 446 "../src/view.vala"
								row_tmp = _tmp8_ + 1;
#line 3181 "view.c"
							}
#line 446 "../src/view.vala"
							_tmp7_ = FALSE;
#line 446 "../src/view.vala"
							_tmp9_ = self->priv->game;
#line 446 "../src/view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 446 "../src/view.vala"
							_tmp11_ = _tmp10_;
#line 446 "../src/view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 446 "../src/view.vala"
							_tmp13_ = _tmp12_;
#line 446 "../src/view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 446 "../src/view.vala"
								break;
#line 3199 "view.c"
							}
#line 447 "../src/view.vala"
							_tmp14_ = self->priv->cells;
#line 447 "../src/view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 447 "../src/view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 447 "../src/view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 447 "../src/view.vala"
							sudoku_cell_set_paused (_tmp15_, TRUE);
#line 3211 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_unmask_view (SudokuView* self)
{
#line 450 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 3225 "view.c"
	{
		gint col_tmp = 0;
#line 452 "../src/view.vala"
		col_tmp = 0;
#line 3230 "view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 452 "../src/view.vala"
			_tmp0_ = TRUE;
#line 452 "../src/view.vala"
			while (TRUE) {
#line 3237 "view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				SudokuBoard* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
#line 452 "../src/view.vala"
				if (!_tmp0_) {
#line 3245 "view.c"
					gint _tmp1_;
#line 452 "../src/view.vala"
					_tmp1_ = col_tmp;
#line 452 "../src/view.vala"
					col_tmp = _tmp1_ + 1;
#line 3251 "view.c"
				}
#line 452 "../src/view.vala"
				_tmp0_ = FALSE;
#line 452 "../src/view.vala"
				_tmp2_ = self->priv->game;
#line 452 "../src/view.vala"
				_tmp3_ = sudoku_game_get_board (_tmp2_);
#line 452 "../src/view.vala"
				_tmp4_ = _tmp3_;
#line 452 "../src/view.vala"
				_tmp5_ = sudoku_board_get_cols (_tmp4_);
#line 452 "../src/view.vala"
				_tmp6_ = _tmp5_;
#line 452 "../src/view.vala"
				if (!(col_tmp < _tmp6_)) {
#line 452 "../src/view.vala"
					break;
#line 3269 "view.c"
				}
				{
					gint row_tmp = 0;
#line 453 "../src/view.vala"
					row_tmp = 0;
#line 3275 "view.c"
					{
						gboolean _tmp7_ = FALSE;
#line 453 "../src/view.vala"
						_tmp7_ = TRUE;
#line 453 "../src/view.vala"
						while (TRUE) {
#line 3282 "view.c"
							SudokuGame* _tmp9_;
							SudokuBoard* _tmp10_;
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							SudokuCell** _tmp14_;
							gint _tmp14__length1;
							gint _tmp14__length2;
							SudokuCell* _tmp15_;
#line 453 "../src/view.vala"
							if (!_tmp7_) {
#line 3294 "view.c"
								gint _tmp8_;
#line 453 "../src/view.vala"
								_tmp8_ = row_tmp;
#line 453 "../src/view.vala"
								row_tmp = _tmp8_ + 1;
#line 3300 "view.c"
							}
#line 453 "../src/view.vala"
							_tmp7_ = FALSE;
#line 453 "../src/view.vala"
							_tmp9_ = self->priv->game;
#line 453 "../src/view.vala"
							_tmp10_ = sudoku_game_get_board (_tmp9_);
#line 453 "../src/view.vala"
							_tmp11_ = _tmp10_;
#line 453 "../src/view.vala"
							_tmp12_ = sudoku_board_get_rows (_tmp11_);
#line 453 "../src/view.vala"
							_tmp13_ = _tmp12_;
#line 453 "../src/view.vala"
							if (!(row_tmp < _tmp13_)) {
#line 453 "../src/view.vala"
								break;
#line 3318 "view.c"
							}
#line 454 "../src/view.vala"
							_tmp14_ = self->priv->cells;
#line 454 "../src/view.vala"
							_tmp14__length1 = self->priv->cells_length1;
#line 454 "../src/view.vala"
							_tmp14__length2 = self->priv->cells_length2;
#line 454 "../src/view.vala"
							_tmp15_ = _tmp14_[(row_tmp * _tmp14__length2) + col_tmp];
#line 454 "../src/view.vala"
							sudoku_cell_set_paused (_tmp15_, FALSE);
#line 3330 "view.c"
						}
					}
				}
			}
		}
	}
}

static void
sudoku_view_insert_key (SudokuView* self,
                        gint key,
                        GdkModifierType state)
{
	SudokuNumberPicker* _tmp0_;
	gboolean wants_value = FALSE;
#line 533 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 535 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 535 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 536 "../src/view.vala"
	wants_value = state != GDK_CONTROL_MASK;
#line 537 "../src/view.vala"
	wants_value = wants_value ^ self->earmark_mode;
#line 539 "../src/view.vala"
	if (wants_value) {
#line 3358 "view.c"
		SudokuCell* _tmp1_;
		SudokuCell* _tmp2_;
#line 541 "../src/view.vala"
		_tmp1_ = sudoku_view_get_selected_cell (self);
#line 541 "../src/view.vala"
		_tmp2_ = _tmp1_;
#line 541 "../src/view.vala"
		sudoku_cell_set_value (_tmp2_, key);
#line 3367 "view.c"
	} else {
		gboolean _tmp3_ = FALSE;
		SudokuGame* _tmp4_;
		GameMode _tmp5_;
		GameMode _tmp6_;
#line 543 "../src/view.vala"
		_tmp4_ = self->priv->game;
#line 543 "../src/view.vala"
		_tmp5_ = sudoku_game_get_mode (_tmp4_);
#line 543 "../src/view.vala"
		_tmp6_ = _tmp5_;
#line 543 "../src/view.vala"
		if (_tmp6_ == GAME_MODE_PLAY) {
#line 3381 "view.c"
			SudokuCell* _tmp7_;
			SudokuCell* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 543 "../src/view.vala"
			_tmp7_ = sudoku_view_get_selected_cell (self);
#line 543 "../src/view.vala"
			_tmp8_ = _tmp7_;
#line 543 "../src/view.vala"
			_tmp9_ = sudoku_cell_get_value (_tmp8_);
#line 543 "../src/view.vala"
			_tmp10_ = _tmp9_;
#line 543 "../src/view.vala"
			_tmp3_ = _tmp10_ == 0;
#line 3396 "view.c"
		} else {
#line 543 "../src/view.vala"
			_tmp3_ = FALSE;
#line 3400 "view.c"
		}
#line 543 "../src/view.vala"
		if (_tmp3_) {
#line 3404 "view.c"
			gboolean enabled = FALSE;
			SudokuGame* _tmp11_;
			SudokuBoard* _tmp12_;
			SudokuBoard* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
#line 545 "../src/view.vala"
			_tmp11_ = self->priv->game;
#line 545 "../src/view.vala"
			_tmp12_ = sudoku_game_get_board (_tmp11_);
#line 545 "../src/view.vala"
			_tmp13_ = _tmp12_;
#line 545 "../src/view.vala"
			_tmp14_ = self->priv->_selected_row;
#line 545 "../src/view.vala"
			_tmp15_ = self->priv->_selected_col;
#line 545 "../src/view.vala"
			enabled = sudoku_board_is_earmark_enabled (_tmp13_, _tmp14_, _tmp15_, key);
#line 546 "../src/view.vala"
			if (!enabled) {
#line 3425 "view.c"
				SudokuGame* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 547 "../src/view.vala"
				_tmp16_ = self->priv->game;
#line 547 "../src/view.vala"
				_tmp17_ = self->priv->_selected_row;
#line 547 "../src/view.vala"
				_tmp18_ = self->priv->_selected_col;
#line 547 "../src/view.vala"
				sudoku_game_enable_earmark (_tmp16_, _tmp17_, _tmp18_, key);
#line 3437 "view.c"
			} else {
				SudokuGame* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 549 "../src/view.vala"
				_tmp19_ = self->priv->game;
#line 549 "../src/view.vala"
				_tmp20_ = self->priv->_selected_row;
#line 549 "../src/view.vala"
				_tmp21_ = self->priv->_selected_col;
#line 549 "../src/view.vala"
				sudoku_game_disable_earmark (_tmp19_, _tmp20_, _tmp21_, key);
#line 3450 "view.c"
			}
		}
	}
}

void
sudoku_view_dismiss_picker (SudokuView* self)
{
	SudokuNumberPicker* _tmp0_;
#line 553 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 555 "../src/view.vala"
	_tmp0_ = self->number_picker;
#line 555 "../src/view.vala"
	gtk_popover_popdown ((GtkPopover*) _tmp0_);
#line 3466 "view.c"
}

static void
sudoku_view_real_dispose (GObject* base)
{
	SudokuView * self;
	SudokuFrame* _tmp0_;
	SudokuNumberPicker* _tmp1_;
#line 558 "../src/view.vala"
	self = (SudokuView*) base;
#line 560 "../src/view.vala"
	_tmp0_ = self->priv->frame;
#line 560 "../src/view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 561 "../src/view.vala"
	_tmp1_ = self->number_picker;
#line 561 "../src/view.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp1_);
#line 562 "../src/view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, adw_bin_get_type (), AdwBin));
#line 3487 "view.c"
}

gint
sudoku_view_get_selected_row (SudokuView* self)
{
	gint result;
#line 46 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/view.vala"
	result = self->priv->_selected_row;
#line 46 "../src/view.vala"
	return result;
#line 3500 "view.c"
}

static void
sudoku_view_set_selected_row (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 46 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/view.vala"
	old_value = sudoku_view_get_selected_row (self);
#line 46 "../src/view.vala"
	if (old_value != value) {
#line 46 "../src/view.vala"
		self->priv->_selected_row = value;
#line 46 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY]);
#line 3518 "view.c"
	}
}

gint
sudoku_view_get_selected_col (SudokuView* self)
{
	gint result;
#line 47 "../src/view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 47 "../src/view.vala"
	result = self->priv->_selected_col;
#line 47 "../src/view.vala"
	return result;
#line 3532 "view.c"
}

static void
sudoku_view_set_selected_col (SudokuView* self,
                              gint value)
{
	gint old_value;
#line 47 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/view.vala"
	old_value = sudoku_view_get_selected_col (self);
#line 47 "../src/view.vala"
	if (old_value != value) {
#line 47 "../src/view.vala"
		self->priv->_selected_col = value;
#line 47 "../src/view.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY]);
#line 3550 "view.c"
	}
}

static SudokuCell*
sudoku_view_get_selected_cell (SudokuView* self)
{
	SudokuCell* result;
	SudokuCell** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint _tmp2_;
	SudokuCell* _tmp3_;
#line 51 "../src/view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 51 "../src/view.vala"
	_tmp0_ = self->priv->cells;
#line 51 "../src/view.vala"
	_tmp0__length1 = self->priv->cells_length1;
#line 51 "../src/view.vala"
	_tmp0__length2 = self->priv->cells_length2;
#line 51 "../src/view.vala"
	_tmp1_ = self->priv->_selected_row;
#line 51 "../src/view.vala"
	_tmp2_ = self->priv->_selected_col;
#line 51 "../src/view.vala"
	_tmp3_ = _tmp0_[(_tmp1_ * _tmp0__length2) + _tmp2_];
#line 51 "../src/view.vala"
	result = _tmp3_;
#line 51 "../src/view.vala"
	return result;
#line 3582 "view.c"
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 460 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 460 "../src/view.vala"
	result = self->priv->_show_warnings;
#line 460 "../src/view.vala"
	return result;
#line 3595 "view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 461 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 462 "../src/view.vala"
	self->priv->_show_warnings = value;
#line 464 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 464 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 464 "../src/view.vala"
	if (_tmp1_) {
#line 465 "../src/view.vala"
		sudoku_view_update_warnings (self);
#line 3618 "view.c"
	} else {
#line 467 "../src/view.vala"
		sudoku_view_clear_all_warnings (self);
#line 3622 "view.c"
	}
#line 469 "../src/view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 469 "../src/view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 469 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 461 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 3632 "view.c"
}

gboolean
sudoku_view_get_show_earmark_warnings (SudokuView* self)
{
	gboolean result;
#line 476 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 476 "../src/view.vala"
	result = self->priv->_show_earmark_warnings;
#line 476 "../src/view.vala"
	return result;
#line 3645 "view.c"
}

void
sudoku_view_set_show_earmark_warnings (SudokuView* self,
                                       gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 477 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/view.vala"
	self->priv->_show_earmark_warnings = value;
#line 479 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 479 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 479 "../src/view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 477 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY]);
#line 3666 "view.c"
}

gboolean
sudoku_view_get_solution_warnings (SudokuView* self)
{
	gboolean result;
#line 486 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 486 "../src/view.vala"
	result = self->priv->_solution_warnings;
#line 486 "../src/view.vala"
	return result;
#line 3679 "view.c"
}

void
sudoku_view_set_solution_warnings (SudokuView* self,
                                   gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 487 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 488 "../src/view.vala"
	self->priv->_solution_warnings = value;
#line 489 "../src/view.vala"
	_tmp0_ = sudoku_view_get_show_warnings (self);
#line 489 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 489 "../src/view.vala"
	sudoku_view_set_show_warnings (self, _tmp1_);
#line 487 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY]);
#line 3700 "view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 496 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 496 "../src/view.vala"
	result = self->priv->_show_possibilities;
#line 496 "../src/view.vala"
	return result;
#line 3713 "view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 497 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 498 "../src/view.vala"
	self->priv->_show_possibilities = value;
#line 499 "../src/view.vala"
	_tmp1_ = sudoku_view_get_show_possibilities (self);
#line 499 "../src/view.vala"
	_tmp2_ = _tmp1_;
#line 499 "../src/view.vala"
	if (_tmp2_) {
#line 3733 "view.c"
		SudokuGame* _tmp3_;
		GameMode _tmp4_;
		GameMode _tmp5_;
#line 499 "../src/view.vala"
		_tmp3_ = self->priv->game;
#line 499 "../src/view.vala"
		_tmp4_ = sudoku_game_get_mode (_tmp3_);
#line 499 "../src/view.vala"
		_tmp5_ = _tmp4_;
#line 499 "../src/view.vala"
		_tmp0_ = _tmp5_ != GAME_MODE_CREATE;
#line 3745 "view.c"
	} else {
#line 499 "../src/view.vala"
		_tmp0_ = FALSE;
#line 3749 "view.c"
	}
#line 499 "../src/view.vala"
	if (_tmp0_) {
#line 3753 "view.c"
		SudokuGame* _tmp6_;
#line 500 "../src/view.vala"
		_tmp6_ = self->priv->game;
#line 500 "../src/view.vala"
		sudoku_game_enable_all_earmark_possibilities (_tmp6_);
#line 3759 "view.c"
	} else {
		SudokuGame* _tmp7_;
#line 501 "../src/view.vala"
		_tmp7_ = self->priv->game;
#line 501 "../src/view.vala"
		if (sudoku_game_get_current_stack_action (_tmp7_) == STACK_ACTION_ENABLE_ALL_EARMARK_POSSIBILITIES) {
#line 3766 "view.c"
			SudokuGame* _tmp8_;
#line 502 "../src/view.vala"
			_tmp8_ = self->priv->game;
#line 502 "../src/view.vala"
			sudoku_game_undo (_tmp8_);
#line 3772 "view.c"
		}
	}
#line 497 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 3777 "view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 509 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 509 "../src/view.vala"
	result = self->priv->_highlighter;
#line 509 "../src/view.vala"
	return result;
#line 3790 "view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 510 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 511 "../src/view.vala"
	_tmp0_ = self->priv->_selected_row;
#line 511 "../src/view.vala"
	_tmp1_ = self->priv->_selected_col;
#line 511 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp0_, _tmp1_, FALSE);
#line 512 "../src/view.vala"
	self->priv->_highlighter = value;
#line 513 "../src/view.vala"
	_tmp2_ = self->priv->_selected_row;
#line 513 "../src/view.vala"
	_tmp3_ = self->priv->_selected_col;
#line 513 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp2_, _tmp3_, TRUE);
#line 510 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 3819 "view.c"
}

gboolean
sudoku_view_get_has_selection (SudokuView* self)
{
	gboolean result;
#line 520 "../src/view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 520 "../src/view.vala"
	result = self->priv->_has_selection;
#line 520 "../src/view.vala"
	return result;
#line 3832 "view.c"
}

void
sudoku_view_set_has_selection (SudokuView* self,
                               gboolean value)
{
	SudokuCell* _tmp0_;
	SudokuCell* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 521 "../src/view.vala"
	g_return_if_fail (self != NULL);
#line 522 "../src/view.vala"
	self->priv->_has_selection = value;
#line 523 "../src/view.vala"
	_tmp0_ = sudoku_view_get_selected_cell (self);
#line 523 "../src/view.vala"
	_tmp1_ = _tmp0_;
#line 523 "../src/view.vala"
	_tmp2_ = sudoku_view_get_has_selection (self);
#line 523 "../src/view.vala"
	_tmp3_ = _tmp2_;
#line 523 "../src/view.vala"
	sudoku_cell_set_selected (_tmp1_, _tmp3_);
#line 524 "../src/view.vala"
	_tmp4_ = sudoku_view_get_has_selection (self);
#line 524 "../src/view.vala"
	_tmp5_ = _tmp4_;
#line 524 "../src/view.vala"
	if (_tmp5_) {
#line 3869 "view.c"
		SudokuCell* _tmp6_;
		SudokuCell* _tmp7_;
#line 525 "../src/view.vala"
		_tmp6_ = sudoku_view_get_selected_cell (self);
#line 525 "../src/view.vala"
		_tmp7_ = _tmp6_;
#line 525 "../src/view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp7_);
#line 3878 "view.c"
	} else {
		SudokuNumberPicker* _tmp8_;
#line 527 "../src/view.vala"
		_tmp8_ = self->number_picker;
#line 527 "../src/view.vala"
		gtk_popover_popdown ((GtkPopover*) _tmp8_);
#line 3885 "view.c"
	}
#line 529 "../src/view.vala"
	_tmp9_ = self->priv->_selected_row;
#line 529 "../src/view.vala"
	_tmp10_ = self->priv->_selected_col;
#line 529 "../src/view.vala"
	_tmp11_ = sudoku_view_get_has_selection (self);
#line 529 "../src/view.vala"
	_tmp12_ = _tmp11_;
#line 529 "../src/view.vala"
	sudoku_view_set_cell_highlighter (self, _tmp9_, _tmp10_, _tmp12_);
#line 521 "../src/view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY]);
#line 3899 "view.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/view.vala"
	g_return_if_fail (n_param_values == 5);
#line 26 "../src/view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/view.vala"
		data1 = closure->data;
#line 26 "../src/view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3924 "view.c"
	} else {
#line 26 "../src/view.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/view.vala"
		data2 = closure->data;
#line 3930 "view.c"
	}
#line 26 "../src/view.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/view.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 3936 "view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
#line 26 "../src/view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/view.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_view_real_dispose;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_ROW_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_ROW_PROPERTY] = g_param_spec_int ("selected-row", "selected-row", "selected-row", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SELECTED_COL_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SELECTED_COL_PROPERTY] = g_param_spec_int ("selected-col", "selected-col", "selected-col", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-earmark-warnings", "show-earmark-warnings", "show-earmark-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY] = g_param_spec_boolean ("solution-warnings", "solution-warnings", "solution-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HAS_SELECTION_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HAS_SELECTION_PROPERTY] = g_param_spec_boolean ("has-selection", "has-selection", "has-selection", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/view.vala"
	sudoku_view_signals[SUDOKU_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", TYPE_SUDOKU_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 3973 "view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 35 "../src/view.vala"
	self->earmark_mode = FALSE;
#line 46 "../src/view.vala"
	self->priv->_selected_row = 0;
#line 47 "../src/view.vala"
	self->priv->_selected_col = 0;
#line 517 "../src/view.vala"
	self->priv->_has_selection = TRUE;
#line 3990 "view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/view.vala"
	_g_object_unref0 (self->priv->settings);
#line 29 "../src/view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 30 "../src/view.vala"
	_g_object_unref0 (self->priv->game);
#line 31 "../src/view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 32 "../src/view.vala"
	_g_object_unref0 (self->priv->frame);
#line 33 "../src/view.vala"
	_g_object_unref0 (self->priv->paused_label);
#line 44 "../src/view.vala"
	_g_object_unref0 (self->number_picker);
#line 26 "../src/view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 4015 "view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/view.vala"
	switch (property_id) {
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_int (value, sudoku_view_get_selected_row (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_int (value, sudoku_view_get_selected_col (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_earmark_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_solution_warnings (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/view.vala"
		g_value_set_boolean (value, sudoku_view_get_has_selection (self));
#line 26 "../src/view.vala"
		break;
#line 4098 "view.c"
		default:
#line 26 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/view.vala"
		break;
#line 4104 "view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/view.vala"
	switch (property_id) {
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_ROW_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_selected_row (self, g_value_get_int (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SELECTED_COL_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_selected_col (self, g_value_get_int (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_EARMARK_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_earmark_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SOLUTION_WARNINGS_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_solution_warnings (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 26 "../src/view.vala"
		case SUDOKU_VIEW_HAS_SELECTION_PROPERTY:
#line 26 "../src/view.vala"
		sudoku_view_set_has_selection (self, g_value_get_boolean (value));
#line 26 "../src/view.vala"
		break;
#line 4166 "view.c"
		default:
#line 26 "../src/view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/view.vala"
		break;
#line 4172 "view.c"
	}
}

gboolean
zoom_level_is_fully_zoomed_out (ZoomLevel self)
{
	gboolean result;
#line 574 "../src/view.vala"
	switch (self) {
#line 574 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4184 "view.c"
		{
#line 577 "../src/view.vala"
			result = TRUE;
#line 577 "../src/view.vala"
			return result;
#line 4190 "view.c"
		}
		default:
		{
#line 579 "../src/view.vala"
			result = FALSE;
#line 579 "../src/view.vala"
			return result;
#line 4198 "view.c"
		}
	}
}

gboolean
zoom_level_is_fully_zoomed_in (ZoomLevel self)
{
	gboolean result;
#line 585 "../src/view.vala"
	switch (self) {
#line 585 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4211 "view.c"
		{
#line 588 "../src/view.vala"
			result = TRUE;
#line 588 "../src/view.vala"
			return result;
#line 4217 "view.c"
		}
		default:
		{
#line 590 "../src/view.vala"
			result = FALSE;
#line 590 "../src/view.vala"
			return result;
#line 4225 "view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_in (ZoomLevel self)
{
	ZoomLevel result;
#line 596 "../src/view.vala"
	switch (self) {
#line 596 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4238 "view.c"
		{
#line 599 "../src/view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 599 "../src/view.vala"
			return result;
#line 4244 "view.c"
		}
#line 596 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4248 "view.c"
		{
#line 601 "../src/view.vala"
			result = ZOOM_LEVEL_LARGE;
#line 601 "../src/view.vala"
			return result;
#line 4254 "view.c"
		}
#line 596 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4258 "view.c"
		{
			{
#line 604 "../src/view.vala"
				g_warning ("view.vala:604: ZOOM already at maximum");
#line 605 "../src/view.vala"
				result = ZOOM_LEVEL_LARGE;
#line 605 "../src/view.vala"
				return result;
#line 4267 "view.c"
			}
		}
		default:
		{
#line 608 "../src/view.vala"
			g_assert_not_reached ();
#line 4274 "view.c"
		}
	}
}

ZoomLevel
zoom_level_zoom_out (ZoomLevel self)
{
	ZoomLevel result;
#line 614 "../src/view.vala"
	switch (self) {
#line 614 "../src/view.vala"
		case ZOOM_LEVEL_LARGE:
#line 4287 "view.c"
		{
#line 617 "../src/view.vala"
			result = ZOOM_LEVEL_MEDIUM;
#line 617 "../src/view.vala"
			return result;
#line 4293 "view.c"
		}
#line 614 "../src/view.vala"
		case ZOOM_LEVEL_MEDIUM:
#line 4297 "view.c"
		{
#line 619 "../src/view.vala"
			result = ZOOM_LEVEL_SMALL;
#line 619 "../src/view.vala"
			return result;
#line 4303 "view.c"
		}
#line 614 "../src/view.vala"
		case ZOOM_LEVEL_SMALL:
#line 4307 "view.c"
		{
			{
#line 622 "../src/view.vala"
				g_warning ("view.vala:622: ZOOM already at minimum");
#line 623 "../src/view.vala"
				result = ZOOM_LEVEL_SMALL;
#line 623 "../src/view.vala"
				return result;
#line 4316 "view.c"
			}
		}
		default:
		{
#line 626 "../src/view.vala"
			g_assert_not_reached ();
#line 4323 "view.c"
		}
	}
}

static GType
zoom_level_get_type_once (void)
{
	static const GEnumValue values[] = {{ZOOM_LEVEL_SMALL, "ZOOM_LEVEL_SMALL", "small"}, {ZOOM_LEVEL_MEDIUM, "ZOOM_LEVEL_MEDIUM", "medium"}, {ZOOM_LEVEL_LARGE, "ZOOM_LEVEL_LARGE", "large"}, {0, NULL, NULL}};
	GType zoom_level_type_id;
	zoom_level_type_id = g_enum_register_static ("ZoomLevel", values);
	return zoom_level_type_id;
}

GType
zoom_level_get_type (void)
{
	static volatile gsize zoom_level_type_id__once = 0;
	if (g_once_init_enter (&zoom_level_type_id__once)) {
		GType zoom_level_type_id;
		zoom_level_type_id = zoom_level_get_type_once ();
		g_once_init_leave (&zoom_level_type_id__once, zoom_level_type_id);
	}
	return zoom_level_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

